The following changes were made between 1.8.0-jumbo-1 and 1.8-0-jumbo-2:

magnum (2497):
	inc.c: Instead of sending a "" to crk_process_key(), use a safe static
	  buffer of PLAINTEXT_BUFFER_SIZE. No problem seen here but in other
	  places with similar code.
	Move lastpass format back in tree. See #890
	OpenCL: Support reporting OpenCL 2.0 versions.
	OpenCL: Pass DEV_VER_MAJOR and DEV_VER_MINOR to OpenCL compiler. Eg.
	  for Catalyst 1234.5 they will be 1234 and 5 respectively. For
	  strings like "text 123 text 56" they will be 123 and 56. Closes
	  #909.
	DEScrypt OpenCL: Tweak the selection of "fast" versus "safe" version
	  of the kernel. The selection logic will very likely grow over time.
	OpenCL: If kernel build fails, force outputting build options.
	OpenCL: AMD devices have some weird bug when using pinned buffers.
	  They seem to allocate twice the memory. We need to account for this
	  when finding out limits.
	Speed up some --list stuff with OpenCL formats. See #919.
	Even more speedup for --list stuff with OpenCL formats. See #919.
	Tweak for --list=format-[all-]details and OMP formats. See #919.
	OMP tuning and some other performance fixes. See #877.
	AC: Fix ASAN configuration. Closes #921.
	AC: More fixes to ASAN configuration. #921.
	Fix a problem with --list=format-tests and Unicode formats. Closes
	  #919
	DEScrypt OpenCL: Tweak the selection of "fast" versus "safe" version
	  of the kernel. The __Tahiti__ macro is not all upper case, as I had
	  it. And only nvidia GM204 seem to be faster using the "safe" kernel
	  - Kepler and Fermi wants the other.
	Vectorized OpenCL formats: Correction for max memory use.
	Vectorized OpenCL formats: Correction for max memory use.
	raw-sha256 bug fix. It didn't unify case for all hashes. Closes #925,
	  #926, #927, #928, #931.
	OpenCL: Fix a bad bug with multi-field test vectors. Found by ASAN.
	OpenCL: Auto-tune max. size calc. fix for vectorized formats (RAKP and
	  NTLMv2). See #922
	Office2013 OpenCL: Disable vectorizing on VLIW5 because the register
	  pressure is too high. Discussion in #908.
	AC: Add -D__USE_MINGW_ANSI_STDIO for MinGW.
	Office2013 OpenCL: Allow forcing vectorizing.
	Fix a minor problem in AESNI Makefile.
	RAKP OpenCL: On VLIW5, limit vectorizing to 2x due to GPR pressure.
	  See #908.
	Various OpenCL formats: On VLIW5, limit vectorizing to 2x due to GPR
	  pressure. See #908.
	Oops I committed the define of JTR_RELASE_BUILD into bleeding.
	Makefile: Fix a typo in luks2john's LDFLAGS. See #933
	jumbo.c: Pure whitespace fixes.
	OpenCL: Drop some obsolete code. Fix a lot of formats for using LWS=0
	  (auto tune LWS) or LWS=9999 (set to ceiling instead of forcing auto
	  tune). Also plenty other minor tweaks and fixes.
	Change the $HEX$ loader bodge to use strncmp() instead of strstr(),
	  for performance.
	Drop OCL_CONFIG in favor of FORMAT_LABEL. It will be stripped to it's
	  base and lower-cased, eg. rar-opencl -> rar, so the end result is
	  supposedly the same (or bugs got fixed automagically, which is the
	  very intention with this). Closes #940.
	Drop a couple of old formats from the unused/ directory. That
	  directory is not a permanent graveyard - Git is.
	Drop a couple of old Unicode "original" files from unused. We do not
	  need them - the licensing information is stated in the files we
	  actually use.
	Fix a problem with opencl_cryptsha512_fmt after my recent changes.
	Drop no-op code from Truecrypt. See #941.
	Fix indentation and widescreen comments in memory.c
	raw-sha1-linkedin bodge for loader.c. Closes #924.
	RAKP-opencl, fix a problem with uninitialized index buffer when used
	  with -skip. Closes #947.
	mscash-cuda. Update valid() and prepare() from CPU format. Closes #942
	sha256crypt-cuda. Use shared valid() and binary() functions. Closes
	  #943.
	sha512crypt-cuda. Use shared valid() and binary() functions. Closes
	  #944.
	Revert an incorrect fix in formats.c from faf28f43. You must not call
	  clear_keys() in the middle of a batch of keys!
	Revert an incorrect fix in mssql from faf28f43.
	Put workaround back in RSVP since we reverted the fix in formats.c
	Bugfix for xsha512-cuda found by ASAN.
	Add more test vectors to CUDA formats that only had one.
	Encfs-opencl and sxc-opencl: Add test vectors from CPU format.
	OpenCL keyring format: Add second test vector from CPU format. This
	  immediately made a bad bug show up, which was fixed too.
	Revert "loader: incresed number of parms being loaded from file, for
	  scrypt"
	pwsafe-opencl: Reject uppercase in valid().
	Drop 'test' but keep .gitmodules. Experimental.
	Drop some unused code from Keccak and Blake.
	Fix some header inclusions that should be <brackets> but was "quotes"
	Add an option to configure (--enable-plugin-dependencies) that creates
	  plugin dependencies in Makefile. Highly experimental and
	  best-effort. See #955.
	Add a self-test for salt() ensuring it returns same data for same
	  salt. See #953.
	Base64_convert code: Some off-by-one and buffer cleaning problems
	  fixed. See #953
	Fix some more header inclusions that should be <brackets> but were
	  "quotes".
	Add Makefile dependencies for non-plugins, "best effort".
	Default to enable plugin dependencies generation.
	Add a debug print to formats.c salt dupe check.
	PFX bugfix. We were clearing salt after setting things in it. This
	  does not fix #953 - it appears we really have to use a dynamic salt.
	Change wording of self-test warning for dupe salt detection. There's
	  not really any doubt it's broken.
	OpenCL DES: Use an LWS of 8 for Intel, for good measure (they
	  recommend it in their white papers). Closes #958.
	Revert 53442ed and 123a654. They were never needed. See #958
	Allow environment variable OMP_SCALE to override john.conf setting
	  FormatBlockScaleTuneMultiplier. And clean up code.
	luks2john: Add missing LF in error output.
	Fix bugs in LUKS format. Some optimist had changed things without
	  checking results of it. We were freeing memory that was not
	  alloc'ed, and non-inlined hash handling was terrificly b0rken in
	  valid().
	Add autoconfig-stamp-h.in to .gitignore
	DEScrypt-opencl: Add a kludge for older buggy Intel CPU driver.
	Double entry in .gitignore after mid-air collision. Removed.
	Make base64_convert less Windows-ish by lifting the limit of 50K max.
	  number of lines read from stdin. Fix some bugs while at it. The max
	  line length is now 256K as stated (it was coded as 256M). FWIW our
	  current LINE_BUFFER_SIZE is less at 0x30000.
	base64_convert: Put a line length limit notice back in usage blob.
	Fix edge-case issues with enc_lc() and enc_uc(). The destination size
	  is now buffer size, not string length.
	Fix a good bunch of formats that did not work with the new OMP_SCALE
	  test/devel stuff. See #877.
	Fix some more formats that did not work with the new OMP_SCALE
	  test/devel stuff. Plus some no-ops for unified code. See #877.
	Revert CP737 to what the Unicode database says.
	Manual sync of libclamav unrar code from upstream. This did not fix
	  #1000.
	Fix an ASAN problem in unrar.c where a read ahead buffer could read
	  past end of buffer. Closes #1000.
	Fix a bug in -list=format-details where multi-field ciphertexts were
	  not printed. Also drop some for loops in -list=format-tests in favor
	  of strchr().
	unrar.c, bump over-alloc more for protection against bad data. See
	  #1000 and closes #1001.
	Document how to crack CRAM-MD5 using the HMAC-MD5 format. Closes #999.
	Add salt_compare method and plaintext_min_length param to format
	  struct. Closes 996, closes #997.
	Add --list info for new format struct members. Closes #1004.
	unrar.c: Implement a similar protection for rar_getbits() that Jim did
	  in rarvm_getbits(). Unfortunately this did not help #1008.
	Wordlist mode had no consecutive dupe suppression when running
	  unbuffered and without rules. This reverts 15949eb and fixes it in a
	  better way. Closes #1012.
	Reduce some chatter when -verbosity is decreased.
	If verbosity is increased, report tunable cost even when all hashes
	  have same cost. This was suggested in #816.
	Allow -cost with -test. See #816.
	Clean up cost-with-test code, see #816.
	Cost-with-test: Added printing of costs used in test. Closes #816.
	Cost-with-test: Changed message for costs used in test. See #816.
	Benchmark w/ -cost issues. Closes #816. - Never output cost
	  information w/ --test=0. - Also mute it if verbosity was decreased
	  from default. - Give a better error message when -cost pruned all
	  test vectors. - Fail with a proper notice if a required cost is not
	  defined.
	Import pp.c (as prince.c) from Atom's Princeprocessor and implement a
	  prince mode with it. See #1011.
	Add means for setting PRINCE parameters. Also add logging of them. See
	  #1011.
	PRINCE: Add ETA/progress. See #1011.
	PRINCE: Minor tweaks. See #1011.
	PRINCE: Implement session save/restore. See #1011.
	PRINCE: Minor tweaks. See #1011.
	PRINCE: Fix a problem where we broke out of inner loop but not the
	  outer. See #1014.
	PRINCE: Fix another problem where we broke out of inner loop but not
	  the outer. Closes #1014.
	Fix a potential "ASan problem" in mask mode.
	PRINCE: Always report DONE when everything is cracked. This is not
	  necessarily a good idea (will open another issue) but all other
	  modes do so.
	PRINCE: Support node/fork. See #1011.
	PRINCE: Better node/fork distribution. See #1011.
	PRINCE: Fix resume problem. Closes #1016.
	PRINCE: Cosmetic & performance resume tweaks. See #1016.
	Drop PRINCE from usage blob and other stuff, unless GMP is available.
	PRINCE: Sync pp.c from Atom's repo.
	PRINCE: Add proper GMP cleanup for JtR-specific variables.
	PRINCE: Optionally define PRINCE-specific wordlist in john.conf.
	Autoconf: Add a PRINCE notice to summary (for GMP library).
	PRINCE: Mute a compiler warning.
	Add a header in pkzip_plug.c muting a compiler warning.
	Sync upstream PRINCE changes. Major improvement for resuming.
	PRINCE: Much faster node distribution - but distributes poorly for
	  very small keyspaces.
	PRINCE: Sync prince.c from upstream (d9bbf908) pp.c.
	PRINCE: Sync prince.c from upstream (be309320) pp.c (major bugfix).
	Autoconf: Check whether compiler supports some int128 type(s).
	PRINCE: Prefer uint128_t over GMP if available, for a 44% boost. This
	  only works with 64-bit builds and not with all compilers (it should
	  work with gcc 3.1 and above). Otherwise fall back to GMP.
	PRINCE: Support 128-bit integer for legacy Makefile builds.
	PRINCE: Fix a bug with 128-bit restore.
	Show default parameters for PRINCE mode in usage blob.
	PRINCE: Bugfix for legacy builds.
	Add instructions for working around bugs in the system headers of OS X
	  Yosemite. See #1025.
	PRINCE: Merge upstream.
	OSX: Backup originals if patching system headers o.O
	Mask mode (pure): Fix progress/ETA for node/fork runs. Closes #1024.
	PRINCE: Drop the inner-loop node distribution alternative, plus some
	  error output tweaks.
	PRINCE: Update from upstream.
	PRINCE: Ensure session store/resume compatibility between GMP and
	  non-GMP versions. And fix input/output of large numbers in the
	  int128 version. Also fix what I hope is a bug upstream (else we got
	  a problem).
	PRINCE: Update from upstream. 6.4x boost. Drop the int128 version for
	  now (WIP).
	PRINCE: Add options --prince-skip=N and --prince-limit=N.
	PRINCE: Add int128 alternative to GMP again, this time using a header
	  with nefarious macros.
	Re-add AC status output for int128 PRINCE.
	PRINCE: Add --prince-keyspace option. Also add --disable-int128 to
	  autoconf.
	mpz_int128.h: Support base 10 and 16 for mpz_set_str()
	PRINCE: Show "bits used" when printing keyspace. Also revert a bug
	  workaround that should no longer be needed (div by zero while
	  skipping).
	Add unrule.pl embryo. This does wot epixoip said, plus removes dupes
	  and sorts by count. Reduces rockyou.txt by 60% in 30 seconds. See
	  #998.
	mpz_int128.h: Add overflow checks, saturating to INT128_MAX (and to
	  zero for subtraction)
	mpz_int128.h: Minor tweaks.
	blf.h: Use "stdint.h" and not <stdint.h>
	Sync pp.c from upstream.
	Add a warning about saturation in mpz_int128.h in case someone tries
	  to use it for something other than PRINCE.
	PRINCE: Fix a bug in JtR-specific code introduced when merging
	  upstream.
	Drop OS X 'as' wrapper script in favor of -q option to native 'as'.
	mpz_int128.h: Fix saturation checks for case where rop and op1 is the
	  same variable.
	PRINCE: Update from upstream v 0.20.
	PRINCE: Tweak parameter checking.
	PRINCE: Fix (JtR specific) resume bug.
	PRINCE: Update pp.c from upstream and add new -prince-case-permute
	  amplifier option to JtR.
	PRINCE: Allow output lengths up to 125. Note that this mode currently
	  limits output length to 16 unless you use -max-len to bump it. For
	  most other use cases, -max-len is a limiter.
	Print timestamp with --log-stderr.
	PRINCE: Bug fixes for case when output length > max input length.
	Jim's portability hack of pp.c was broken: * If -DJTR_MODE we don't
	  need getopt.h at all * if that macro is not defined we must not
	  depend on other object files.
	PRINCE: Reduce memory use.
	PRINCE: Fix a bug when output length > max. input length.
	PRINCE: Fix output length bugs. We can't support longer output than 32
	  unless we switch to u64, but it will too slow anyway.
	PRINCE: Fix a session bugs with node/fork. This is incompatible with
	  saved sessions from previous versions - there was no way around it.
	MIPS tweaks for autoconf script. Suggested by Solar after tests.
	PRINCE: Update from upstream.
	AC: Add mips* back (and a new mips64*) for catching obscure target
	  triples.
	WPAPSK: Better version of previous patch. See #1031
	PRINCE: Add support for encodings. This does not affect performance
	  much, and only during initial wordlist load.
	PRINCE: Add loopback mode. Note that we do not yet have dupe
	  suppression which is almost a must for loopback.
	PRINCE: Add dupe-suppression.
	PRINCE: Update from (sort of) upstream.
	Some tweaks for --max-length option. Do not allow it to over-ride a
	  limited --stdout=N length, and bail with error if trying to use
	  larger than allowed for PRINCE mode (currently 32).
	Change the inline error output from keepass format to reference the
	  issue for fixing it, and use error() instead of exit(). See #1023
	  and #1026.
	Do not test for int128 unless we are really 64-bit or better.
	PRINCE: Fix resume bug.
	PRINCE: Update from upstream. Dupe-suppression is now default.
	PRINCE: Yet again tweak session save/resume. It's hard to get
	  node/fork right.
	Replace exit() calls with error() so we get a proper bailout with
	  logging.
	PRINCE: Optionally memory-map the input file (not for loopback mode
	  nor when using case permutations). This is JtR-specific, the
	  original prince-processor still only supports loading from stdin.
	  Dupe suppression is no longer default except in loopback mode, good
	  old --dupe-suppression option does it otherwise.
	Tweaks to the Yosemite patch, for not breaking clang builds.
	Pacify a clang compiler warning in pp.c.
	PRINCE: Add logging of memory use (JtR only).
	PRINCE: Upstream bug fix, and some more fixes for dupe-suppression.
	Comment out an unused variable in MD4 OpenCL kernel.
	PRINCE: Revert a bogus change in last commit.
	PRINCE: JtR-specific bugfix similar to the recently fixed one
	  upstream.
	PRINCE: Automatically decrease elem-cnt-max to pw_max if applicable.
	Drop an odd thing Frank accidentally(?) added to bash completion.
	Fix bash completion for --prince=FILE. Closes #1020.
	bash completion: Allow ':' instead of '=' for --prince=FILE. See
	  #1020.
	MPI/fork: Mute dupe "slow loading" warning messages for NTLMv1.
	PRINCE: Ensure session-save does not store a position we never
	  reached. Not sure there was a problem but better than sorry.
	PRINCE: Add rules support. This is very slow right now because we run
	  each word through all rules instead of the other way round. Closes
	  #1019.
	Add a format that is based on dummy but use no encoding at all.
	  ciphertext == plaintext. This is easier to use for some tests.
	Some --list OpenCL tweaks for Apple.
	Cosmetic --list CUDA tweak for cc 2.1.
	Add a comment in plaintext format. This format is faster than dummy if
	  using same max lengths.
	Drop some weird garbage from Makefile.in
	Support -DSYSTEMWIDE using Autoconf --with-systemwide. Shared binary
	  directory defaults to /usr/libexec/john unless you use the --prefix
	  option to configure [which also implies --with-systemwide].
	PRINCE: Updates from upstream.
	logger.c: Only flush stdout if we're indeed running fork. It should
	  not be needed for MPI.
	Minor tweak for SecureMode = Y.
	Fix p/s counter for GPU generation.
	PRINCE: Enable hybrid mask mode.
	Various fixes for PRINCE hybrid mask mode.
	Add a newly needed GMP function for emulation.
	Some file locking tweaks: Ensure a LOCK_SH before pot sync was not
	  interrupted by a signal (timer). This should not matter much, if at
	  all. Also show whether locking is supported or not in
	  --list=build-info.
	Add some file locking debug output for -DLOCK_DEBUG and also have it
	  imply -DPOTSYNC_DEBUG.
	Add a flock-test script to unused.
	Change a couple #ifdef POTSYNC_DEBUG to LOCK_DEBUG for consistency.
	Simplify pot-reload file open. This should really not make any
	  difference in the end (we're doing the same things) but it looks
	  nicer and it no longer feels like we're missing a call to close()
	  (as opposed to fclose() which we do call).
	Make it possible to *completely* disable pot syncing just by editing
	  john.conf. Also clarify some descriptions.
	Plaintext format: Add a test vector including spaces, and some
	  comments.
	PRINCE: Enable use of mmap with loopback, plus various bugfixes.
	Fix some logging that happened before log_init() so never made it into
	  log.
	Finish the alternative fcntl() file locking. After having consulted
	  Solar, we also make it the default.
	Improved -DLOCK_DEBUG a little.
	BFEgg is FMT_NOT_EXACT. See #1045.
	BFEgg should have a max. password length of 72.
	Drop FMT_NOT_EXACT from BFEgg again, and document (in source) the
	  optional per-run alternative --keep-guessing. See #1045.
	Tweaks and a bug fix for fcntl locking.
	Update some obsolete information in README.mpi.
	Clarify description of FMT_NOT_EXACT in formats.h, and drop that flag
	  from CRC32 format. That format should be run with --keep-guessing
	  option instead (if/when actually needed). Also drop some comments
	  from formats so they don't hit a "git grep FMT_NOT_EXACT" while not
	  actually having that flag.
	Mute clang compiler warnings about unused variables (that we can't
	  drop cause we need the sizeof() them) in gpg2john.
	Fix usage blob for --prince-mmap, a restriction was dropped.
	The --stress-test option did not work very well with OpenMP formats
	  that have things like "self->params.max_keys_per_crypt *= omp_t"
	  since this would be evaluated before each test and figures would
	  soon get silly. So we save them and restore them. Also applies to
	  plaintext_length as that might be eg. "*= 3" for UTF-8.
	Update doc/OPTIONS with some missing bits and pieces.
	Work around a very strange MPI segfault when trying to resume a
	  session that does not exist.
	Fix a bug that was introduced with the ShowUIDinCracks option, even
	  when not enabled. pwdump-format input files ended up showing random
	  garbage.
	doc/OPTIONS, tweak description of --keep-guessing.
	ShowUIDinCracks: Honor --field-sep-char.
	CUDA md5crypt, clean salt.
	Add salt_hash() to a couple of formats. See #809.
	AC: Rename --disable-native-macro to --disable-native-march which is a
	  whole lot less confusing. Also ensure that --disable-native-tests
	  always implies --disable-native-march.
	AC: All x86 cross-compile tests were busted and returned true for
	  anything.
	Document a problem when using Ubuntu 12.04 with modern (AVX2)
	  hardware. Closes #1051.
	PRINCE: Updates from upstream.
	Always use mem_alloc(), or check result of malloc(), for good measure.
	Our "mute ASAN" fix in bench.c affected benchmark speeds a whole lot
	  for fast formats. This mitigates it at least enough not to show
	  slower than real-life speed (compared to mask mode).
	DES-opencl: Use mem_alloc wrapper.
	Update Unicode external dumb/repeats modes for Unicode 7.0, and add
	  some codepages for possibly dealing with "Equation Group" hashes as
	  published by Kaspersky. All generated from the Unicode Database.
	Update doc/ENCODINGS.
	Fix bogus include paths (using quotes where there should be brackets).
	Ensure Makefile dependencies for opencl_DES_hst_dev_shared.h
	DEScrypt-opencl: Bugfix for dupe salts. The list of binaries for a
	  given salt may have NULL entries (already cracked).
	OpenCL: Ensure that we get AMD-specific functionality even if JtR was
	  built with nvidia headers, and vice versa.
	Add a few more vendor-specific OpenCL macros in case they are not
	  present in headers.
	DEScrypt OpenCL: get rid of a warning about comparison of integers of
	  different signs.
	Cosmetic tweak (on error) for fcntl locks.
	OpenCL: Use locks when reading/writing cache files.
	memdbg: Fix calloc bugs. Closes #1062.
	DES-opencl bugfix. I got "Get key error! 50 1575" until I did this,
	  and with this fix it cracked a hash at that point.
	Copy test vector plains to full-size buffers outside of hot loops so
	  we get a better raw speed benchmark figure. Closes #1054.
	Add CRAM-MD5 support to HMAC-MD5 format, using the raw Base64 strings
	  prepended with a Hashcat-compatible tag. Closes #1018.
	We've had an odd prototype for mem_calloc() ever since implemented in
	  36416c5. As much as I hate this no-op commit it makes it easier to
	  import code in the future.
	Fix regex.h for new path of rexgen header.
	hmac-SHA384 bug fix. Closes #1063.
	Fix a bug in hmac-MD5 and hmac-SHA1, and unify HMAC code.
	Revert recent changes to HMAC formats and make the correct fixes.
	  Better fix for #1063 (the previous fixes were OK but used larger
	  buffer sizes than necessary).
	Disable raw-sha1-linkedin if SHA1_SSE_PARA > 3. Closes #454.
	Bug fix for edge cases in wordlist mode using mmap(). Hopefully
	  addresses #1025.
	Bug fix (ASAN) in HMAC-MD5 for CRAM-MD5 conversion. See #1067
	Add our own strnlen() unless system has one.
	Add a self-test for catching buggy SIMD implementations using 0x80 as
	  end of data. 0x80 can be anything, for example a euro-sign in
	  CP1252. You can't ever use it for detecting end of data!
	XSHA512: Fix a bug that would truncate any plaintext containing 0x80.
	MSSQL12 SIMD support. There's some overhead in set_key() that's hard
	  to work around without writing totally unreadable code.
	MSSQL12: KISS fixes for SIMD: Simpler buffer cleaning and use flat
	  buffers. Speed is about the same (or better) and code is much
	  simpler and potential bugs are squashed before they showed up.
	Replace more deprecated des_ methods and calls with the DES_
	  counterparts.
	Fix bogus line endings in cryptsha256_common.h (it had a disgusting
	  MIX of LF and CRLF).
	sha256crypt: Allow - but truncate - salts longer than 16.
	sha256crypt-cuda: Bump max length to 23. See #1077. This format
	  probably should be able to do 24, but then it loses some in the Test
	  Suite due to a bug somewhere.
	Pending core change in cracker.c. Ensure get_key() is not called (via
	  status.c) after clear_keys() was called. Closes #1076.
	Pending core change in cracker.c. Ensure get_key() is not called (via
	  status.c) after clear_keys() was called. Take 2. Closes #1076.
	Drop a few empty clear_keys() functions and use fmt_default*
	Revert "bcrypt / opencl: created a BF_common set of functions / data"
	Enforce C89 for gcc-5.x (it defaults to C11). See #1093.
	Notify user of ASan affecting speed if she tries to benchmark (we
	  already did for -DDEBUG). I have ended up chasing non- problems a
	  couple of times because I forgot I was running an ASAN build o.O
	Move our strnlen() function to jumbo.c, where we have other such
	  functions. Basically, misc.c is for our "own" functions while
	  jumbo.c is for functions that many systems already have, but some
	  systems do not. Like in this case: We only implement the strnlen()
	  function unless it is available in libc.
	Revert "siemens: only validate a 1. Since we now have split, a 0
	  should not be valid any more"
	MSSQL12 bugfix for non-MMX/SSE2
	Add a bunch of known mappings between OpenCL driver version and
	  Catalyst driver version (and name).
	OpenCL, --list=opencl-devices for Catalyst (cosmetic)
	Drop the "[CPU]" after OpenCL version number, it's redundant.
	Revert a test vector in siemens S7 format to it's original format.
	Cosmetical changes to OpenCL SHA512 formats: PLAINTEXT_LENGTH was used
	  in a confusing way. Change to match our conventions. These changes
	  are verified with TS for good measure.
	Merge an optimization for HH() in md5.c originally commented as "Help
	  the compiler detect a common subexpression between steps in round
	  3."
	MD5_std.c, md5_go.c, md4.c, NT and some GPU MD4/MD5: "common
	  subexpressions in round 3" optimizations.
	sse-intrinsics.c: Use _mm_set1_epi32(n) instead of
	  _mm_set_epi32(n,n,n,n) when applicable. This is 100% cosmetical.
	Refactor MMX_COEF -> SIMD_COEF_32
	MSSQL12: Avoid build warnings on non-SIMD
	Add README-jumbo on top of README.md
	OpenCL: More use of shared code.
	Change mem_alloc_tiny() to malloc/free for large buffers in a bunch of
	  formats. This mitigates memory leaks when running --test with a huge
	  number of threads (eg. MIC/Xeon Phi) or with --stress-test. It
	  matters less for a real crack run. I picked some of most common
	  formats here plus the ones with largest OMP_SCALE figures for a
	  starter.
	Dynamic: Use malloc/free for buffers. This fixes the real show
	  stoppers, but there's still plenty of memory leaking when running
	  eg. "../run/john -stress-test=0 -form:dynamic".
	Use malloc/free for buffers; Another bunch of formats.
	Mass refactoring of saved_key_length -> saved_len to ease scripted
	  changes.
	Use malloc/free for buffers; Yet another bunch of formats.
	bench.c now resets the Unicode system, formats need not care.
	Revert a torrent of trigger-happy-commits and start using
	  posix_memalign() or aligned_alloc() for mem_alloc_align - drop the
	  extra pointers.
	Waste a couple of cycles for each alloc just to mute the ridiculous
	  compiler warning "possibly uninitialized variable" - which is isn't.
	Fix a couple of ASan crashes caused by erroneous $tag$*.
	Avoid re-declaring _XOPEN_SOURCE (core code clash with autoconf)
	If mem_alloc_align() fails, exit with message telling what size was
	  requested.
	OpenCL fixes. More unifying of SHA1 ahead.
	RAR5 OpenCL bugfix: Wrong "cost" (iteration count) reported due to
	  casting to incorrect (GPU side, should be core side) salt type.
	OpenCL shared SHA1 and MD4/MD5 cleanup and bugfixes.
	AMD bug workaround re-implemented in new shared SHA1 for OpenCL.
	Fix OpenCL formats for strtokm(). See #1108.
	Fix for that stupid AMD driver bug workaround for SHA1, for mixed
	  vector/scalar formats.
	Use -Og for debug targets if compiler supports it. Closes #1113.
	GPG-opencl failed due to changes half-assed merged from CPU format.
	  Closes #1119.
	Change strok() to strtokm() in all formats but SKEY. See #1108.
	It turns out a bug workaround for Catalyst 14.9 *triggers* an other
	  bug in older drivers... Doh. Addresses #908.
	Change strok() to strtokm() in shared files that were missed. See
	  #1108.
	PDF had a `strtok (` that didn't get replaced. Closes #1108 again.
	OpenCL: Implement an optimized SHA512 for the case where half of the
	  block is zero (as in PBKDF2). Just a slight boost, I guess the
	  compiler did much of it already.
	GPG: Needed to treat $gpg$* as the effective tag. And bump plaintext
	  size.
	GPG: Bump max length to 125, and fix some code to adopt to
	  PLAINTEXT_LENGTH. The OpenCL format already behaved well in that
	  aspect but had some other non critical bugs leading to suboptimal
	  code. I also unified some code to ease comparing side by side.
	GPG OpenCL: Alternate leaner code, trying to make it work on more
	  nvidias.
	GPG OpenCL: Much leaner code. Still does not work on all nvidias.
	GPG OpenCL: Disable leaner code for nvidias.
	Disable "cost" support in CUDA sha2crypt formats. They were buggy and
	  not trivial to fix. Closes #1118.
	Strip format, fix an ASan regression from 70f3b95a (I guess)
	Cosmetic: Address clang warnings. Closes #1126.
	Fix a "binary() returned misaligned pointer" in phpass/dynamic. See
	  #1127.
	AC: protect a variable with quotes in some tests.
	OpenCL raw-md4: Correct mask mode behavior when GWS is supplied. We'll
	  use the figure as-is but we still print a message about internal
	  generation.
	Add some debug/benchmark stuff to raw-md4-opencl. For GCN and Maxwell,
	  I see no difference at all between different versions of the HH()
	  optimization - or not using at all.
	OpenCL raw-MD5 GPU-side mask: Change GWS divisor to a more suiting
	  figure. This is significantly faster (on both GCN and Maxwell) but
	  still a compromise: Both auto-tunes to 4M, the HD7970 works best at
	  8K and Maxwell at 16K. We need to auto-tune *with* candidate mask!
	SHA256 OpenCL: Mute complaint from picky compilers
	pass_gen.pl: Do not list formats as supported when they are not.
	  Closes #1132.
	mem_calloc_align had its parameters reversed. Not that it matters.
	Change calloc_tiny to calloc/free in many formats. See #1110.
	Fix a bug introduced in b9e13c38, closing #1139.
	Change calloc_tiny to calloc/free in 14 formats. See #1110.
	AC: Include CPPFLAGS when creating fmt_externs.h and fmt_registers.h
	  just in case it matters in some situation. Closes #1137.
	Fixes for building "icc .S files". See #1065.
	Update the icc pre-built see-intrinsics.S files, using the icc on
	  super: "icc version 14.0.0 (gcc version 4.4.7 compatibility)" Closes
	  #1065.
	Fix a bug in MD5 introduced in 2e33cfd. Closes #1142.
	Fix a copy/paste bug in DMD5. Closes #1143.
	Most OpenCL formats: Auto-tune in reset().
	Bugfix in o5logon-opencl.
	Fix GPG-opencl for nvidias.
	Optimizations for oldoffice-opencl that are also workarounds for some
	  AMD driver bugs.
	OpenCL: The recent AMD change for PUTCHAR re-triggered the damn AMD
	  bug in oldoffice. Introduce a new macro for preferring the non-cast
	  alternative but default to the cast one.
	Stop Lotus5-opencl auto-tune from overflowing on fast devices.
	Lotus5-opencl, auto-tune limit.
	README-OPENCL update.
	Common OpenCL auto-tune: Temporary changes to handle auto-tune with
	  GPU-side mask. See #1136.
	Common OpenCL code messed around with bench_running flag, this lead to
	  problems and should no longer be needed anyway.
	mask.c: Allow actually using some other mask than options.mask
	  (possibly for auto-tune or benchmark).
	Fix search/replace mistakes in comments in OpenCL MD4.
	encoding_data.h: CP720 had (lack of) case conversion incorrectly
	  specified. Closes #1158.
	Support fallback to older clang syntax for Address Sanitizer.
	Fix a segfault when --users option resulted in no hashes loaded, and
	  an encoding was used. Closes #1164.
	Prince format lacked some length checks. Closes #1163.
	Fix a "theoretical" bug (ASan) in Prince. Closes #1162.
	Fix alignment issues. Closes #1133.
	Fix a bad bug introduced by f6af7d7: --show=left was broken for all
	  formats but dynamic. Closes #1130.
	Refactor salt() -> get_salt() and binary -> get_binary() in most
	  (Jumbo) formats that did not already use those names.
	Do not allow negative numbers for --mkpc. Closes #1166.
	Prefer posix_memalign() over aligned_alloc() as a work-around for an
	  ASan shortcoming. See #1159.
	Complete the previous patch: Prefer posix_memalign() over
	  aligned_alloc() as a work-around for an ASan shortcoming. See #1159.
	Comply with the strange restriction of aligned_alloc() that "size
	  should be a multiple of alignment".
	Less intrusive implementation of --mkpc. We do not alter format's view
	  of max_keys_per_crypt, just cracker.c's. Closes #1167.
	--mkpc is now a no-op for --test so do not allow it.
	Disallow some options unless we are running a cracking mode.
	Handle --mkpc in an even safer way. This handles the situation where
	  max_keys_per_crypt changes during a run.
	Raw-sha1-ng and shared intrinsics code incorrectly reported using AVX,
	  while they actually use at most SSE4.1 if no XOP.
	Change the dump_stuff() debug functions so they don't spew out
	  warnings.
	Add a pseudo_intrinsics.h function, for abstracting intrinsics from
	  the actual vector width.
	raw-sha512-ng: Use pseudo-intrinsics.
	raw-sha256-ng: Use pseudo-intrinsics.
	raw-sha1-ng: Use pseudo intrinsics.
	Q'n'D fix for a problem with cprepair.
	vtestz was not available on Travis' clang.
	Fix regression problems with clang from recent patches.
	Drop an extraneous paren from pseudo-intrinsics header.
	Fix a benign bug in raw-sha1-ng
	Drop an unused variable in raw-sha256-ng.
	Fix an issue with non-AVX SSE4.1 or SSSE3 systems Closes #1180.
	Fix incorrect function declarations for cmp_all() and cmp_one()
	Drop experimental code for OMP_SCALE, closing #1181.
	When we do not request membdg, really do not let it interfere with
	  anything at all. See #1125.
	Fix for cross-compiles on OS X, using SSE4.1 but not AVX.
	Add a parameter to configure, --enable-experimental-code, that sets
	  USE_EXPERIMENTAL macro. This way we can merge incomplete features
	  but have them disabled unless user asks for them.
	Make it possible to leave Dynamic format out entirely from a build.
	  And do so by default for AVX2, unless the option
	  --enable-experimental-code was given to configure.
	Fix for the AC handling of AVX2 vs Dynamic.
	Use pseudo-intrinsics for sse-intrinsics.c, making nearly all
	  remaining SIMD formats AVX2/AVX512 capable.
	Various fixes for AVX2.
	Fix NT2 format for AVX2.
	Drop SIMD_COEF_BITS and just divide by SIMD_COEF instead. The
	  optimizer will change it to a bit shift anyway and code gets easier
	  to understand.
	Fix more hard-coded vector sizes. And set all the SSE_PARA's to 2 for
	  __AVX2__, for ironing out problems.
	Wpapsk bugfixes for AVX2. Practically 2x boost over AVX.
	Fix hardcoded SIMD width in Office format.
	Hardcoded vector widths in Dynamic. Just the top of the iceberg. Now,
	  dynamic_30 works. Not many more of them...
	Hardcoded vector width in alignment.
	Finally nailed the MD5 problem for AVX2. Now all raw formats work.
	Fix a load of hardcoded vector widths.
	Fix algorithm names for AVX2/AVX512.
	CPU_NAME -> SIMD_TYPE
	More fixes for hardcoded vector width.
	Fixed SAP/H width issues.
	Fixed IPB and mscash2 width issues.
	Fixed mysql-sha1 and nsldap width issues.
	Slow workaround for Office format. I have yet to get the original
	  implementation to work with AVX2 - something is not right with the
	  width macros.
	Vector width fix for md5crypt. But it still doesn't work.
	Fix hardcoded vector widths in RAKP.
	Fix hardcoded vector widths in salted-sha1.
	Fix hardcoded vector widths in sunmd5. Still does not work with AVX2.
	Fix hardcoded vector widths in SAP/B.
	Fix regression problems from Lei's recent fix.
	Finally fix the inherent problem with raw-sha1-linkedin's source(),
	  that would not cope with certain combinations of vector width and
	  interleaving, and also did not allow crippled test vectors.
	Fix 64-bit index calculation for widths > 4.
	Fix hmac-sha256 vector width.
	Fix hard-coded widths SAP F/G format.
	SunMD5, fix hard-coded vector widths. Closes #1191.
	Oracle11, fix hard-coded vector widths. Closes #1190.
	Finally nailed md5crypt vector width. Closes #1192.
	It appears we can use same PARA values for AVX2 as for AVX.
	Add a few more easter egg format classes: -form:avx, -form:avx2 and
	  -form:avx512.
	Some cleanup in pseudo_intrinsics.h, and an optimization for MIC
	  emulation of _mm512_loadu_si512() that should do lots of good in
	  most cases.
	pseudo-intrinsics.h cosmetical/whitespace/comments.
	sse-intrinsics.c whitespace/comments cleanup. And finally drop the old
	  80x4 SHA1 that we stopped using long ago.
	Dynamic: Change a few hardcoded width figures to correct formulas.
	  These changes make a few more formats pass self-test. See #1189.
	Width fixes in Dynamic. See #1189.
	Algorithm name tweaks.
	Minor algorithm name fixes.
	More algorithm name fixes. We are not displaying "block loops", it's
	  just confusing.
	More algorithm name fixes. Some were completely backwards.
	It turns out I'm the one who was backwards w/ algorithm names.
	Last bunch of fixes to algorithm names.
	Yet some algorithm name fixes.
	Drop confusing mentions of "sse2" in config. Closes #1193.
	Add an ifdef'ed out scalar version of vtranspose_epi32() (in the AVX2
	  section) for reference and benchmarking. See #1201.
	The _mm*_i32gather_epi32() intrinsic has different parameters for
	  different architectures:
	Cleanups for raw-sha1-ng. Drop vtranspose_epi32 from
	  pseudo-intrinsics.h and revert the 4x code to a format-local macro
	  with its original name. Also re-write some ugly width-dependent code
	  to be more canonical and fix some white space problems.
	Separate int128.h from mpz_int128.h, and fix raw-sha1-ng in that
	  regard.
	Add some documentation about AVX2 vs. Dynamic format.
	Auto-disable dynamic format for k1om (MIC) also.
	AVX2 fixes for 32-bit builds. See #1205.
	Fix for legacy generic build after AVX2 support was added.
	Fixes for generic builds.
	Fixes for generic. See #1205.
	Some plugins could not just be deleted, so make them non-plugs. Closes
	  #1170.
	Drop the binary plugin interface that no-one uses. Closes #1124.
	Fix a typo in configure.ac
	Allow building with no plugins present. Closes #1207.
	Add some documentation about how to disable AVX2.
	Autoconf: Add support for detecting AVX512. Also fixes a bug with XOP
	  erroneously regarded as better as AVX2.
	Autoconf: Move the OS X as(1) quirk prior to all feature tests.
	Autoconf: Do not test for AVX512 unless we have AVX2.
	Drop dupe macros from pseudo_intrinsics.h and tweak non-XOP rotates.
	Cosmetic change (unify code) to pseudo_intrinsics.h.
	wordlist.c: Use pseudo-intrinsics for SIMD mgetl().
	Fix a bug in vroti_epi16() (which is not used yet anyway).
	sse-intrinsics.c: Implement the "MD4/5 common XOR" but leave it
	  defined out since it seems to be slower no matter how I do it
	  (reason yet to be examined).
	MD5: 9% boost just by moving code around (this was with gcc 4.8.2 and
	  AVX2)
	Pseudo-intrinsics tweaks for AVX2.
	Change a few int's to unsigned in sse-intrinsics.c. 1% boost in eg.
	  wpapsk and md5crypt.
	Revert some intrinsics tweaks that had dubious benefit.
	OpenCL RC4: Use restrict pointers.
	Autoconf: Detect AVX512BW as well.
	AC: Assume that there's no point in testing for AVX512BW unless we
	  found AVX512F.
	AC: Same as previous commit but for cross compiles.
	Drop a vim swap file accidentally added in 2f8bc4871
	Correct some algorithm names.
	Fix the length stuffing in dynamic, taking us a good bit closer to
	  AVX2+ support. See #1189.
	Fix more hardcoded width crap in Dynamic. See #1189.
	Cruical AVX2+ fix for dynamic. Fixes most (all?) segfaults but some
	  formats still fail self-test. See #1189.
	Yet another bunch of width fixes in dynamic. See #1189.
	Possibly the last bunch of width fixes in dynamic. Closes #1189.
	Do not disable dynamic format for AVX2 anymore. Closes #1189.
	Drop obsolete dynamic vs. AVX2 notices.
	Dynamic, change lots of variables to unsigned, enabling optimizations.
	Ensure unsigned divisions with SIMD_COEF_32/64 for faster code.
	Major white-space clean-up to common-opencl.[ch] First: indent -kr
	  -i4 -ts4 -nlp -nbbo -ncs -l79 -lc79 -bad -il0 common-opencl.[ch] and
	  then: astyle --style=kr -t4 -U -H -p -xC79 -c -k3 -z2
	  common-opencl.[ch]
	Fix a bug in --list=opencl-devices that caused "Max clock (MHz)" to
	  show a totally bogus number on some (rare) devices.
	Drop obsolete header from wordlist.c (we now use pseudo- intrinsics.h)
	Fix a logic error in #ifdefs for including mman.h. This should close
	  #1214. It's strange we did not get complaints on many systems.
	Add an experimental clone of raw-md5 that uses flat buffers for SIMD.
	  For now it uses Tavis' SSE set_key() from his raw-sha1-ng format,
	  but this will be dropped in favor of some upcoming code in
	  sse-intrinsics.c. See #1220.
	Reformat Jim's unreadable 650-column wide comments in
	  see-intrinsics-load-flags.h, and add a few more flags (yet to be
	  actually implemented) to the enum. See #1220.
	Bug fixes for raw-md5-flat. And drop the SIMD set_key().
	Fix mixed declarations and code in pseudo-intrinsic.h
	Fix memdbg for alignments larger than 16. Also fixes some other minor
	  problems (warnings). Closes #1200.
	Always define _DEFAULT_SOURCE when defining _BSD_SOURCE. Closes #1227.
	pkzip: Fix a cast that could lead to undefined behavior from
	  overflowing signed integer. Closes #1232.
	OMP_SCALE tweak for raw-md5.
	Promote "nt2" to be main "NT" format. Rename old "NT" to "NT-old".
	  Closes #1226.
	NT OpenMP overhaul. This format should not run in HT threads.
	listconf.c: Always call fmt_init() now that OpenCL formats are fixed.
	03404dfd broke for any system using gcc but not glibc. Just comment it
	  out for now.
	Fix a bug in pp.c where munmap() was called even when we do not
	  HAVE_MMAP. And add a warning notice when building without mmap.
	AC: Change the way we look for mmap(). Closes #1214.
	Add a format_all_done() for silencing memory leak checkers. Closes
	  #1244.
	Fix a gigantic memory leak in dynamic when using --show and an input
	  file containing many different formats. See #1244.
	Fix minor memory leaks in dual-use formats. See #1244.
	Define _POSIX_SOURCE for glibc builds, for exposing fileno(3).
	Let AC handle definition of _POSIX_SOURCE. Closes #1263.
	Add a self-test fail for get_key() returning NULL.
	Improve StatusShowCandidates so it logs the exact candidate number for
	  a crack. Screen output will still be rounded up to batch size.
	  Closes #1269.
	memdbg: Fix alignment up to sizeof(vtype) for 32-bit builds. Closes
	  #1270.
	memdbg: We were adding too much padding for 32-bit. It worked but was
	  wasteful. See #1270.
	Revert "crypt-descrypt: for length-13, we never disable, since they
	  are in ST code"
	Fix the slow AVX2 bug workaround in Office 2013 and add other
	  optimizations to boot. 65% speedup for -cost=2013:2013 (and now an
	  actual 2x speedup over AVX). Also hopefully fixes latent bugs with
	  interleaving.
	Stop requiring libz. It's only needed for pkzip format and gpg2john.
	Add some missing codepages to opencl_unicode.h
	DMG (debug): Use fcntl locks if we have it.
	Update .travis.yml
	Update README.mozilla for mozilla-ng format
	Update INSTALL-UBUNTU for latest rexgen (and drop obsolete libs).
	Drop some artifacts from old MMX support.
	Drop @Z_LIBS@ from Makefile.in - or it will be added either twice or
	  when not appropriate.
	Revert "Drop @Z_LIBS@ from Makefile.in - or it will be added either"
	Fix OS X as(1) workaround in cases where CC is not "gcc". Closes
	  #1293.
	Minor and cosmetic tweaks for raw-sha1-ng.
	krb5pa-sha1 formats: Salt cleansing, for pot sync to work properly.
	Fix OpenSSL/CommonCrypto output. Closes #1299.
	options.c: Bail with error if an invalid field separator char (eg.
	  multi-byte character) is used.
	Reduce scope of a pot-sync variable.
	sunmd5: Fix #1301 and also implement various changes for OpenMP that
	  was discussed on john-dev.
	Fix a repeated bug in many SIMD formats that had min_keys_per_crypt
	  set to 1 or to SIMD_COEF without para multiplier. It's supposed to
	  be set to whatever number is calculated at minimum, so for SIMD
	  formats it should be (SIMD_COEF * SIMD_PARA).
	OMP_SCALE tune for sha1crypt. See #1303. Higher numbers may be
	  slightly better but impacts self-test duration too much.
	Work around AES-NI problems with 32-bit builds.
	Fix misaligned return from binary() in IPB2 and Lotus5. Closes #1291,
	  closes #1304.
	Add struct alignment in sunmd5 that was missed in 7910681c
	gpg2john: implicit int declaration.
	Add another solution to #1093. This make it possible to build using
	  gcc 5 without --std=gnu89 (although I kept the latter for now). See
	  also #1250.
	ALWAYS_INLINE: Revert last commit and implement a different solution.
	  See #1093.
	keyring: Alloc a huge buffer instead of trying to create it on stack.
	  Works around a problem on some 32-bit builds and does not affect
	  speed anyway. Closes #1292.
	pufferfish: Fix incorrect source file permissions.
	Add missing FORMAT_NAME for streebog formats.
	Stribog: Properly emulate epi64 intrinsics for 32-bit builds. And
	  disable format completely unless SSE4.1 is available. Tested on
	  32-bit OSX. Closes #1331.
	Sledge-hammer bodge for pp.c fileno() warning in Cygwin.
	Default to not enable OpenMP for fast formats. Closes #1325.
	Fix Pomelo algorithm_name for SSE2 case. I believe the format uses
	  SSE2 in single-hash calculation, so it says 1x.
	Stribog formats use SSE4.1, but not for doing several hashes in
	  parallel. So change algo to 1x.
	Do not treat SHA256/512-ng formats as "fast" ones when it comes to
	  OpenMP.
	truecrypt_volume2john: Add a missing LF
	Revert "Sledge-hammer bodge for pp.c fileno() warning in Cygwin."
	Repeats16/32: Increment char before length (b will now come before
	  aa). This greatly benefits formats where length variations cause
	  thread (or branch) divergence.
	Fix a bug in rar2john for decoding non-ASCII filenames when stored in
	  compressed form. Did not affect crack, just meta data (eg. Single
	  mode).
	Tweak error output in wpapcap2john.
	wpapcap2john: Add some rigidity against bad input. Closes #1340.
	Finally start defaulting to UTF-8. Closes #1215.
	Pomelo: Drop some checks that are always false (unsigned < 0). Closes
	  #1343.
	keystore2john: Drop some checks that are always false. Closes #1342.
	Fix a problem with debug builds and gcc 5.x. Closes #1286.
	Bump max length in GOST R 34.11-94 format. There's no reason for us to
	  artificially limit it. Also fix HMAC-GOST code (not yet used).
	Stribog: Don't compare too much in cmp_all() - but on the other hand
	  *do* compare all of the hash in cmp_one().
	Many formats: Don't compare too much in cmp_all(). There is a reason
	  we separate cmp_all() and cmp_one() for crying out loud. Hopefully
	  this Q'n'D fix compiles to a simple binary[0] == crypt_key[0] in
	  many cases.
	BFEgg has a binary size less than 8, do not memcmp ARCH_SIZE.
	mem_alloc_tiny(): If -DDEBUG or -DMEMDBG, never return better
	  alignment than requested (for triggering bugs). See #1195.
	Truecrypt: Fix a debug code buffer that was undersized.
	Fix non-AVX2 builds after the previous patch.
	Add SIMD_PARA_SHA256/512 macros to mic.h and x86-sse.h.
	Dynamic: SHA2 interleaving fixes.
	Show SHA2 interleaving factor in algorithm names if applicable.
	Do not use "pragma GCC optimize" for ASan builds.
	SHA512 SIMD interleaving bug fix.
	sha512crypt: Interleaving fixes. Tested with para 3 so far.
	sha256crypt: Interleaving fixes and some unification with sha512crypt.
	  Tested with para 2 & 3 so far, and AVX & AVX2.
	SHA2 interleaving fixes. More to come.
	sse-intrinsics.c: Asan builds was unbearably slow without using
	  #pragma GCC optimize... To get that, use Asan and build with "make
	  debug".
	Fix non-OpenMP build problems introduced with b96ed88f.
	Add all aliases to --list=encodings, and fix bash completion for
	  multiple "or". Closes #1352.
	HMAC-SHA2 formats, interleaving fixes (not complete).
	XSHA512 interleaving fixes (not complete).
	SHA2 interleaving fixes.
	Drop redundant SHA256/512_BUF_SIZ macros. They are all 16 so we don't
	  need different ones.
	SHA2 interleaving fixes.
	AIX-SSHA512 bugfix.
	SHA2 interleaving fixes.
	Blackberry: Interleaving bugfix, and correct algorithm name.
	rawSHA224/256 formats: Fix interleaving (now passes Test Suite).
	rawSHA384/512 formats: Fix interleaving. Still fails but I'm pretty
	  sure the problem is in sse-intrinsics.c. Except I can't find any
	  problem there...
	Fix a SHA512 interleaving bug in sse-intrinsics.c. Lei did the right
	  thing, then I blew it.
	Interleaving bugfix in Drupal. Still doesn't work.
	Final interleaving bugfixes in Drupal.
	Interleaving bugfixes in MSSQL12
	Interleaving bugfixes in XSHA512.
	Minor regression fixes after SHA2 interleaving battle.
	Add a testparas.sh script. See #1297.
	testparas.sh LF and OMP fixes.
	Refactor MD5_SSE_PARA -> SIMD_PARA_MD5 and so on. See #1217.
	Pomelo and SunMD5: Fixes for non-SIMD builds.
	SybaseASE: Handle truncated key length. See #1367.
	Implement SSEi_FLAT_OUT for simpler format code. SHA512 and MIC may
	  hopefully use the new scatter instructions here.
	Use new SSEi_FLAT_OUT in formats that did marshalling in caller.
	Bump Keepass max. length to 125.
	Fix a minor OMP_SCALE regression from 87fab5b.
	sse-intrinsics.c missed LF on last line from 84bd73e0c. I've seen
	  compilers choke on that.
	Use vscatter for SSEi_FLAT_OUT in MD4 and MD5 too.
	Add codepage.pl as seen on john-users mailing list.
	testparas.sh: Ensure using OMP_SCALE=1 while testing. Also change all
	  formats to use any existing OMP_SCALE if defined. This is for
	  automated testing (obviously not limited to testparas.sh).
	Fix SSE2 vswap64() macro. We change in-place *and* return the result.
	  See #1373.
	More #ifndef OMP_SCALE wrappers. Last one-liner wasn't good enough.
	Add SIMD support to new Oracle 12c format.
	sse-intrinsics.c: Wider interleaving loops, and as a result use
	  non-array temp variables. See #1217.
	SHA1 intrinsics: Drop a whole array of redundant temp. We can use the
	  existing pad array! And decrease SHA1_PARA to 1 because that's
	  faster now.
	Fix bug for SSEi_FLAT_IN introduced in b3fb17c7b, and drop yet another
	  temp variable. Closes #1375.
	sse-intrinsics: Revert to using tmp[SIMD_PARA].
	SHA512 intrinsics: Decrease the w[80] pad to w[16] using the same
	  sliding-window technique used in SHA1 and SHA256. Just a 3-4% boost
	  here but may gain more on some systems. See #1217.
	Unify SHA256 and SHA512 intrinsics. Effectively a no-op, but simpler
	  code. See #1217.
	Add an EMMS at HDAA MMX function exit (icc warned about it).
	Mute a warning from some compilers about see-intrinsics cast.
	Intrinsics: Safer casting (union) between vtype and integer.
	Replace testparas.sh with testparas.pl, with Markdown table output,
	  ready for pasting in GitHub.
	Add non-OMP figures in testparas.pl
	Improve testparas.pl for quicker run and real non-OMP figures. This is
	  very hacky but does the job.
	krb5pa-md5: Improve comments on input format.
	Keepass: Avoid a compiler bug related to SALT_ALIGN. Closes #1284.
	Add CRC-32C format with SSE4.2 support, just for trying it out. See
	  #1379.
	Use a unique tag for CRC-32C.
	Re-enable SIMD for Truecrypt/SHA512. Closes #1421.
	Fix a bug in last commit spotted just by review. We need test vectors
	  for this! See #1421.
	Add error handling for keyfile operations in truecrypt.
	doc/MASK: Fix a typo and do not use tabs.
	Drop the separate CRC-32C format (CRC-32 format now hosts both).
	Drop the recently introduced Lineage format. It wasn't ready.
	Add "cost" support to CRC-32 format, mainly to facilitate benchmarking
	  CRC-32C separately (using --cost=1).
	Whitespace/cosmetic in raw-md4-opencl
	Add GPU-side mask mode to raw-md5.
	Drop some obsolete/redundant stuff from CRC32 format.
	Tweaks to README.md: Slightly smaller heading, put license last.
	Fix a segfault in some OpenCL formats when ran after another.
	raw-sha512-opencl: Fix re-init bugs.
	Fix for plugins that are #ifdef _OPENMP (they were never included).
	OpenCL formats: Fix a problem with --list where fmt_done() is called
	  without create_clobj() being called first. Closes #1237.
	Drop an old kludge for nvidia rotates and fix weirdness in pwsafe code
	  (cosmetical).
	Core merge for Makefile.legacy. Git lost track of the connection with
	  master:src/Makefile after some screw-ups we did in the past.
	Update rexgen.h for latest librexgen.
	Support Tera prefix for C/s numbers.
	Revert bogus change of raw-md5-opencl format tag, plus some minor
	  (cosmetic) fixes.
	Add generic pbkdf2-hmac-md5 OpenCL format.
	Add SIMD support to pbkdf2-hmac-md5. Closes #1446.
	Add 1000x test vectors to pbkdf2-hmac-md5.
	OpenCL raw-md4/5 formats: Correction for assert.h, it was given in
	  quotes instead of brackets.
	Another try handling the CircleCI problem with MD5 internal CTX
	  struct.
	Add 'const' to our own MD4 and MD5 update functions.
	Mute some compiler warnings (gcc 4.4.7, possibly false positives).
	Add a pbkdf2-hmac-md4-opencl format, for testing purposes.
	Correct some confusing format struct names.
	Add a pbkdf2-hmac-md4 format, for testing/benchmarking. Also change
	  testparas.pl to use the PBKDF2 formats for MD4 and MD5 and add some
	  test vectors so we always do 1000 iterations.
	Selectively mute some output from testparas.pl.
	Fix for clang not compatible with gcc despite claiming to *be* gcc
	  (which proves that's a dumb ass claim).
	Add const to MD4/MD5 Update functions. I already did this but jfoug
	  decided to drop them without discussion. Do not do that, I didn't
	  add them by accident.
	MD4/5 const stuff.
	#undef MIN/MAX macros before defining.
	Add CPPFLAGS to cprepair target.
	Drop a dupe macro definition from raw-sha1-opencl
	bcrypt-opencl: Only use privat mem (as opposed to local) for Maxwell
	  and above.
	Ignore "Idle=Y" when running an OpenCL or CUDA format. See #1460.
	Work around an OSX OpenCL driver bug for Intel HD4000 where profiling
	  info sometimes end up with end-time == 0. In the cases seen, we can
	  just ignore it (set end-time to start-time). Let's hope we don't see
	  more of this bug.
	Improve OpenCL version detection.
	OpenCL 1.2 formats: Move slow function call out of inner loop.
	Add a workaround for what I believe is a driver bug in OS X for nvidia
	  (seen on GT650M driver version 10.2.7 310.41.25f01). See #1459.
	BF-opencl: Use private memory for nvidia sm_30 & sm_35 too.
	Turns out only Kepler benefits from using private memory in
	  bcrypt-opencl. The Maxwell is 6.5x faster using local memory.
	OpenCL fixes after #1456 and #1457.
	SHA512 OpenCL: Workarounds for OSX' nvidia & HD4000 driver bugs.
	  Closes #1464 (even though HD4000 now fails instead of crashes).
	Unify OpenCL formats / use shared code.
	pass_gen.pl: Drop misplaced 'require' lines for Haval. The point of
	  using 'require' instead of 'use' is we only place them where
	  actually needed. I can't currently build the Haval stuff from CPAN,
	  for some reason (fails self test).
	Revert "Add build timestamp to --list=build-info"
	Add -Wdate-time if compiler supports it. JTR_FLAG_CHECK is a gem!
	Add git commit hash to --list=build-info. Also move non-version
	  strings like "debug" and "OMP" to the *build* info.
	I was hoping this would fix a dependency problem with version.h, but
	  it doesn't. It does update version.h if needed, but listconf.c may
	  already have decided dependencies being OK.
	Fixed dependency problem (I think) with version.h
	Ensure "usage" version is same as "--list=build-info".
	Drop a level macro that broke all real builds.
	We can't use OpenCL 1.2 commands without wrapping them in #ifdef.
	  Addresses #1470.
	If we are a "release build", never show Git hash in version string.
	Kludge for ADL device id matching with Catalyst > 14.9 and dual-chip
	  devices. I'm out of (printable) words for AMD.
	Change our OpenCL run-time support macros: APPLE -> __APPLE__
	  DEVICE_IS_CPU -> __CPU__ And add __GPU__ too. The __CPU__ and
	  __GPU__ macros are defined by AMD but we make sure they get defined
	  when not using AMD too.
	pbkdf2-hmac-sha512-opencl: Apply some bugfixes from CPU version.
	  Closes #1476.
	Allow an option argument string to contain an equal sign when the
	  delimiter is a colon. Closes #1481.
	Revert 734dc42 and re-implement parts of it in a way that doesn't
	  force you to use a fkn pager to read the output.
	Drop an unjustified chain of ifdefs for debug build warnings in
	  bench.c
	Fix a bug in configure from d9293dc.
	Some dynamic formats had the ambiguous text "first 32 bytes". Change
	  it to "hash truncated to length 32". Closes #1482.
	Bugfix for POSIX va_args usage in dynamic_compiler.c. You can't re-use
	  the va_list, you need to copy it.
	See if we can have Travis test OpenCL (CPU) builds.
	Fix a perl warning and a missing linefeed in testparas.pl.
	testparas.pl: show OMP/GOMP params
	2nd try getting OpenCL into Travis
	OSX OpenCL: We can't -D__APPLE__ because it clashes with system stuff
	  when using the CPU device. Refactor to __OS_X__.
	RAR3 formats: share about 700 lines of code. See #978.
	RAR5 formats: Reject bogus iteration count. Closes #1493.
	OpenCL verbosity tweaks.
	DEScrypt-opencl: Use "safe goto" for newer AMD drivers. Closes #1496.
	nt-opencl: Silence a compiler warning.
	OpenCL: Verbosity tweaks.
	Core: Always pass database to reset(), if we have one.
	OpenCL formats: Adopt to core change for reset().
	OpenCL mscash: Adopt to core change for reset().
	OpenCL SHA2 formats: Bug fixes after core change for reset().
	Mute compiler warnings when building without OpenMP.
	Fix -DDYNAMIC_DISABLED.
	Fix name case for pbkdf2-hmac-sha512-opencl
	Fix typo in Makefiles ($shell) -> $(shell)
	Silence warnings about redefining bswap32. See #1511
	Fix OpenCL version mismatch in GPU mask formats. See #1508 for
	  discussion.
	One OpenMP pragma missed in 5bd720090
	Add --list=build-info to 'make check'. See #1516.
	Silence warnings about redefining bswap64. See #1511
	Port SXC fixes to OpenCL version.
	Port Strip fixes to OpenCL version. And fix a fundamental align
	  problem with the "unsplit" PBKDF2 salt struct.
	Add -list=build-info to CircleCI. Closes #1516.
	Strip-opencl: Fix alignment warning. Closes #1519.
	Do not trust byteswap.h for things like swap(*x++). See #1520.
	magnum decided to return the address holding a pointer instead of the
	  address it contained. Dubious idea, and did not quite work out well.
	Comment out defining DEBUG in build_table.c. Closes #1521.
	Boost NT format by a percent or two skipping final add, which is a
	  very modest first attempt to reversing steps...
	More reversing steps for NT SIMD format (and shared MD4 SIMD). Total
	  boost now 10% from original speed.
	Add whirlpool_plug.o to dynacomptest rule.
	Reverse steps in raw-md4 format. 12% boost. See #1523.
	Ensure out max-length self-tests doesn't make case-insensitive formats
	  fail.
	Fix cmp_all() in reversing MD4 SIMD formats. It would only check 32
	  bits when reversing steps. We don't have the half baked buffer so we
	  need to do a full MD4 in cmp_exact() but that wont affect
	  performance anyway. See #1523.
	Reverse steps (more of an early exit) in raw-md5 (SIMD). See #1523.
	Reverse last add of constants in SIMD raw SHA1. See #1523.
	Reverse final add in all (SIMD) MSSQL formats. See #1523.
	OpenCL formats: Do not compile kernel in init(). It slows things down.
	Bugfix for reversing final add in SHA512.
	Partially revert "Generate more test output for `make check`, for
	  Travis build clues"
	Pacify warning about unused variables in MD5 kernel.
	Pacify warnings about unused variables in MD4 and SHA1 kernels.
	Pacify warnings about unused variable in NT kernel.
	Fix non-SIMD builds of MSSQL formats.
	Fix #1533 (and a memory leak while at it). Sorry about whitespace but
	  it was a horrible mess of tabs and spaces.
	Add a heading for --list=format-details. Defined out for now.
	mscash-opencl claimed to fully support UTF-8 and codepages, while it
	  doesn't. This is a bad bug: False negatives!
	Fix version.h rule: -N is not a universal option to diff and we don't
	  need it anyway. Closes #1555.
	Fix for when using attribute format gnu_printf instead of printf. See
	  #1555 and 6406e51.
	It turns out even -q is not in POSIX diff. Closes #1555 again.
	Fix a bug that prevented NETLM and NETHALFLM to be removed even though
	  they are plugins. Also prepare for upcoming OpenCL version of LM
	  format.
	Add tag to bare hashes $u -> $$U preparation (if needed). Also fixes
	  some CRLF issues. See #1541.
	Fix for dynacomptest workaround. See #1541
	LM-opencl: Make device query error for warp size non-fatal. Also fixes
	  minor things like format name and benchmark len. Closes #1561.
	Print CUDA version numbers in --list=cuda-devices. Closes #1534.
	Minor fixes to sha256crypt while trying to nail #1532.
	Reverse final add in raw SHA2 formats and LinkedIn format. Closes
	  #1523.
	Linkedin format was accidentally disabled for all non-SIMD builds.
	Dynamic compiler: Normalize $password -> $p. See #1543.
	Add cmpt_cp.pl, closes #1568.
	Some more white-space fixes. See #1567.
	cmpt_cp.pl was accidentally put in base directory instead of src.
	zip2john: Change default to never use file magic. Closes #1569.
	zip2john: Fix usage blob after last commit. See #1569.
	editorconfig: Let user decide his tab width. That's the very beauty of
	  using tabs!
	Fix a bug in pot sync found by Christien Rioux, where split is used
	  twice. Since split returns a static buffer, a strcmp of the two
	  results always returned 0. Closes #1573.
	Improve SSEi_REVERSE_STEPS for SHA1 for another 5% boost. The Linkedin
	  format can't reverse steps because it needs a source() with larger
	  part of binary as input to be safe.
	Update icc-precompiled intrinsics (compiled on Super).
	Fix memdbg bug in mscash2-opencl helper. Closes #1574.
	Fix "reverse sum" bug in raw SHA-224/384 and also decrease binary size
	  in a bunch of raw SHA-2 formats for smaller memory footprint when
	  loading many hashes. Closes #1577.
	MSSQL off by one bug introduced with recent reverse-steps code.
	Fix a couple of bugs in MSSQL formats before jfoug finds them ;-)
	Work around an OpenCL driver bug in OSX. See #1583.
	Rewrite some hairy code in oldoffice kernel. I'm not sure it was legal
	  (and guaranteed left-to-right) at all but even if it were, some
	  drivers had problems with it. See #1571.
	OpenCL: Add a -D__MESA__ for MESA platforms. And use it to enforce
	  "safe goto" DES kernel version for decrypt. See #1470.
	Since Mesa incorrectly claims supporting OpenCL 1.2, add an autoconf
	  function test checking for actual presence in the libs found. See
	  #1470.
	Minor fix for the OpenCL 1.2 AC detection stuff.
	Fix for non-opencl builds.
	Fix a bug in LM OpenCL for use of clGetKernelArgInfo. See #1587.
	LM OpenCL: Fix for OSX nvidia. Closes #1587.
	Bugfix for selection of LM Incremental mode.
	Automagic selection of LM-opencl codepage.
	sha256crypt-opencl: Protect some macro arguments with parens. Closes
	  #1601.
	Correct algorithm_name for non-SIMD sha512crypt.
	Bump nt-opencl to max. length 27. This adds six additions to each
	  calculation and increases a buffer size with 8 bytes.
	Autoconf: Don't enable CUDA unless user asked for it.
	Autoconf: Change --enable-rexgen -> --disable-rexgen (default is we
	  use it if found; user may want to disable it).
	Oracle12c: The SIMD implementation never worked except for index 0 - a
	  whole loop was missing. See #1607.
	CRC32 bugfix: We used a function pointer to crypt_all that was set in
	  set_salt, but cracker.c and others may have already "cached" its
	  dereference. See #1607.
	Fix for non-SIMD OMP Oracle12c.
	Drop old "testpara" make targets (they are obsoleted by testparas.pl).
	  Closes #1297.
	CircleCI forced me into actually testing a non-SIMD build myself and
	  fix the Oracle12c problems.
	Tune lm-opencl for OSX nvidia.
	Emit a warning if CUDA was found but not OpenCL.
	Update README-CUDA.
	Warn if using an 8-bit incremental mode with a 7-bit format. Closes
	  #1619.
	-enc=raw (or -enc=ascii) disables CPstoreUTF8 option. Closes #1633.
	Document the fact --loopback now defaults to using rules. See #1655.
	Change %zd to %zu in a number of files. Silly.
	Regard GPU temp readings of < 10°C or > 125°C as invalid.
	Change all code to use our AES-NI (run-time detection) implementation
	  (with fall-back to OpenSSL). Heaven knows why we didn't do this ages
	  ago.
	Fix aes/ legacy Makefile for recent AES changes.
	Revert Office, LastPass and GPG formats to use OpenSSL AES since our
	  run-time-detecting AES-NI code only handles CBC mode. Closes #1683.
	7z-opencl: New kernel, optimized similar to RAR3. About 65% boost and
	  now faster than oclHashcat.
	Boost 7z formats' many-salts speed a *lot*, it's KDF is effectively
	  unsalted as long as the iteration count doesn't change. Closes
	  #1679.
	Emit a warning if "many salts" benchmark did not test the full
	  BENCHMARK_MANY number of salts.
	Bitcoin: Drop OpenSSL EVP high-level crap in favor of our own AES.
	  Hopefully fixes #1667.
	RAR3 formats: Stop using OpenSSL EVP, see #1686. This ought to give a
	  noticeable boost, especially for OpenCL.
	Add missing header protection wrapper (wtf is that called?) for aes.h.
	7z: Add a missing OpenMP pragma for non-SIMD and fix algorithm names.
	Add a bunch of test vectors to 7z formats.
	Fix bug in 7z for SIMD: Max supported length seem to be 27. Also fix
	  my own bug with OpenMP allocation. There are still some SIMD
	  problems so the '#undef SIMD_COEF_32' stays.
	Re-write the "extra pot files" code to use a list section. See #1623.
	doc/CONFIG: Replace a line that got lost from its section, and add a
	  bit more details/examples.
	Drop an unused variable from encfs_common_plug.c.
	OpenCL PBKDF2-HMAC-MD4/5 contrived formats: Use 2x interleaving on
	  nvidia Kepler.
	pass_gen.pl: Add a -vectors option for test vector "source code"
	  output.
	Drop silly warnings from pass_gen.pl
	md5crypt-opencl: Prepare for supporting length > 15.
	formats.c: Use strcasecmp for checking (most) format names. Also
	  trim/fix some error output.
	pass_gen.pl: Refactor a sub for checking (surrogate) UTF-16 length.
	7z: Bugfixes for SIMD. Buffers were not sufficiently allocated for
	  worst-case scenario. Also move more code into "if (new_keys)".
	  Closes #1692.
	7z: Fix for non-SIMD builds.
	Add a macro for detecting "nvidia sm_32 or better" and use it for
	  enabling Solar's inline PTX for md5crypt format.
	OpenCL NTLMv2 & SHA1crypt: Run 2x interleaved on Kepler.
	OpenCL shared pbkdf2-hmac-sha1: Tweaks for reducing GPR pressure.
	Update Catalyst major/minor -> "version" list.
	Drop pufferfish format. Closes #1702.
	Don't use __attribute__((max_constant_size())) on OS X, it's not
	  supported (emits warnings). Closes #1657.
	Loopback mode: Never assemble LM halves when target format is
	  descrypt. Closes #1654 (or so I hope).
	Tweak "recommended"/"not recommended" output for AMD versions.
	7z: Canonical fix for the confusing alloc formulas. See #1692.
	Single mode: Re-write Jim's patch for retesting guessed plains against
	  all other salts. See #1706.
	Use fewer test-vectors in 7z-opencl unless -DDEBUG - it takes too long
	  to self-test.
	Tweak for new auto-tune, fixing problem with some formats.
	Shared OpenCL code: Drop obsoleted functions.
	New OpenCL auto-tune: Print nanoseconds in human format.
	OpenCL autotune: Drop obsolete functions get_task_max_size() and
	  get_default_workgroup().
	Add ability to read all pot files in a directory. See #1623.
	EditorConfig: Use a tab width of 8 for core files.
	Break out the Jumbo additions to single mode rules to a separate
	  section (but do include that section where it was located, so this
	  is a no-op).
	SessionFileProtect: Adopt to coding style, simplify code and fix error
	  messages. Closes #1710.
	Try to address #1711. I have no idea why this doesn't work.
	Logic bug with SessionFileProtect.
	OpenCL: Change BENCH_CLERROR so it can always be used in crypt_all().
	  This reduces the risk of auto-tune aborting the process if hitting a
	  limit.
	More output from auto-tune: Show LWS when tuning GWS and vice versa.
	OpenCL: Change some %zu to portable macro.
	Add a global variable telling if we're currently auto-tuning.
	Change default (LWS == NULL) to a device query for warp size. But also
	  include other alternatives in a ladder of #if's.
	RAR-opencl: Use the new ocl_autotune_running variable to get rid of
	  the crypt_all_benchmark() function.
	WPAPSK-opencl: Use the new ocl_autotune_running variable to get rid of
	  the crypt_all_benchmark() function.
	7z-opencl: Use the new ocl_autotune_running variable to get rid of the
	  crypt_all_benchmark() function.
	Office OpenCL formats: Drop the separate crypt_all_benchmark().
	encfs-opencl: Drop the separate crypt_all_benchmark().
	krb5pa-sha1-opencl: Drop the separate crypt_all_benchmark().
	sha1crypt-opencl: Drop the separate crypt_all_benchmark().
	rar5-opencl: Drop the separate crypt_all_benchmark().
	pwsafe-opencl: Drop the separate crypt_all_benchmark().
	OpenCL PBKDF2 formats: Drop the separate crypt_all_benchmark().
	Bunch of OpenCL formats: Replace unreadable code with an existing
	  macro.
	Many OpenCL formats: Speed up autotune and make it more reliable.
	OpenCL: Make a macro vector-aware.
	RAR-opencl: Autotune fix just for good measure. I saw no problems.
	OpenCL: Drop local v_width, use the global one. Refactor
	  opencl_v_width to ocl_v_width.
	Tweak BENCH_CLERROR macro.
	Workaround for OS X weirdness with CPU OpenCL device.
	OpenCL bugfix: BENCH_CLERROR got the logic backwards after change.
	Tweak error output during autotune.
	OpenCL: Add a global variable holding the max LWS of *all* kernels.
	  For this to work, format's get_task_max_work_group_size() must be
	  correct.
	OpenCL: Don't show a build log only containing warnings/notices,
	  unless verbosity is bumped. This was the case for release builds
	  already.
	OpenCL kernel functions: Never use static, always use inline.
	GET_MULTIPLE_OR_BIGGER macro must not be vector aware. Add another one
	  instead.
	Add john.conf option for auto-tune initial LWS enumeration.
	OpenCL RAR formats: Bugfixes for LWS=0.
	md5crypt-opencl: Add a pragma needed for amd_bitalign with older
	  drivers.
	Change some exit() to error() for proper logging and easier debugging.
	  See #1714.
	Add a header to win32_memmap.c needed for error().
	Update dependencies in Makefile.in
	7z and RAR: Trim the waste-space allocation for length sorting. Closes
	  #1692.
	Correct dependency for error() is misc.h.
	7z: Missing paren. I did say it was tricky.
	Undocumented hack: If you give the benchmark time as a negative (eg.
	  -test=-1) it will be minimum that time, but will also wait for
	  completion of "many salts" test.
	Keccak formats: Stop lying about SIMD support. There is none. Closes
	  #1712.
	SHA-3 format: Stop lying about SIMD support. There is none. See #1712.
	Fix 1711: Correct detection of whether we're restoring or not.
	Fix a logic bug that made (currently) impossible things like "-markov
	  -rules" not bail out with error. Closes #1697.
	Revert exit() -> error() for a CUDA file.
	OpenCL: Move Solar's bitalign macros to opencl_misc.h.
	OpenCL: Drop the fragile nvidia_sm32plus macro in favor of separate
	  SM_MAJOR and SM_MINOR definitions supplied to the kernel.
	Handle partial NVML (missing nvmlDeviceGetIndex() function). Closes
	  #1630.
	Minor tweaks to --list:cuda/opencl-devices output (stop using tabs,
	  for a starter. Looks bad when pasted)
	Bugfix for the many-salts extra test.
	OpenCL: Ensure self-test and autotune does not involve changing length
	  of test vectors' plaintext. Some formats have too big a penalty for
	  that so we need to let the format decide (by means of what test
	  vectors it declares).
	OpenCL autotune: Rework keysetting a bit more (and fix a bug that lead
	  to irregularities).
	formats.c: The fmt_set_key() wrapper now has its buffer SIMD- aligned.
	  Also fixes a few callers that did not use the wrapper.
	Fix --format option when -DDYNAMIC_DISABLED. Closes #1722.
	Change a format expression in dynamic.con so we don't end up seeing
	  "peoplesoft" when gripping out primitives. See #1716.
	Tweak format descriptions for dynamic Cisco formats so we don't end up
	  seeing "cisco" when grep'ing out primitives. See #1716.
	RAR-opencl: Minor optimization, 5-10% boost.
	RAR OpenCL: allow less work per loop-kernel call.
	OpenCL auto-tune: log resulting work sizes.
	Minor 7z-opencl optimization.
	Tweaks for .editorconfig
	Suppress an erroneus comment about UTF-8 with -enc=raw.
	Add FMT_TRUNC format flag. This is set for formats that originally
	  truncate at our max. length (eg. LM, DEScrypt) but not for formats
	  where our max. length is limited (usually due to optimizations), eg.
	  NT and MD5crypt. See #1724.
	Lotus5-opencl bugfix (segfault in some situations). Closes #1726.
	If BF_X2 is already defined (eg. CFLAGS), don't change it. See #1199.
	Retire the "md4-gen" format, just like "sha1-gen" (they both live in
	  unused/ for a while). It was obsoleted long ago.
	If BF_ASM is 1, don't allow redefining BF_X2. See #1199.
	--list=build-info: Show salt hash size.
	Separate --log-stderr from --nolog. Now the former does not imply the
	  latter, but both can be used.
	Salt sort: Allow user to disable the default fallback to "most used
	  first" (it was hard-coded until now).
	Lower default iteration count for pbkdf2-hmac-sha2 OpenCL formats, for
	  easier testing. Use -cost:10000 to get the old figures.
	Unify SHA-1's H() a.k.a F3() a.k.a SHA-2's Maj() as well as SHA-2's
	  Ch() implementations, using better optimized ones. OpenCL and CUDA
	  formats. See #1727.
	Unify SHA-1's H() a.k.a F3(), a.k.a SHA-2's Maj() as well as SHA-2's
	  Ch() implementations, using better optimized ones. Intrinsics
	  formats. See #1727.
	7z-opencl: Bugfix for keeping within workgroup limits.
	DMG-opencl segfaulted on super because of OpenSSL thread safety issues
	  with EVP. Disable OpenMP for now. See #1686.
	raw MD5 flat format (experimental): Drop bogus header dependency
	Intrinsics: Use vandnot version for vcmov, if available (currently
	  always). Both versions are 3 ops but the andnot one has parallelism.
	Pseudo-intrinsics: Comments (no-op).
	OpenCL: Ensure auto-tune plaintext length is within limits.
	OpenCL: Add an alternative SHA-2 Ch() a.k.a MD4/5 F() for archs with
	  and-not instruction. And stop defining USE_BITSELECT for Maxwell.
	OpenCL: Fix definition of OLD_NVIDIA. It was always intended for
	  sm_1x.
	DMG formats: Drop use of EVP in favor of low-level API and re-enable
	  OMP support for the OpenCL format. See #1686.
	Several formats: Use shared PKCS padding-check function. See #1686.
	OpenCL shared MD5: Use Solar's newly found or-not bitselect.
	Dynamic: Drop a couple of spurious space characters.
	opencl_misc.h: Do not define HAVE_ANDNOT for GCN. This is a no-op
	  though since it'll use bitselect instead anyway.
	Re-enable use of bitselect instructions for Maxwell. The previous
	  tests seem to have been invalid due to kernel binary caching.
	Add a "kernel-clean" make target, dropping nvidia's cached binaries in
	  ~/.nv/ComputeCache as well as our own cache for other vendors.
	  Neither of them is safe from a change in just a header file included
	  by a kernel.
	7z formats: Add a salt_compare function so we are sure to exploit any
	  same-iteration-count weakness. Closes #1728.
	Update --list=format-methods with missing methods. Change ordering to
	  same as in the struct. Do not output get/ binary_hash methods that
	  are NULL.
	OpenCL: Work around an Apple driver bug for Intel HD Grahpics. See
	  #1723.
	Recent change to keychain formats increased number of FP.
	Intrinsics: Sourcing of misc.h was trying to abandon the pack.
	Intrinsics: Change Solar's "#if 0" around MD4/5's SSEi_FLAT_OUT to
	  "#if USE_EXPERIMENTAL" and add comments on why it's left out.
	mem_align function: Require power of 2 alignment, and use faster code.
	  See #1731.
	Change stack allocations of MEM_ALIGN_SIMD to be safe. Closes #1731.
	Intrinsics: Pacify a compiler warning on XOP where PARA >= 3.
	Drop support for "icc precompiled intrinsics". We keep breaking it and
	  apparently no-one is using it nowadays anyway.
	XOP builds: Use 2x interleaving for SHA-256.
	NTLMV1/MSCHAP2 bugfix (for currently unused code path).
	testparas.pl: Finish with printing a complete suggested command line
	  for ./configure. Also add a second optional parameter for number of
	  cores (for make -j option).
	Document testparas.pl (very briefly).
	Ensure all PBKDF2 formats have 10K test vectors. To bench them, use
	  "-test -cost:10000"
	Optimization for emulated vloadu/vstoreu for the case address is
	  already aligned. See #1731.
	testparas.pl: Bug when run with no args.
	The "-test=-1" hack for testing all 256 "many salts" did not work for
	  2nd or later formats in a test run.
	The "-test=-1" hack for testing all 256 "many salts" still wasn't
	  quite OK. Took too long for some raw formats. Closes #1738.
	New canonical code for "format class" selection. If you say something
	  like -format=@rc4 you will only get formats that has "RC4" within
	  its algorithm name. This can also be combined with rejecting
	  dynamics. Examples:
	Trying to beat Jim to fixing a free() <-> MEM_FREE() problem in john.c
	  that I very recently introduced.
	Format-class selection: Allow rejecting OpenCL formats.
	Ensure unsigned divisions (optimized to shifts) in various index
	  calculations.
	Dynamic compiler: Add max-length and zero-length test vectors.
	Dynamic compiler: Bugfix for mixed-case plaintext test vector.
	Add missing parens in dynamic_compiler_lib.c. Add missing dependencies
	  for dynamic_compiler.c and dynamic_compiler_lib.c.
	Fix all dependencies in Makefile.in. Closes #1745.
	Do not consider lc() and uc() for SALT_AS_HEX. See #1748.
	Pull back Myrice's OpenCL SHA-512 formats (to unused, they need some
	  updates before you can build them).
	Face-lift for Myrice's formats, still in unused. They need the shared
	  auto-tune, and things moved from init() to reset().
	Drop interim formats, so next commit get the "moves" right.
	Put Myrice's formats back in business.
	Add a config option WordlistMemoryMap, defaulting to Y but letting
	  user disable use of mmap in wordlist mode.
	Auto-tune had a really silly bug for picking plaintext length,
	  resulting in always zero.
	Found Myrice's XSHA512 kernel. Its removal was hidden in an unrelated
	  commit (b0f1fad4).
	Add autotune to Myrice's SHA-2 formats.
	Address some test vector length issues in dynamic compiler format. See
	  #1751.
	Add some debug output for CircleCI. See #1751.
	Fix for non-SIMD dynamic='md5($p)' max-length test vector. See #1751.
	Drop the "#pragma GCC optimize 3" from simd-intrinsics.c, and the XOP
	  workaround that was needed when we had it.
	Revert some mem_align() uses. Closes #1735.
	AVX-512: undef VCMOV_EMULATED when using ternary intrinsics to emulate
	  it (it's just as good as the vcmov instruction).
	Re-introduce the mmxput3() switch alternative (but ifdef'ed out).
	Use some shared OpenCL code for Myrice' SHA-512, and optimized SHA-2
	  subfunctions, but keep the actual SHA functions for now.
	Dynamic: Drop the phrase "(MD5_body)" from non-SIMD MD5 algorithm
	  name. It made no sense anyway (it's just a function name) and it
	  screwed up dynamic compiler format's parsing of algorithm_name vs.
	  label. Closes #1763.
	Intrinsics: Add missing curly braces around initializer.
	Add "Best64" rules from Hashcat. Some rules are not working in JtR so
	  was commented out, and one 'f' rule was added to end up with exactly
	  64 rules.
	Stop defaulting to "ReloadAtCrack = Y". It hurts performance when a
	  lot of hashes are cracked very fast, and the remaining pot sync
	  alternatives will take care of the important business anyway.
	Centralize reversing/unreversing of (scalar) binaries, for easier
	  maintenance of code. And re-implement source() for raw formats using
	  reversed steps (SHA-1 still to-do).
	Drop the john.conf default for DefaultInternalEncoding.
	Do NOT lock potfile during pot sync.
	Implement source() for raw-SHA1 format.
	Fix SessionProtect for forked (or MPI) sessions, as well as for
	  JOHN_SYSTEMWIDE builds (Jim had hard-coded the session name). Closes
	  #1764.
	Move the logic for "Disabled Formats" out of loader.
	Do not define CRK_PREFETCH in cracker.c (it's defined in params.h).
	Reverse three steps for SHA-2. 4-5% boost. Closes #1758.
	Replace 0x7ffffff in all binary/hash_6 functions with PH_MASK_6 which
	  is defined as (PASSWORD_HASH_SIZE_6 - 1) in params.h.
	mssql12 non-SIMD bugfix.
	Change all binary/hash function masks to params.h macros.
	Dependency tweak for plugins. See #1767.
	Prince mode: Pure formatting.
	Prince mode: 8x speedup for rules.
	Prince mode: Optimization for when rules are used but no rules were
	  accepted (or eg. --rules=none).
	Introduce macros for telling that vloadu or vstoreu are emulated.
	Bugfix for -DDEBUG.
	Change wordlist memory buffer default threshold to 1 GB, and use that
	  default unless -save-memory >= 2. Also tweaks some other related
	  things.
	Fixes for generator/amplifier logic for mask and regex. Closes #1756,
	  see also #1757 (more work needed there).
	Mask mode: More rigid parsing of ranges/placeholders. Closes #1765.
	Mask mode: Allow '??' as literal '?'.
	Make -stdout "FMT_TRUNC" so we can chose at run-time whether to
	  truncate (-stdout=N) or reject (-max-len=N).
	Loader: Fix a bug where a loop depending on signed behavior was using
	  size_t.
	Revert "john-huge-loader-mt.diff, splitting initialization of bitmap"
	mem_calloc: Actually use calloc().
	Fix a few bugs not caused by, but triggered by, the recent loader
	  allocation tweaks. See #1769.
	Ensure ShowUidOnCrack is turned off when --save-memory is active.
	More tweaks for --save-memory.
	Raw MD5 non-SIMD bugfixes.
	MSSQL: Fix for reverse steps: We have to uppercase.
	Add a config note about --save-memory vs. ShowUIDinCracks.
	Refactor a variable to match its john.conf name.
	Minor optimization for loader.
	  http://www.openwall.com/lists/john-dev/2015/09/16/32
	Re-write code that used comma separator so it's easier to read.
	Drop code that was obsoleted by fd3c440.
	Fix a bug with hybrid mask used with wordlist + rules when an internal
	  encoding is active.
	Mask mode: Use fmt_null_key instead of creating our own.
	Minor overhaul of regex hybrid mode. See #1678.
	Fix bugs introduced in previous commit and close #1678.
	Add the cool rexgen example from #1678 to our arsenal of presets.
	Allow external filters even with Hybrid Mask. The logic was there
	  already.
	Disable CRK_PREFETCH for now, segfaults seen.
	  http://www.openwall.com/lists/john-dev/2015/09/20/6
	Linkedin format: Bugfixes for reading {SHA}-style pot entries.
	Disable UTF-8 checks when -enc:raw.
	Optimization for registering dynamics. Shaves the number of calls to
	  dynamic_IS_VALID() by half (from 10,000).
	Print hash counts to stderr for --show=invalid. See #1773.
	Update INSTALL-UBUNTU (after I did just that).
	Drop summary line from -show=invalid - it's not populated at all.
	Add parsing of 1800.11 -> Catalyst 15.9.
	Fix and improve OpenCL logging.
	OpenCL: Force saving of kernel "binary" with env DUMP_BINARY. This
	  will have kernel's name with ".bin" extension added, stripped from
	  any path (so will end up in current directory). It will also
	  over-ride the caching we sometimes do for non-nvidia devices (the
	  nvidia driver caches for us).
	OpenCL bug fix (or just rigidity fix) for auto-tune.
	Add full Unicode/codepage support for NT-opencl, including for mask
	  mode with --internal-encoding. See #1037.
	Mask mode: If mask contains UTF-8 characters, require
	  --internal-encoding so we don't get false negatives from improper
	  use. See #1037.
	--show=invalid counted incorrectly. See #1773.
	Add full Unicode/codepage support for mscash-opencl, including for
	  mask mode with --internal-encoding. See #1037.
	New DEScrypt OpenCL code: Portability macros for %zu.
	Comment out the silly "Get key error!". I have only ever seen false
	  alarms and Sayantan wont even comment it. See #1037.
	Fix a bug in all UTF-8 conversions on GPU. We are processing strings
	  that are not NULL-terminated, yet checked for NULL in some places
	  instead of checking length. The result was a performance drop.
	OpenCL: Add one more instance of "spinning wheel" cursor for slow
	  benchmarks with --test=-1 (force all "many-salts" test).
	Mask mode debug stuff.
	Code style: Don't write pointers as multiplications.
	OpenCL autotune: Fix bugs when LWS is required to be a power of 2.
	NT-OpenCL: Use shared auto-tune.
	OpenCL auto-tune fixes. And a hack: If mask mode is active, we
	  decrease max duration to a tenth.
	AC: Change AC_CHECK_LIB tests from "!= no" to "= yes".
	Put OpenCL UCS-2/UTF-16 support selection under the wings of
	  ./configure. Closes #1779.
	DES-opencl cleanup, and a tweak in shared code. Closes #1778.
	MSCash-OpenCL: Use shared auto-tune. See #1037.
	Revert "MSCash-OpenCL: Use shared auto-tune. See #1037."
	MSCash-OpenCL: Use shared auto-tune. 2nd try, see #1037.
	mscash-opencl: Unicode salt support and test vectors. Closes #1781,
	  see also #1780.
	Bump SALT_HASH_LOG from core's 12 to 20.
	Makefile.in: Add recent loader.o dependency for base64_convert.h.
	OpenCL: Unicode/codepage fixes (edge cases, even literally) for mscash
	  & NT formats. Both formats now pass systematic testing (TS).
	Workaround for AMD problem with mscash-opencl. Closes #1780.
	gcc-4.4.7 complained about me breaking strict aliasing rules in
	  mscash-opencl. I agreed to disagree but had to fix it anyway.
	Fix some mis-match between mask mode and its documentation. Also
	  deprecate ?h and ?H in favor of ?B and ?b since ?b is used by
	  Hashcat.
	Mask mode fix: If a custom mask placeholder was defined containing
	  UTF-8 characters, we bailed out for "internal encoding required"
	  even when that placeholder was not actually used.
	OpenCL common code: Ensure use of portable basename().
	Drop spurious file add by Jim
	Fix bug when using default (from john.conf) mask, and some other cases
	  of hybrid/pure mask & regex modes.
	Mask: When iterating over length, optionally emit a status line after
	  each length is done.
	SHA-256 intrinsics: Reverse 4 more steps for another 3% boost. This
	  can't be done for SHA-224.
	Mask mode: Tweak an error message for easier understanding.
	SHA-512 intrinsics: Reverse 4 more steps. This can't be done for
	  SHA-384.
	MSSQL12: Reverse seven steps.
	MSSQL12: Non-SIMD fixes after last commit.
	Mask mode: Change "internal encoding" error output to be more
	  specific.
	Deprecate -internal-encoding in favor of -internal-codepage, for
	  clarity. Change corresponding john.conf option
	  DefaultInternalEncoding to DefaultInternalCodepage. The old option
	  names are still supported (and will be for a long time). Also
	  refactors the related variables.
	OpenCL auto-tune: Tune with GPU-side mask, when applicable.
	Autotune: Print Gp/s instead of a wall of digits.
	Pacify an idiotic warning.
	Revert most of the recent auto-tune-with-mask patch. Regression-tests
	  revealed it already happened, LOL.
	Cross-compile fixes for 'ar' and 'strip', and for using DESTDIR for
	  bash (and zsh) completion. See #1783.
	Change most opencl_build() calls from Sayantan's formats to
	  opencl_build_kernel() so they cache like the other formats.
	OpenCL: Use a hash of parameters when deciding a cached kernel file
	  name, instead of creating filenames that exceed all sane limits. And
	  since the hash also includes the actual full source, we get extra
	  "security".
	Bugfix in our implementation of RC4.
	NT-opencl: Use our optimized MD4 macros. See #1729.
	mscash-opencl: Use our optimized MD4 macros and the rotate function.
	  Closes #1729.
	hmacmd5.h "bugfix": do not depend on caller including md5.h.
	krb5-tgs: Major cleanup, code-style, stop re-inventing the wheel, fix
	  major and minor bugs, add proper Unicode conversion, add OpenMP
	  support, much less promiscuous valid().
	OpenCL NT & mscash: Copy-paste bug of sorts.
	Further boost for krb5-tgs format.
	Cosmetic fixes in kirbi2john.py.
	Complete the implementation of FMT_REMOVE. Closes #1793.
	Minor enhancement of FMT_REMOVE code. See #1793.
	Update docs for OS X 10.11 "El Capitan".
	OpenCL bug fix. 57a6cce change a buffer to alloced memory but we were
	  still using sizeof() on it. Closes #1797.
	Fix a bug in --reject-printable for split formats.
	Revert "mask: ETA was 1/x the correct time in -fork=x mode"
	Try to get rid of the Travis CI failures occurring ever since 09f7f91.
	Bugfix for --test-full
	Revert "Try to get rid of the Travis CI failures occurring ever since"
	Myrice's OpenCL formats: Hopefully fix intermittent failures on CPU
	  devices.
	Implement LOP3.LUT as inline PTX, but do not enable it (not yet seen
	  doing any good - only tested for md5crypt).
	DUMP_BINARY environment variable over-rides any normal binary caching.
	CUDA WPAPSK: Bugfix after get_hash macros was introduced.
	Common OpenCL: Fix a potential memory leak.
	lotus5-opencl: Drop that weird "PADDING" thing. This alone seemed to
	  fix all problems - closes #1726.
	Revert "configure: changed != xno to = xyes for some display results
	  (crypt, mmap)"
	Bump dynamic's DYNA_SALT_HASH_BITS to same as SALT_HASH_LOG.
	Add proper logic for enabling LOP3.LUT (although we still don't
	  actually enable it because only regression was seen).
	Minor CUDA fixes.
	Tweaks for LOP3.LUT. Refactor the function to lut3() like what Roman
	  used in published DES BS s4. Always expose that function (if
	  available).
	Add kernel filename to "Options used" when building OpenCL kernels.
	DES & LM bit-slice OpenCL: Implement DeepLearningJohnDoe's LUT3
	  s-boxes, but with s4 replaced with Roman's published one (one less
	  gate).
	Shared OpenCL MD4, MD5, SHA-1 and SHA-2 code: Optional explicit
	  LOP3.LUT.
	Stop mis-using the "warn" parameter of opencl_build_kernel. It's for
	  kernels that take like over 10 seconds to build.
	Stop mis-using the "warn" parameter of opencl_build_kernel (one last
	  format that was missed).
	Use Makefile logic to copy/update OpenCL stuff to run/kernels.
	Tweak Makefile logic for OpenCL stuff in run/kernels.
	Tweak Makefile logic for OpenCL stuff in run/kernels.
	Revert recent Makefile changes. They are problematic.
	I seem to have a bad hair day.
	Fixes for generation of Makefile OpenCL dependencies. Also updates
	  most other dependencies (auto-generated with plugin_deps.pl)
	Fix a mis-leading notion in list=build-info.
	Mask mode: Default to emitting status when switching length. And fix
	  some progress reporting issues.
	Use __FUNCTION__, not __func__.
	Some no-ops while trying to work out what's wrong with lotus5. Looks
	  like an nvidia driver bug. Intermittent failure when not
	  auto-tuning. See #1726.
	Yet some tweaks required for OpenCL dependency generation.
	Extra pot-file feature: When traversing directory, only consider files
	  with extension of ".pot". This is how the Windows code path already
	  handled it. Also, accept symlinks. And clean up code, moving this
	  to its own function to avoid indenting off screen... Closes #1623.
	Windows fix for extra pot files. Windows does not grok symlinks.
	Using S_IFLNK applies to lstat(2), not stat(2).
	john.conf comment grammar fix.
	Unicode core files overhaul: Code-style fixes and tweaks.
	--stdout: Allow using a codepage output encoding.
	External mode: Optionally support handling UTF-32 characters,
	  converted to target encoding just before crk_process_key(). This
	  speeds up things like -external:dumb32 with 4x and opens up for
	  plenty of other tricks.
	Dumb16/32 and Repeats16/32 external modes: Use new UTF-32 external
	  mode feature. 4x boost (or even more if target encoding is a
	  codepage).
	Implement a proper lut3_64() function, using two 32-bit ops.
	OpenCL: Use bitalign for ror64() in shared code and in Myrice's
	  formats. See #1819.
	The bitalign-rotate can't be used with vectors.
	opencl_mask_extras.h: Pure whitespace clean-up.
	Missed tab in whitespace clean-up.
	Pot sync tweak for split OpenCL kernels.
	Add a trivial script for calculating truth table for
	  _mm512_ternarylogic_epi32 or LOP3.LUT. Example:
	Some mostly no-ops and whitespace noise while trying to nail the
	  nvidia LOP3.LUT bug.
	LOP3.LUT bug fixes. Wasn't a driver bug... was PEBCAK!
	Bugfix in the example in comments of truth.pl...
	Enable LOP3.LUT for SHA-1 formats.
	Stop using cl_nv_pragma_unroll for detecting nvidia; it does not work
	  on OS X. Also update mscash2-opencl with optimized functions.
	truth.pl: Optionally show all alternatives for LOP.LUT3 (or AVX-512
	  ternary) truth tables.
	Regression fixes for LOP3.LUT. We can't use that inline asm function
	  with vector variables.
	Add SaltLen to new dynamic_1034. See #1825.
	Poke a little at Myrice's formats to get rid of intermittent failures.
	Usage blurb tweaks. Thou shall not hit 80th column (not even counting
	  from 1, due to Windows' silly terminal).
	Allow "-test -mask" for benchmarking GPU-side mask mode performance.
	  Currently, self-tests are not performed when this is used. Mask can
	  be given or the default one from john.conf will be used. See #1822.
	Enhance the "-test -mask" feature. See #1822.
	Tweaks for --test --mask. See #1827.
	Auto-tune tweak for mask mode. See #1827
	Mask mode ETA bug fix: mask_tot_cand is supposed to hold total
	  multiplier *including* GPU-side. Parent modes' progress reporting
	  depend on it.
	Some refactoring of mask mode global names, per code style.
	Mask mode: Decrease max. number of placeholders from 255 to 127. This
	  still supports the global core max length of a plaintext and should
	  help footprint and locality.
	Implement a shared OpenCL function to get a very rough "speed index"
	  for an OpenCL device, and use it to tune mask mode. Closes #1831.
	Global tweaks to recent mask mode tuning logic. See #1831.
	Print our "speed index" estimation in --list=opencl-devices. See
	  #1831.
	More tweaks for mask tuning. See #1831.
	Mask benchmark tweak. We won't generate candidates longer than
	  format's first test vector.
	Hack fix for #1828.
	Put a max-length test vector first in LM-opencl for better auto-tune.
	mscash-opencl: First test vector should be length 8 or so and
	  definitely not a null-string. This is for shared auto-tune reasons.
	Bugfix for building non-OpenCL.
	Reduce default logging for rules and incremental mode. Now -verb=4 or
	  higher is required to get gigabyte size logs.
	Have -stdout call log_init() but imply --nolog. See #1774.
	NT & mscash OpenCL: Avoid double auto-tune for "-test -mask".
	--list=opencl-devices fix. Do not print SIMD width as "stream
	  processors" (although we count it as such for other purposes).
	PBKDF2-HMAC-MD4/5: Allow VLIW5 to use native vector width. The
	  register pressure limitation doesn't apply to these formats.
	krb5tgs format: Bump MAX_EDATA_SIZE, see #1838.
	Implement a function that creates a "struct db_main" from test
	  vectors, and a destroyer for it. See #1835.
	Allow changing or dropping the UTF-8 degree sign in GPU temp
	  printouts.
	Bug fix for the shared check_pkcs_pad() function. This surfaced in
	  form of false positive in dmg (header version 1).
	AMD bug-workaround for SHA-512 formats when using bitalign for
	  ror64(). Closes #1840. Also closes #1834, adding a related pragma
	  needed for older drivers.
	AMD bug-workaround for oldoffice-opencl. Closes #1497.
	Mask mode: Change ?a to frequency-ordered, from Rockyou data. Closes
	  #1842.
	Mask mode: Change ?l, ?u, ?d and ?s to frequency-ordered, from Rockyou
	  data. See #1842.
	Improve handling of UTF-8 "degrees" character in case terminal is not
	  UTF-8. If we know how to output it, do. Otherwise just skip that
	  character. Closes #1841.
	Fix a cosmetic problem with speed figure calculations overflowing
	  32-bit integer under GPU-side mask mode. I already wrote code for it
	  but it was defined out.
	Mask benchmark: Pure mask mode should send a NULL key.
	OpenCL: Cosmetic. Move "speed index" adjacent to its source
	  parameters.
	Copy/paste bug in raw/x-sha512-ng-opencl.
	Tweak the use of setlocale(). We now query the "terminal locale" and
	  store it, but then reset LC_CTYPE to "C" so to not change behavior.
	  See #1841.
	Implement a minor optimization for SHA-512 sigma's, from Intel's "Fast
	  SHA-512 Implementations on Intel Architecture Processors"
	  whitepaper.
	Mask mode: Enable a sanity check that was disabled for
	  backward-compatibility.
	RAR: Mute an irrelevant warning when loading pot entries.
	Decrease log chatter from single mode, like was done with others.
	Fix an autoconf problem resulting in the CPU detection in john.o
	  wasn't enabled when it should be.
	Add CPU detection for AVX2.
	Fixes for AVX2 detection.
	Another fix for AVX2 detection.
	Mask mode: Fix incorrect use to CTYPE macros, so ?W will case- toggle
	  according to our active encoding - not just ASCII.
	--list=build-info: Show fallback binaries.
	Bugfix for MPI vs. fallback binaries. We must not initialize MPI until
	  we are running the "final" binary.
	OpenCL shared header bugfix: OLD_NVIDIA was defined on all non-nvidias
	  too.
	Add cpuid tests for SSSE3, SSE4.1, SSE4.2, AVX512F and AVX512BW.
	CPU detection fixes. We drop the check for SSE4.2 because only one
	  format needs it - that one should have a run-time check instead.
	More CPU detection fixes. A bit more thorough.
	Require AVX for CRC32C intrinsics (only SSE4.2 is needed but we don't
	  want to add another CPU fallback case). Closes #1856.
	Minor fixes to Myrice's formats.
	Salt cleansing bugfixes.
	Bugfix for plugin_deps.pl, do not recurse autoconfig.h file. Closes
	  #1860.
	oldoffice-opencl: Move benchmark logic out of salt.
	pkzip: Fix a problem caused by the format changing the salt after
	  get_salt. We still do so, but leave that part out of the active
	  "dynamic salt" part for compare purposes. Otherwise we get problems
	  with pot sync and other things. Closes #1862.
	Mask mode: Fix a problem with resume sometimes missing candidates.
	  This should now be 100% safe. Closes #1859.
	Exclude Myrice's formats from Travis CI testing. It's got to be a
	  driver bug causing all trouble with them. Also ditch the
	  Formats_base thing, it was just confusing. Better learn the
	  difference between putting [Disabled:Formats] vs.
	  [Local:Disabled:Formats] in your john-local.conf! The former
	  replaces the original list while the latter adds to it.
	Add some safety in dynamic parser code. See #1863.
	Do not assume that char is signed. See #1863.
	Mask mode: Ensure that things like ?l?u (eg. the default mask) only
	  produces a single case for case-ignoring formats.
	AC: Do not use \b with sed, apparently it's not POSIX and it doesn't
	  work with OSX. Closes #1867.
	Fixes for OSX El Capitan and CUDA 7.5. Closes #1868.
	Enable showing memdbg summary with MEMDBG environment variable. See
	  #1872.
	Fixes for our local stdint.h. Add intmax_t and uintmax_t as we now use
	  them in Jumbo. Also use compiler macros like __INT32_TYPE__ if
	  available. Finally, remove a clash in math.h from core.
	arm32le.h: Do not define SIMD_PARA_* when we don't have NEON. See
	  #1874.
	Assorted signed/unsigned bug fixes. See #1874.
	Drop unused Blake2 functions. See #1874.
	Move the nefarious LUKS test vectors to a separate file. #1861.
	Split lines of luks_insane.tests.h so not to break havoc.
	Add filename to cisco2john output, in id field.
	Fix algorithm name of Azure AD format.
	Fix algorithm name of Azure AD format, this time to the correct one.
	Simplify OpenCL SHA-1 (unsplit) kernel a little.
	Add a john.conf option AbortGraceTime for tweaking behavior of
	  --max-run-time=N option. Closes #1638.
	Add Truecrypt-opencl format. First cut, only RIPEMD-160 yet and for
	  some odd reason it's only a quarter the speed of Hashcat's as of
	  now. See #1344.
	Optimizations for Truecrypt-opencl format.
	pass_gen.pl: Honor -loops when generating bitcoin
	Assorted hybrid resume fixes. Closes #1859.
	Do not call wordlist's hybrid fix_state unless we are actually running
	  wordlist as parent mode.
	Fix SessionFileProtect for batch mode. Closes #1774.
	Consider the "Extra potfiles" not only when loading hashes, but also
	  for other things like -show and -loopback. Closes #1808.
	Revert "Have -stdout call log_init() but imply --nolog. See #1774."
	Revert "Hack fix for #1828."
	List:Extra.Potfiles bugfix for --loopback (allow using loop_db).
	john.c: Comment on a non-obvious line of code.
	Log the command line used for session. It will be expanded from
	  abbreviations and unified to using '=' and not ':' as option
	  separator.
	Finally, fix the Jumbo options-reset problem (when resuming)
	  canonically.
	Fix a nasty bug in oldoffice-opencl where type 4 would never crack.
	  Closes #1881.
	Change dyna salt formats to use fmt_default_dyna_salt(). Also assorted
	  fixes for dynamic salts, including OpenCL support.
	AC: Test for hyperthreading, if available - define HAVE_HT. Set BF_X2
	  according to the result. Closes #1199.
	AC: The HAVE_HT test was only done for AVX or higher, having bcrypt in
	  mind. But we might want to use it for other things too so this
	  commit makes it unconditional.
	Set BF_X2 to 3 for non-OMP builds, regardless of CPU. See #1199.
	Allow using OMP or CPU fallback without using SYSTEMWIDE.
	Allow using CPU fallback without using SYSTEMWIDE (bug fix, the
	  previous commit only fixed OMP fallback).
	Better fix for #1881. The previous fix worked fine but affected
	  performance.
	Enable oldoffice's source() function, printing mitm hash in case user
	  wants to search for alternate keys. The use of MITM calls for using
	  dyna_salt. Closes #736.
	Bugfix for dyna_salt in OpenCL: Bitfields are not allowed but we
	  actually only need the right size.
	Show different output telling FMT_NOT_EXACT from --keep-guessing.
	Fixes for CPU detection. See #1855.
	[john.c] Clean-up from Jim's constant breaking of code style.
	Disable cpuid checks if CPUID_DISABLE environment variable is defined
	  (at all). See #1855.
	Bug fixes and easier-to-follow code for CPU detection.
	Add 32-bit checks for AVX2, SSE4.1 and SSSE3. The AVX2 check is very
	  quick and dirty, not using leaf 7 nor extended flags but it should
	  be sufficient for a starter. This is UNTESTED but will hopefully be
	  Good Enough[tm] for #1855 for now.
	Remove LENGTH from --markov mode documentation. Closes #1651.
	Document PRINCE mode. Closes #1428.
	configure.ac is not just a bash script.
	Bugfix for 32-bit CPU detection. See #1886.
	[options.c] Portability fix: Include jumbo.h.
	Another 32-bit CPU detection bug fix. See #1886.
	Safer CPU detect for cross compiles. See #1886. Closes #1855.
	Code style fixes for Markov before doing actual changes. This is a
	  no-op.
	Delete Frank's diary from our source tree.
	Code style fixes for Rexgen before doing actual changes. This is a
	  no-op.
	regex fixes for -max-length.
	Add hybrid regex support to markov mode. See #1445.
	Add hybrid regex support to incremental mode. See #1445.
	Add hybrid regex support to PRINCE mode. See #1445.
	Add hybrid regex support to External [generator] mode. Closes #1445.
	[mask.c] Fix for 32-bit builds not getting prince mode.
	Tweaks for legacy builds.
	Fix for 32-bit SSE2 CPU detection.
	Yet another fix for 32-bit SSE2 CPU detection. How hard can it be to
	  get this right? See #1886.
	Don't just "define" things like JOHN_AVX, set it to 1!
	Remove a wall of 32-bit build warnings. The majority were due to a
	  silly macro that was sprayed all over the code base instead of put
	  in one place. Closes #1891.
	Allow using external (generator) mode as hybrid parent. Closes #1889.
	Allow using regex mode as parent to hybrid mask. See #1890.
	Allow hybrid regex *and* mask, using a third mode as parent. Mask is
	  last since it can accelerate GPU. Closes #1890.
	Update documentation of Jumbo cracking modes with regex, stacking and
	  some other details.
	More updates on documentation and usage blob.
	Mask mode: Avoid internal key buffer being thrashed by external
	  filter. Closes #1893.
	PRINCE had same external filter bug as mask mode, see #1893.
	john.conf typo.
	Stupid bugfix for CPU detection. I did not notice that SSE2 flag was
	  in EAX while SSSE3 and SSE4.1 flags are in ECX, so I ended up
	  erroneously checking the xsave flag (and testing would not reveal
	  the problem when cross-compiled on newer machines...
	CPU detection: Cosmetic (comments, and rename a confusing label).
	Bugfixes for -test -mask.
	OpenCL SHA-1: Concentrate an AMD workaround to within the SHA-1 header
	  only.
	MPI bugfix for OMP fallback.
	[pass_gen.pl] allow specified -salt shorter than 8.
	Bugfix for vectorized use of OpenCL SHA-1 after recent change.
	Much nicer code for previous commit: Use __typeof__() keyword.
	WPAPSK-OpenCL: Revert to using AoS, for working around AMD bugs.
	  Closes #1905.
	Fix a couple of problems with --pipe mode when using tty for input.
	Windows fix for "label at end of compound statement".
	HMAC-SHA256: Support up to 183 characters of salt. Closes #1904.
	Reduce (default) chatter from descrypt-opencl.
	Allow muting status output for GPU temp, utilization and fan
	  individually.
	Fix a bug in loopback mode that caused a segfault in case the
	  assembled LM halves alone would crack 100% of the hashes.
	SAP G bugfix. See #1917.
	SAP G, add headroom for 4-byte UTF-8. Closes #1917.
	[listconf.c] Move --list=opencl-devices to listconf_parse_late() so we
	  can get things from john.conf.
	Bugfix in NTLMv1/MSCHAPv2 naive formats. Closes #1923.
	Scrypt (Jumbo-specific input format) and PBKDF2-HMAC-MD* formats:
	  Avoid using dupe test vectors. They triggered false positives in the
	  Test Suite. Closes #1913.
	Fix a rename in 9215a07e that ended up incorrect.
	  cryptsha512_kernel_GCN.cl was renamed to "unused" instead of moved
	  to "src/unused/".
	Fix a clash between mscash2-opencl multi-device support and "Poor
	  man's multi-device support". Closes #1920.
	Allow LDAP-style raw MD5. See #1613.
	Drop nsldaps-opencl and unify salted-sha1-opencl with shared code. See
	  #1613.
	Drop nsldap-opencl and unify raw-sha1-opencl with shared code. Closes
	  #1613.
	Update CHANGES-jumbo.git and CREDITS-jumbo. See #1911.
	Workaround for Intel for our use of typeof() in OpenCL.
	Try not to fail if we can't install fglrx-dev.
	Bump OMP_SCALE for PHPASS. See
	  http://www.openwall.com/lists/john-dev/2015/12/06/1
	Slight change in -list=format-all-details output to avoid confusion.
	Use a "fake db" for self-test and benchmark.
	NT-opencl: Drop all special code for self-test, and use the new "fake
	  db".
	Pass db to OpenCL auto-tune, use db->salts in all crypt_all() calls.
	mscash-opencl: Drop special code for self-tests (using db from test
	  vectors)
	Fail self-test if we can't find a test vector salt in the test db.
	Bugfix and problem workarounds for ldr_init_test_db() "fields"
	  assembly.
	Add a hack for muting messages from oldoffice-opencl's source() while
	  loading test db.
	Fix a (benign) memory leak in cryptsha256-opencl. Closes #1945.
	[unrarfilter.c] free() -> MEM_FREE(), closes #1942.
	Unicode/codepage improvements for letters that doesn't have any case.
	If one of -min-len or -max-len is given to mask mode, give the other a
	  default of format's min/max length. Closes #1947.
	Add memdbg.o dependencies. Closes #1944.
	Add a couple more memdbg.o dependencies. Closes #1944.
	Correct fix for f3113f21
	Tweak some macros in shared OpenCL code.
	NT: Do not use local memory for OS X with nvidia. The actual criteria
	  is unknown, but this was seen better on a Macbook with GT 650M.
	Driver bug workaround for GPU-side UTF-8 conversion on OSX with
	  nvidia. Unfortunately this halves the performance, but only when
	  UTF-8 is used and no internal codepage is active. Closes #1857.
	[common-gpu.c] Increase a couple of printf buffers, and drop some
	  orphaned code. Closes #1950.
	OpenCL sensor status: Increase another sprintf buffer, avoiding
	  possible overruns. See #1950.
	hmac-SHA256: Move a test from split() to valid(), and other minor
	  fixes.
	Add README-DISTROS for more detailed fallback build instructions. Also
	  tweak strip and install targets as well as autoconf handling of
	  --prefix option. Closes #1656, closes #982.
	Usage blurb: Move -test-full to "hidden" options and update its
	  wording. Move -costs from "hidden" to standard options (along with
	  -salt et al).
	wpapcap2john: Add option for manually specifying ESSID:BSSID pairs in
	  case there are "hidden" networks or your sniff file lacks beacons
	  for some other reason.
	Wordlist: Speed up fix_state when memory buffered. See #1955.
	Add some comments in unrar.c documenting a false positive from ASan.
	  Closes #1962.
	loader.c: Do not prune test_db from --cost. Closes #1961.
	loader.c: Do not prune test_db from --salts. See #1961.
	Increase verbosity level needed for testdb output.
	Avoid undefined behavior for signed integer in rpp.c. See #1963.
	Reduce chatter from descrypt-opencl and also introduce some macros for
	  verbosity levels. Closes #1968.
	Bugfix for some cases where self-test messages over-ran buffers.
	HMAC-SHA384/512: Bump max salt length and support JWT hashes. Closes
	  #1898.
	Update INSTALL-UBUNTU document not to use an older rexgen version
	  anymore.
	Fix some whitespace that was thrashed by f3cd0e63
	Allow $HOME to override the home directory (eg. ~/.john) in
	  JOHN_SYSTEMWIDE builds. Closes 1901.
	The length sorting in RAR3 was ineffective unless we bump mkpc a lot.
	OpenCL: Turn an Apple-specific fallback into a generic one. Some
	  clustering solutions may prohibit use of vendor-specific extensions.
	--list=opencl-devices: Add AMD wavefront width.
	Use realpath() for evaluating absolute path for OpenCL -I./kernels.
	  This is needed for some cluster environments like VCL but might
	  break other use cases. We may want a john.conf option for it.
	Common OpenCL code: Decrease scope of platform struct, and some other
	  minor tweaks.
	Common OpenCL code: Bug fixes and tweaks for VCL. Closes #1989.
	Fix bug in default GPU selection introduced by 0a026d5. Closes #1995.
	Mask.c, fix multiple problems with progress/ETA. See #1996.
	doc/MASK: Document the special ETA behavior when iterating over
	  lengths. See #1996.
	Conditionalize an AMD workaround. Closes #1994, see also #1497.
	Change all use of __ARM_NEON__ to __ARM_NEON. See #1998.
	RC4 bugfix for decrypting more than 256 bytes with RC4_single().
	Unicode: Minor bugfix for detection of invalid UTF-8 sequences. Also
	  drop some local copies of valid_utf8() in favor of the shared one.
	leet.pl: chmod +x
	cracker.c: Remove sourcing of SSE2 header obsoleted by recent merge of
	  master branch.
	loader.c: Unify ldr_init_password_hash() with John Proper (some
	  variable names differed).
	Drop pristine ADL SDK files from our source tree and provide our own
	  header, supporting NVIDIA as well as AMD and free to distribute
	  under the "fair use" doctrine.
	Support ADL on Windows (untested).
	undrop bug fix: hash length is length 13 including the '+'. Closes
	  #2011, thanks to shrikus.
	OpenCL: Generic workaround for OSX driver bug. Fixes many formats.
	--list=opencl-devices, add SIMD width for AMD devices.
	recovery.c: Avoid a race condition between closing a finished session
	  file (which releases our lock on it) and unlinking it.
	Some tweaks for 1be1841: Support $JOHN path, set execute bit on
	  script, drop length limit and decrease score of variables.
	Revert "Some tweaks for 1be1841: Support $JOHN path, set execute bit
	  on"
	Oldoffice formats: Fix for --show vs. legacy MITM data in input files.
	pass_gen.pl incorrectly required Crypt::ECB to be installed even when
	  not needed.
	hmac-MD5: Bump max. salt length to 183.
	Oldoffice: Optimization for dupe salts, similar to what we do for
	  WPAPSK but with a lot less gain.
	Don't try to use typeof() with Intel OpenCL.
	office2john: Handle old Word "0Table" vs. "1Table" properly.
	Fix a problem with sequential dupe suppression in rules, when internal
	  codepage is used.
	Fix for rules' consecutive dupe suppression of candidates containing
	  non-ASCII characters when using --internal-codepage. See 4faaba9.
	Do not delegate hashes to generic crypt format unless specifically
	  requested. Closes #2069.
	External mode filter: Support UTF-32.
	External mode max-length fixes. See #2072.
	External mode: Code style fixes and avoid unneeded differences from
	  core.
	Drop support for deprecated -internal-encoding option (replaced by
	  -internal-codepage) except we still recognize it in restored
	  sessions.
	Bugfix for --skip-self-tests. See #1967 and closes #2090.
	CUDA fixes for macro-redefinitions. Problem likely introduced in
	  ad2e4727.
	Pot sync performance fix: Use strnzcpy() instead of strncpy(). This
	  was found by comparing a run with LINE_BUFFER_SIZE at 0x400 instead
	  of 0x30000.
	PRINCE: Allow a negative max element count. This will make the
	  effective max depend on each password length. For example, using
	  -prince-elem-cnt-max=-2 the effective max will be 3 at length 5, and
	  4 at length 6.
	Mask mode: Tweak mask-stretching. Hopefully addresses #1983 a little
	  but does not fix all situations.
	Wordlist mode: Ignore UTF-8 BOMs. Closes #2138.
	Fix long standing bug in --pipe mode vs. encodings.
	Implement --max-run-time-reset option that complements
	  --max-run-time=N. The new option resets the timer on each crack so
	  session aborts after N seconds of not cracking anything. Closes
	  #2139.
	Drop the --max-run-time-reset option and instead include that
	  functionality in --max-run-time=N where N is a negative number. See
	  #2139.
	OpenCL: Recognize nvidia Pascal series (ie. the cores per MP count).
	Drop some noise from dlopen definitions.
	Add number of PCI lanes to --list=opencl-devices.
	fgetll() needs to use size_t for size, not int.
	Quick-hack for rar2john so it always inlines.
	Temporary (?) hack to speed up fgetll() considerably. We switch to
	  using realloc and we also double the chunk size each time. The con
	  is we may end up allocating almost twice the needed memory, worst
	  case. However, that's just virtual memory and the over allocated
	  memory would never be touched.
	Minor tweaks to logger.c and loader.c: Do not depend too heavily on
	  LINE_BUFFER_SIZE and avoid undocumented arbitrary figures for
	  margin.
	More formats fixed for truncated pot lines. This includes OpenCL
	  versions.
	fgetll(): Safer realloc, and don't let the block size exceed 128 MB.
	  Also WAY faster (incremental) strlen.
	Get rid of $SOURCE_BIN$. Pot entries are now always shorter than
	  LINE_BUFFER_SIZE (including the field separator and plaintext).
	keepass2john & zip2john: Always inline. Also some clean-up of rar2john
	  that had a quick hack earlier.
	Bug fixes for handling oversized sources.
	Bugfix for zip2john for arbitrary length files. This is somewhat of a
	  hack but if the alloc fails we can't recover anyway. We'll just
	  crash and burn.
	rar2john bugfix
	Replace the ZIP optimization that was lost in 528e6bc, for a 3x boost.
	  Also implements the same for OpenCL (we never had it there). Closes
	  #2141.
	Apparently Pascal has 128 cores per SM, not 64. This explains why I
	  couldn't get the figures to sum up. Still, I see many references to
	  64 when googling.
	Potsync fixes for truncated pot entries.
	Revert "crypt: problems with #defines and strdup"
	Avoid warnings if re-defining feature macros.
	Fix CUDA build after e78d6ef, closes #2157.
	Fix a long standing bug with -< rule reject when -min-length is not
	  used. This bug had little consequence until Jim implemented the
	  Hashcat rules recently.
	Recovery.c: ASan "read" bugfix.
	rules.c: Do not opportunisticly enable Hashcat rules mode. Use a safe
	  "nullstring" buffer for reading past (ASan "read" problems). And
	  define out a whole section that handles pre-processor stuff (should
	  never be encountered anyway!).
	o5logon: Verify correct password, support Oracle 12 and early-reject
	  wrong-length candidates where possible.
	kerberom.py: Move shebang-line to top (otherwise it has no effect) and
	  chmod +x.
	Fix a silly bug affecting resumed sessions. A few values set from the
	  config file (notably options.reload_at_crack) was zeroed on
	  resuming. A similar bug was fixed in 6a543435 (reducing the memset
	  size) and I should have spotted these extra resets at the time.
	  Alas, I did not.
	Re-enable some HC rules parsing without explicitly setting hc_logic,
	  and drop an obsolete section of code. This is a partial reversion
	  and partial continuation of e04c0c8.
	VMS/UAF: Avoid portability problems with VMS macros containing '$'.
	  Closes #2154.
	Add usage blurb and docs for providing rules at command line for
	  single mode. See #2105.
	Revert "base64_convert.[ch] More work on size_t. commmon.[ch]
	  reverted"
	Revert "base64 (and common) changed int into size_t where needed"
	Optimization for --loopback mode when hitting old, very long pot
	  lines. See #2160. We now return a null string instead of a truly
	  useless portion of truncated cipher text.
	loader.c: Use an existing macro instead of mimicking it.
	Don't use abs() on return from hexlenl(). The latter now returns
	  size_t.
	OpenCL: Don't try to enable cl_amd_media_ops unless it's actually
	  supported by the driver (eg. MESA does not).
	OpenCL: Avoid using 'inline' with MESA in some cases. See #2204
	Change algorithm_name of raw-md5u from "unicode($p)" to "utf16($p)" so
	  it matches other formats (eg. dynamic_29).
	Briefly document the --format=@keyword syntax.
	--show=invalid was no longer working correctly.
	hmailserver and pkzip formats: Fix whitespace violations, some of
	  which bad enough to result in compiler complaints. Supposedly closes
	  #2217.
	Recognize MESA even if it's written as Mesa. See #2204.
	Drop some "tedious truths" from OpenCL common code.
	WPAPSK format: Whitespace cleanup.
	jumbo.h declared our own atoll() in a way that could clash with
	  system's. See #2198, #2201.
	CUDA wpapsk format had a borken adoption to new FMT_MAIN_VERSION in
	  9423af68. Even before that, the format was borken all the way since
	  f024c0a6 due to loader.h being inadvertently sourced (the rest of
	  the bogus changes were reverted but not the #include) and CUDA can't
	  cope with loader.h for some reason or the other. Closes #2198,
	  #2201.
	zip2john: Add support for CRC and lengths only stored in the Data
	  Descriptor following the file data.
	Blind try to fix a MinGW problem in CircleCI.
	Makefile.legacy: added jumbo.o to genmkvpwd for non-atoll systems.
	  #2220
	gpg2john: Drop dependency on LINE_BUFFER_SIZE. But we still have a
	  hard deck defined as BIG_ENOUGH (@kholia[tm]) which was also bumped
	  from 8192 to 64K. See #2218.
	Ensure static unicode arrays are declared as external anywhere but in
	  unicode.o. See #2086.
	Don't use well-known name DECLSPEC for other purposes than people are
	  used to. Changed to EXTATIC meaning either static or extern ;-I
	DEScrypt-opencl: Get rid of a few compiler warnings from picky
	  run-time compilers (eg. OSX).
	Drop an unused variable from salted_sha_kernel.cl.
	ZipMonster format: Tried to get an aligned auto variable. We know that
	  isn't safe. Closes #2202.
	OpenCL: Handle spaces in include path. Closes #2222.
	Some no-op changes to unify raw MD4 and MD5 OpenCL formats for easier
	  comparison (trying to nail #2181).
	Ensure no format ever processes > 4G keys per crypt (including
	  GPU-side mask) because the *pcount return can't hold it. Closes
	  #2181.
	Mask mode: Fixes for "-test -mask", closing #1828 and #1835. Also
	  fixes some other glitches.
	Argon2 formats: Do not print diagnostics unless verbosity was bumped.
	argon2 files: Fix memdbg (plus whitespace violations that my emacs did
	  automatically while at it).
	Drop the borken idea of $BIN_HASH$ yet again. Do not add it again,
	  it's NOT THE SOLUTION.
	Use $SOURCE_HASH$ truncation of test vector's ciphertexts in
	  --list=format-[all-]details. Prior to this commit, they were simply
	  chopped to 256 or 512 bytes.
	Fix for $SOURCE_HASH$ with formats having a binary that gets lost or
	  truncated when "pot-chopped".
	Fixes to formats that may get their binary chopped by $SOURCE_HASH$.
	  See #2117. Note that some formats don't need fixes because their
	  binary comes early enough that it won't get truncated - one example
	  is the SXC format.
	Fix pot sync for truncated pot lines. This code was missing from
	  #2196.
	Revise verbosity levels. Closes #2230.
	Fix Redmond whitespace violations in potcheck.pl, for crying out
	  loud...
	potcheck.pl: Bugfix for long lines, enable verbose option, disable
	  undocumented/unimplemented options, add verbose output.
	rar2john edge case fix, for RAR3.
	OpenCL formats using "perfect hash tables" can't be used with single
	  mode cracking. Bail out with an error instead of potentially hanging
	  indefinitely. Closes #2232.
	Alternate hybrid external mode 'HybridLeet' by Christien Rioux (See
	  #2099).
	Revert a hideous bug Jim accidentally planted in my reference $0$
	  format in 8c48877. This wasted hours of my life searching for
	  apparent core bugs and the format is forever ruined for use with git
	  bisect (which was its primary use). Bad_day.mpg
	Fix for MESA trying to evade detection. See #2204.
	OpenCL: Device-detection fix for MESA. It gives us upper-case device
	  names. See #2204.
	OpenCL: Refactor a reused codepage macro and move to opencl_unicode.h
	OpenCL: Better shared-code support for nvidia Pascal.
	Fix for another bug introduced in 8c48877.
	Renamed oracle9i_fmt_plug.c to o3logon_fmt_plug.c (no other changes).
	o3logon: Change format struct name. Fix some potentially expensive
	  code in valid().
	Add a 'dump_stuff' debug macro for *char to opencl_misc.h.
	ntlmv2-opencl: Preparation for gpu side mask. Drop vectorization
	  support. Reduce to a single kernel. Move the final hmacs to a
	  separate function.
	ntlmv2-opencl: Implement gpu side mask & compare. Speed now more or
	  less on par with Hashcat, despite our format fully supports Unicode.
	pass_gen.pl: Fix a UTF-8 bug introduced in 27ecb1d.
	pass_gen.pl: Proper code for allowing user to say -codepage=UTF-8
	  instead of the short-cut -utf8 (which worked).
	Autoconf: Fix a bug introduced by Jim in 154314c causing int128 to be
	  always disabled.
	config.c: Avoid multiple warning/error output with fork/MPI
	OpenCL: Minor tweak to GPU-side mask auto-tune output.
	zip2john: Fix a bug introduced in 744cdb91 by yours truly: File magic
	  could not be used.
	oldoffice-opencl: Some optimizations for good measure. Not much
	  difference.
	GPU-side mask formats: Fix an edge-case bug.
	pass_gen.pl: Again, don't require obscure libs unless actually needed.
	  This is a quick fix, the real solution is not to depend on these at
	  all. Problem introduced in 030e303.
	OpenCL mscash & ntlmv2 formats: Drop a few redundant lines.
	o3logon format: Use a truncated salt instead of segfaulting in case
	  user runs a codepage-encoded input file with encoding set to UTF-8.
	  See discussion in #2243. Closes #2243.
	ntlmv2-opencl: Simplify code after recent change.
	Many OpenCL formats: Change comparisons with constants according to
	  coding style. Nothing effectively changed, just easier to read.
	pkzip format: Bugfix and improvement of SWF file magic.
	john.conf: Update AMD driver info. Apparently we can't tell 15.11
	  (beta) from 15.12 (release) with just OpenCL queries. I presume the
	  OpenCL part of them is identical.
	OpenCL: Fix a bug with Global_MaxDuration. See #2204.
	ZIP formats may have their binary truncated in pot file, so can't use
	  hash funcs. Closes #2245.
	Some more formats that may have their binary truncated in pot file, so
	  can't use hash functions. See #2245 et al.
	Add a self-test for catching formats that may get their pot entries
	  truncated, but use get_hash(). See #2245, #2117 et al.
	Last bunch of formats (that the self-test could detect) that may have
	  their binary truncated in pot file, so can't use hash functions. See
	  #2245, #2117 et al.
	OpenCL RC4: Very odd way of gaining a 4x boost, nicked from Hashcat.
	oldoffice-opencl: Prepare for GPU-side mask/compare.
	oldoffice-opencl: Implement GPU-side mask. Speed now more or less on
	  par with Hashcat, despite our format fully supports Unicode. #1845
	oldoffice-opencl bugfix: result was not cleared after MITM hit.
	NSEC3 bug fixes. An iteration count of zero is valid according to the
	  RFC. Our crypt_all() would loop for ever if given zero. Closes
	  #2258.
	Ensure reset(realdb) is called with --skip-self-tests. Closes #2256.
	  See also #2090 and #1967.
	Fix some formats that used prepare() for things better done in
	  split(). Some of them even had the functionality in both. See #2254.
	SAP B format: Don't output encoding warning with --list=format-tests
	Fixes for prepare/valid encoding checks/conversions. See #2252.
	as400-ssha1 format: Add a UTF-8 check in valid() since Convert()
	  depends on correct encoding being used.
	Drop a spurious asterisk from AS400-DES format tag.
	Add OPT_REQ_PARAM to a bunch of options that missed it. Closes #2260.
	o3logon format: Drop the prepare. Closes #2254.
	formats.c: Fix a problem with gpu-side mask formats, introduced in
	  1a666cb. Tricky business.
	Opencl formats: Typos in comments.
	krb5pa-md5-opencl: Prepare for gpu-side mask/compare.
	krb5pa-md5-opencl: GPU-side mask & compare.
	More optimized early-reject for krb5pa-md5-opencl. This changes our
	  shared RC4 to no longer hard-code length of decryption at compile
	  time which also affects the oldoffice-opencl format, but this had no
	  impact on performance.
	Update copyright info in OpenCL SHA-1 formats (drop the GPLv2).
	  There's nothing left of Samuele's initial work in them nor is there
	  anything of significance from the projects he referred to.
	OpenCL raw-sha1: Optimizations. Swap binary once before starting
	  crack, instead of wasting time doing literally 25 billion swaps per
	  second for the whole crack run. Also unify raw-sha1 with shared
	  sha1.
	mysql-sha1-opencl: GPU-side mask & compare.
	OpenCL: Drop the option USE_SHA1_SHORT (we always use it).
	lotus5-opencl: Assorted changes trying to nail problems. #1726, #2242.
	Refactor shared OpenCL primitives functions.
	RAR-opencl: Use shared SHA-1 code.
	Bug fix for memdbg builds: The exit checks were never made if session
	  ended with an abort or --max-run-time reached. This seriously
	  limited its use when debugging. Closes #2264.
	Refactor shared OpenCL primitives functions (MD4, MD5).
	On resuming, print brief info from main cracking mode.
	c5c1fd3a broke RAR-opencl for OSX.
	OpenCL shared SHA1: drop unused variables.
	Add yet another "format class" --format=all that overrides anything
	  else (eg. [Formats.Disabled] in john.conf) so you know every single
	  format will be tested/listed regardless of conf.
	Make --format:all more versatile. It now also support things like
	  all-gpu, all-@sha1 and so on.
	as400-ssha1 Unicode test was made too early. No need to complain if
	  we're not seeing "this" format. See #2252.
	office2john.py: Pure whitespace commit (spaces -> tabs).
	office2john: Add handling of a specific problem, so we can continue
	  with other files instead of aborting with error. I'm not sure the
	  problem is with corrupt files or a bug in office2john.
	pass_gen.pl: Errors and warnings should go to stderr.
	pass_gen.pl: Drop/change some spurious old "print" which should now be
	  a return string to unified output function.
	pass_gen.pl: Pure whitespace fixes (spaces -> tabs).
	Mask mode: Correction for an ETA problem when running non-hybrid,
	  fixed length, with node/fork AND with a mask that get truncated due
	  to max length. And only then, whoa.
	Tweak verbosity levels again. We lacked a level between "normal jumbo"
	  and the lowest (1, which even suppress cracks). This new scheme is
	  more future safe: There is currently no level "> VERB_LEGACY" and "<
	  VERB_MAX" but we can easily just bump the max to 6 if we need one.
	office2john: Revert 67d2d385 and also fix .editorconfig so any python
	  files are specified as having silly spaces-indentation.
	Some tweaks for recent chmod change. Simplify code, use POSIX macros,
	  require rw for owner because eg. 0066 will make it unreadable by
	  yourself. Rename IgnoreLogChmodErrors to IgnoreChmodErrors since it
	  affects both.
	logger.c: Code-style fixes, mainly over-long lines.
	e50f748c missed related changes in john.conf.
	logger.c: Portability workaround for Windows.
	logger.c: Portability workaround for Windows, take 2.
	wpapcap2john: Handle pcaps which lack beacons but do have probe
	  responses. They look the same as a beacon (for our purposes) so very
	  easy fix.
	wpapcap2john: Minor cosmetic changes (diagnostics, comments).
	MPI: Show node name with OpenCL device info.
	misc.c: Fix a long-standing #ifdef-logic bug with MPI vs. fork causing
	  pexit() to segfault due to a dangling 'else'.
	Fix alignment in usage blob (problem introduced in 347702b).
	regex.c: Fix a new warning introduced by be39643.
	AC: Add a test for sizeof(wchar_t). Note: If that type isn't available
	  at all, size will be defined as 0.
	Unicode engine: Don't write *pointers as * multiplications, that
	  sucks. This commit is whitespace-only, no real change.
	Regex mode: Fix for recent changes in librexgen. We now properly
	  convert to wchar_t. Closes #2296.
	CUDA: Fix various problems with OSX/macOS.
	Rexgen: Handle internal codepage correctly. See #2296.
	Unicode/wcs bugfix for exotic systems.
	Drop artifact from b64645f7.
	When populating test_db, don't honor --user and --salt options. See
	  #2305.
	Revert a change in mask.c from 6fb81e0 that introduced a bug.
	mask.c: Bug fix for resuming iterated length. See #2306.
	Replace our 7z2john.py with 7z2john.pl (pristine 7z2hashcat.pl)
	Adapt 7z2john from pristine 7z2hashcat
	7zip formats: Allow any data size (drop the idea of BIG_ENOUGH). See
	  #2314.
	Bump SIMD max. salt length in HMAC-SHA256 format to accomodate for
	  some JWT tokens. See #2318.
	Minor fix to office2john. See
	  https://hashcat.net/forum/thread-5739-post-32191.html#pid32191
	Raw SHA-1 formats: Revert to unifying to hex, not Base-64. It had
	  several problems (could not --show old entries, not compatible with
	  dynamic_26, not compatible with Hashcat and so on).
	Mask mode: Add ?h and ?H for hex digits (hashcat compatibility).
	  Closes #2324.
	mask.c: Fix a silly bug introduced by c19f75fb9
	Fix for rar2john buffer overrun problems. Closes #2337.
	Revert "OpenCL formats using "perfect hash tables" can't be used with
	  single"
	recovery.c: Re-position a comment that was pushed away from what it's
	  referring to.
	Fix weird bugs introduced in c79fce1, messing salt resume up. You
	  can't look at salt->count, that's the number of hashes for *this*
	  salt.
	Drop the raw SHA-0 format. It's unlikely anyone will ever need it.
	  Closes #2342.
	Missing update in autoconfig.h.in related to FPGA support.
	Drop CUDA support. Closes #2348.
	Some more cleanup after dropping CUDA (mostly cosmetic).
	Some tweaks to incremental mode vs. --min/max-length options. See
	  #2316.
	Fix a hideous bug in CPU version of WPAPSK format concerning new_keys
	  flag. It was only set in clear_keys() but not in set_key(). This is
	  not enough when running Single mode.
	Fix two memory leaks in zip2john. See #2219.
	Drop CUDA artefacts from doc/INSTALL*
	Fix more memory leaks in zip2john. See #2219.
	Fix more memory leaks in zip2john and stop using alloc_tiny. See
	  #2219.
	Add new option --single-seed=WORD. This is incredibly effective for
	  eg. web dumps where some word/name is very common as part of the
	  passwords. Eg. for the LinkedIn dump you'd use
	  --single-seed=linkedin together with normal single mode.
	Document the new --single-seed option.
	encfs_common.c: Fixes for compatibility with OpenSSL 1.1. See #2355
	Unicode/codepage fix for --single-seed option.
	Bugfixes for Unicode/codepage support vs. single mode.
	Change --single-seed option to only allocate global words once. Also,
	  never create initials or word pairs from seed words. See #497 and
	  #2357.
	Add --single-wordlist option as well as a john.conf list entry for
	  static single mode seed words. Closes #497 and #2357.
	Automatically bump word pair limit for --single-wordlist and
	  --single-seed options to accommodate the list of words. Also update
	  documentation.
	Fix a bug in leet.cc format: You can't free a "tiny alloc".
	Drop all use of ARCH_WORD_64 (introduced in 61cea42 for no clear
	  reason) in favor of uint64_t. Closes #2361.
	Some code clean-up in loader.c, and fix potential issues with
	  truncated pot lines. See #2366, #2367.
	7z2john.pl: Upgrade from upstream 7z2hashcat.pl. See #2314
	7z2john.pl: Update from upstream 7z2hashcat.pl. See #2314.
	Drop a whole bunch of obsolete stuff from "unused" directory. We
	  should be a bit more restrictive with archiving stuff there. Samples
	  should not be placed in the repo at all, we have a wiki page for
	  them. Docs should be in docs directory.
	Add LZMA and LZMA2 decompression functions (from LZMA SDK).
	7z formats: Add support for LZMA and LZMA2 decompression. Reduce false
	  positives to nearly zero and drop FMT_NOT_EXACT. Despite this we've
	  now got a number of optimizations for early rejection.
	7z2john.pl: Update from upstream 7z2hashcat.pl.
	7z: Bug fix for coder props parsing.
	7z2john update from upstream.
	Fix a recently introduced memory leak in 7z formats.
	Memdbg fixes for new LZMA code.
	7z formats: Avoid FP, ensure we round up to AES blocksize.
	7z2john.pl: Update from upstream. Support added for SFX files. Closes
	  #2120.
	Fix non-thread-safe code in enpass-opencl. Closes #2393.
	7z2john.pl: Update from upstream.
	Add generic OpenCL code for AES. Not used yet.
	Enpass and Strip formats tweaks. They had unnecessary large buffers
	  and decrypted more than needed.
	wpapsk2john: Drop hard-coded limit of ESSIDs supported in a batch
	  (realloc on the fly instead). Also search the database in reverse
	  order for quite some speedup on extremely large pcaps (eg. from
	  war-driving where the related data to a packet is more likely to be
	  near end). This was inspired by recent huge sample posted in a
	  Hashcat issue (955).
	OpenCL AES fixes.
	ODF-AES OpenCL format: GPU-side AES decryption. This was mostly made
	  just for testing and PoC but it turns out it made for a better than
	  4x boost on nvidia Maxwell (single CPU thread). AES code is still
	  not optimized at all and there's a couple of SHA-256's we could move
	  to GPU as well if we wanted to.
	Add a mem_realloc() function just for good measure. Some uses of
	  realloc can't use this because they are in external *2john tools
	  that don't link memory.o. Others have their own special handling.
	  Closes #2365.
	OpenCL AES: #ifdef out AES_cbc_encrypt so we don't get complaints for
	  unused functions.
	7z2john.pl: Update from upstream.
	Shared SHA-2 OpenCL code: Bugfixes. Protect macro arguments and ensure
	  second-level macro gets its W variable correctly.
	plugin_deps.pl: Support OpenCL kernel sourcing other kernel(s).
	OpenCL ODF-AES format. Try a new approach for using several kernels,
	  and now do *all* work on GPU (and drop OpenMP). This yielded another
	  near 4x boost and including recent 4x boost we are now near 15x the
	  original speed. Closes #2400.
	7z-opencl: GPU-side early rejection (check AES padding). Closes #2398
	7z-opencl: Minor fixes.
	7z formats: Add padding size and compression type as "costs".
	agilekeychain-opencl: Move all work to GPU. Closes #2403
	Correction for agilekeychain algo name (missing in last commit).
	bench.c: Bugfix for dyna salt when 1st salt is reused (would
	  segfault).
	Enpass OpenCL: GPU-side AES and verify. Closes #2404.
	Drop an unused variable in enpass kernel.
	Fix for a segfault in dynamic prepare() during pot reload. I'm not
	  quite sure who's to blame but I fixed it in crk_reload_pot(). Closes
	  #2415.
	Enpass kernel: Fix a race condition problem with the "any cracked"
	  bit.
	7z2john.pl update from upstream. Support for split archives added.
	  Upstream c143795..fe800e0.
	Globally fix about a thousand whitespace violations. Contrary to
	  popular belief, omitting spaces doesn't make your code faster. It is
	  actually a little harder than that. Also change a number of "char
	  unsigned" to the more friendly "unsigned char".
	7z-opencl: 62cec9d5 introduced a false negative bug for the "many
	  salts" case. We did the early reject for all salts using data from
	  just first salt. Add a separate kernel for the AES stage and run it
	  per salt.
	Fix race conditions and other bugs in recent AES OpenCL formats.
	OpenCL agile/iwork/enpass formats tweaks / bugfixes.
	7z-opencl: Drop an unused variable.
	OpenCL AES: Add ECB interface.
	Add volatile to variables handled with atomic functions.
	OpenCL AES formats: Optimization just for good measure.
	Enpass-opencl: Copy/paste bug
	New Office OpenCL format joining the separate ones (#2424)
	Allow building against OpenSSL >= 1.1. Formats that will be disabled
	  are currently GPG, GPG-opencl, KRB5TGS, PDF, PFX and WPAPSK (CPU
	  only). Closes #2355.
	Add build-time warnings for disabled formats. See #2355.
	Drop PFX format in favor of PFX-ng and rename the latter (but not its
	  format tag). Closes #2431.
	Drop OpenSSL dependencies from WPA-PSK format. Closes #2434.
	GPG formats: Support OpenSSL 1.1. Closes #2430.
	AES fixes for internal AESNI-aware code vs. OpenSSL.
	GPG format needs OpenSSL for AES_cfb128_encrypt
	Add a self-test for -opencl suffix in label being lower case as
	  required. See #2436.
	Zip-opencl: Drop AES from algorithm name, it's not used!
	o5logon-opencl: White-space fixes (no-op).
	o5logon-opencl: GPU-side AES and verify. This made a 7x boost.
	OpenCL formats: Sod using atomics. There simply is no safe way to
	  initialize the variable to 0 other than to do it in a separate
	  kernel or transfer it from host side. These formats aren't fast
	  enough that it matters anyway. See #2439.
	Various minor OpenCL optimizations and bug fixes.
	ssh-ng bugfix for truncated pot entries. See #2457.
	AS400-ssha1 format: Don't use identical test vectors with different
	  syntax. See #2457.
	External HybridLeet mode: Case-toggle letters that lacks leet
	  alternatives. Closes #2461.
	Do not allow a hybrid external mode applied to single mode. Closes
	  #2462.
	Add a --max-candidates option.
	Fix weird bugs introduced in 0ceedb2 including --make-charset not
	  working at all.
	Let new -max-cand option also affect -stdout
	Followup work for new -max-cand=N option. Closes #2475. * Change the
	  "Session aborted" message when session was stopped due to max.
	  reached. * Allow resuming such stopped job (for processing next set
	  of N cands). * Document the option. * Avoid silly portability
	  problems with %lu vs. %llu for uint64_t.
	Some updates and white-space consistency for doc/OPTIONS.
	-max-cand=N option can now take a negative number. That means the
	  "count" will reset on each crack (so it will terminate after N
	  candidates are tried since last crack). See #2475.
	Set CRLF line feeds for john.asm in .editorconfig. See #2484.
	Drop our local stdint.h
	Drop obsolete typedefs.
	unicode.h: Use stdint.h types
	Makefile.in: Drop a stray "stdint.h" dependency for bitlocker2john
	  that probably got in when merging.
	Travis CI: Allow OpenCL failures
	Fix a bug where --show=left only showed statistics (but no hashes)
	  unless at least one hash was already cracked. Closes #2506.
	keepass format: Move sharable stuff to a separate file, in preparation
	  for an OpenCL version.
	zip2john: Support 64-bit sizes in zip version 4.5. See #2528.
	Assorted 64-bit-size fixes for zip/pkzip formats. See #2528.
	Fix a bug in fgetll. We somehow overlooked that fgets' size arg is an
	  int!
	Fix a pkzip problem with sizes exceeding 32-bit signed int.
	Do not trust AES padding as early-reject for 7z (unless that's the
	  only thing we can do due to truncated data). Closes #2532.
	Oldoffice formats: Fix a bug caused by using source() in a salted
	  format. This is simply not supported. Add a self-test to stop us
	  from doing the same mistake in the future. Closes #2535.
	Add some better information for password max-length in case of UTF-8.
	  We now express it in characters, not bytes.
	DMG-opencl: Change max. duration to be less strict.
	Bug fix for new length reporting. See #2529.
	Tweaks for new length reporting. See #2529.
	OpenCL: Whenever format have a notion of "cost" and we're auto-tuning
	  with (#2544)
	SAP format fixes for max. length.
	Bug fix for recent auto-tune-with-real-db.
	Minor cleanup in 7z formats.
	Length reporting tweaks for LM formats.
	Hard code SAP/B length reporting for non-UTF-8 and set FLG_8_BIT
	  again. Closes 2545.
	Don't start "the clock" until all loading, auto-tune etc. are done.
	  This ensures stable speed readings from start, and things like
	  --progress-every and --max-run-time will work better.
	NT-opencl: nvidia bug workaround. Closes #2335.
	Add a separate .editorconfig for src/ztex subdirectory, reflecting the
	  odd mix of line endings. Closes #2484.
	pkzip format: Fix a bug in salt compare size and add a note about
	  "same password assumed within one archive". Closes #2542.
	Fix a couple of obscenely promiscuous or slow prepare() functions.
	  There's many, many more to fix.
	Apply nvidia bug workaround in three more formats. See #2335.
	Add a format flag FMT_HUGE_INPUT telling us that a format supports
	  huge input lines (ie. longer than LINE_BUFFER_SIZE) and thus
	  may/will truncate its pot entries.
	OpenBSDsoftRAID format: Drop a dupe test vector so we don't confuse
	  the test suite.
	Update CREDITS-jumbo and CHANGES-jumbo.git
	Revert some of changes from 272c664 for the net-md5 format. They were
	  needed for tag translation (I thought it was merely about supporting
	  bare hashes).
	Git .mailmap for e-ago
	Revert some of changes from 272c664 for the net-sha1 format. They were
	  needed for tag translation (I thought it was merely about supporting
	  bare hashes). Closes #2554.
	Bug fixes and workarounds avoiding -Wformat-truncation warnings from
	  gcc-7. Closes #2533.
	Style fix, no-op: Change all '# define' -> ' #define'.
	Whitespace violation fixes, no-op.
	Code cleanup: Drop a few unused macros (but not in borrowed code).
	Serious performance bugfix for fgetll() in edge cases.
	Add a makefile target for producing test files from all formats.
	Bugfix for the fgetll bugfix in 07ddb4f7. Also never allocate less
	  than 4K.
	Fix for uninitialized variable. Closes #2556.
	Fix for uninitialized variable in fgetll(). Silly me.
	Pot sync: Emit a warning if pot file shrunk. Merely seeking past end
	  does not detect that.
	RAR OpenCL format was lacking FMT_HUGE_INPUT.
	7z formats was lacking FMT_HUGE_INPUT flag.
	OSPF format is FMT_HUGE_INPUT, electrum and multibit aren't.
	Fix a bug introduced in 827df441.
	Don't allow gcc 7.1.1 to complain about perfectly fine fallthrough
	  code.
	Fixes for -Wold-style-declaration.
	Various fixes for -Wextra
	Add test files (from 'make testfiles') to .gitignore
	DMG OpenCL: Use split kernel. Closes #2564.
	Add SL3 CPU format. Closes #731.
	Add a silly kludge for a silly test. See
	  https://github.com/magnumripper/JohnTheRipper/commit/e4795d6#commitcomment-22477620
	Buffer overrun fix for SL3 format in non SIMD builds.
	Revert "Using the new multibyte character aware API from rexgen
	  (#2566)" (#2569)
	SL3 ensure correct string termination in non-SIMD code.
	Add SL3 GPU format. See #731.
	SL3-opencl: Correction of format flags.
	SL3 formats: Ensure we self-test prepare() function.
	Ethereum format: Set FMT_HUGE_INPUT. See #2568.
	SL3 formats: Share common code.
	OpenSSL-enc format: Get rid of OpenSSL EVP calls. Apart from being
	  more portable we also got a 25% speed boost. See #1686.
	Get rid of OpenSSL EVP in encfs formats. See #1686.
	Drop artefacts from EVP and BIO high-level crap that we have gotten
	  rid of. Some of it were just comments now but they were removed or
	  modified to not hit a grep. Closes #1686.
	mscash formats: Fix bugs for parsing salt containing '#'. See #2575.
	ztex .editorconfig update after 0bfd564c
	Fix some run-time OpenCL compiler warnings for ethereal-presale, plus
	  other insignificant changes.
	PFX: Add a test vector with a non-ASCII password.
	Ethereum-presale OpenCL: Auto tune tweaks. Aim for similar durations
	  of loop and post-process kernels. Avoid uint8_t and size_t in
	  kernels.
	OpenCL SHA-1 (CTX version) clean-up.
	PFX optimizations. Move the last HMAC-SHA1 to GPU (for crying out
	  loud?). Optimize/unroll some 8-bit operations. Use a quick raw SHA-1
	  for inner loop of PKCS12. Over 8x boost (that last thing made the
	  most). See #2176.
	Update .gitignore with a couple of new entries.
	Ethereum-presale OpenCL: Add a cast to pacify some runtime compilers.
	OpenCL: SHA-2 AMD fix for OSX.
	Optionally trust 7z padding for early rejection. See #2532 and
	  470766a.
	Drop test for -Wno-implicit-fallthrough. For some reason, the cc
	  options check passes that even though it's not supported. Anyway
	  it's not needed unless we use -Wextra.
	PFX formats: Add test vectors describing the need for #2606.
	MS Money format: Correction for full UCS-2 support (strip 8th bit).
	  See #2607. Also some optimizations.
	MS Money: #2607 8-bit fix: Assume ANSI codepage -> upper-case ASCII ->
	  strip 8th bit -> UCS-2
	Regex mode now needs librexgen >= 2.0.6
	Fix a problem with resuming a descrypt-opencl session. Closes #2662.
	Fix a bug introduced in 0168a45a when using fork (not MPI). Closes
	  #2664. This might also affect #2547 somehow.
	WPAPSK: Drop some dead code. There's little point in having a function
	  always return 0 and then test for other returns...
	Improve WPAPSK valid() so we don't accept versions we don't support.
	  Closes #2678.
	Fix a problem with possible AVX2 (et al) code before we
	  detect/fallback for CPU type. Closes #2679.
	Remove some dead code from WPAPSK. Key is always 32 bytes.
	WPAPSK formats: Add keyver as cost 1 = WPA (MD5), 2 = WPA2 (SHA1), 3 =
	  802.11w (SHA256)
	WPAPSK-opencl: Add support (GPU side) for 802.11w / WPA-PSK-SHA256.
	  Closes #2648.
	Add "PMF" to wpapsk algo names, indicating we support 802.11w
	  WPA2-PSK-SHA256
	Sybase ASE format: Decrease max. length to 30. Closes #2686.
	Bump RULE_RANGES_MAX from 16 to 30. See #2684.
	Replace calls to abort(3) with our own error().
	Fix a mismatch between (POSIX) sleep(3) and emulation of it for
	  Windows.
	Replace guerilla usage of exit() to error().
	QNX format: Move a valid check from crypt_all() to, wait for it,
	  valid()!
	OpenCL: Bug fixes. The dreaded PGP-WDE bug that only showed up on
	  nvidias were caused by an optimized macro assuming data to be
	  aligned as integer. Most uses of that macro always involved aligned
	  data but the CTX versions of SHA-1 and SHA-2 may pass unaligned
	  data. The now added code to handle that will (hopefully) often be
	  optimized away.
	OpenCL: SHA1/2 CTX also had alignment issues with output. Closes
	  #2710.
	PGPWDE-OpenCL: 5% boost just be ensuring 'struct pgpwde_password' is
	  sized to end up aligned (124 + 4 == 128).
	Oops, the previous commit obviously made a length 125 test vector
	  fail.
	Tweaks for suppression of heavy logging. See #2717.
	Bugfix for resuming a -stdin session.
	OpenCL shared code optimizations (memcpy macro replaced with
	  functions).
	Minor tweaks to pgpdisk-opencl. Avoid non-native widths like the
	  plague, reduce use of private memory.
	pgpwde-opencl: Since host code hard-codes saltlen and key_len, do so
	  in kernel also. This allows the run-time optimizer to gain us some
	  5% boost.
	Agilekeychain: Add the new test vector from f78f329 to OpenCL version
	  too.
	krb5pa-md5-opencl: Add the new test vector from 4810534 to OpenCL
	  version too.
	Electrum(-modern) OpenCL format: Correct algorithm name.
	OpenCL shared code: Avoid build warnings on some platforms.
	PGP OpenCL optimzation
	Revert "Add support for Ethernet link type"
	wpapcap2john: (Re-)add some diagnostic comments after previous
	  revertion.
	eeacc1a merely hid an older bug instead of fixing it. Duh! Fix the
	  silly band-aid (add a warning print) and also fix the original bug.
	wpapcap2john usage blurb: Clearify -e option.
	wpapcap2john: Re-introduce support for Ethernet encapsulation. See
	  #2751.
	Add hccap.h (preparation for #2753).
	Add WPA-PSK PMK formats. Closes #2754.
	wpapsk-pmk-opencl: Optimization for many salts.
	wpapsk-pmk-opencl: Do not set FMT_CASE
	hccap2john: Add support for reading hccapx files. Closes #2753.
	Fix a problem where -max-run-time=N with -fork would loop signals so
	  some processes ended prematurely. See #2757.
	Only add WPA 802.11w CMAC functionality if our OpenSSL has CMAC. This
	  does not apply to OpenCL formats, they do it on GPU. Closes #2763.
	cracker.c: Ensure we never try to sync pot file if event_abort is
	  raised. This shouldn't happen anyway but was added as safety.
	Remove dupe logic from x86-sse.h resulting in incorrect CPU_NAME for
	  anything beyond SSE4.1. See #2764.
	Suppress OpenMP warnings for ztex formats. Closes #2771.
	wpapcap2john: Improve ESSID gathering. Closes #2768.
	wpapcap2john: Warn about silly tools like wpaclean.
	hccapx2john: Update license/description & links.
	wpapcap2john: Type led to build warning.
	DEScrypt-opencl: Avoid printing silly message once per node.
	Refactored some extremely confusing and misleading structure names in
	  wpapcap2john that had me make mistakes over the years.
	wpapcap2john: Code clean-up (add alloc macros). Re-init more stuff
	  between each new file. Add some debug output in case of bad data
	  seen.
	.mailmap update
	Update CREDITS-jumbo and CHANGES-jumbo.git
	wpapcap2john: Fix a long standing bug where too many outstanding
	  unverified auths wouldn't emit a realloc. Thanks to ZeroBeat for
	  finding this!
	wpapcap2john: Cosmetic (diag) fix.
	wpapcap2john: wpapcap2john: Add support for 802.11n HT field. Many
	  cosmetic changes (-v option for verbose output) and a few bug fixes.
	Do not populate testdb if we're not going to use it. Also, fix for
	  repeated message using --fork. Closes #2792.
	wpapcap2john: Warn about insufficient snaplen and speed up promotion
	  loop. Cosmetic bugfix for -v option: Some packets don't have a src
	  field.
	wpapcap2john: Avoid double allocs/copies of same data, and refactor.
	Fix indentation in hccap.h
	wpapcap2john: Change bunch of "packetx" pointers to array "M[x]"
	wpapcap2john: Detect and use M4 packets with intact nonce (in case we
	  missed the M2).
	wpapcap2john: -r Ignore rep count
	wpapcap2john: Safer handling of data, better handling of unverified
	  auths.
	wpapcap2john: Bug fix for -c option (only use verified auths).
	Loader and wordlist/PRINCE modes: Refuse to eat UTF-16 files. Wordlist
	  mode also had the UTF-8 BOM-skip extended to every line in the file
	  (for cases where luser concatenated several infected files). Also,
	  the checks were simplified/optimized, mitigating the performance
	  hit. Closes #2802.
	OpenCL: Add a shared SHA-512 "CTX" (init/update/final style) kernel.
	  See #2801.
	Do not suggest using --fork when user runs a non-OMP format with
	  -stdin or -pipe. Closes #2777.
	Avoid running john-local.conf twice when CWD == $JOHN. Closes #2776.
	wpapcap2john: Bugfix for -r (ignore replay-count) option. That whole
	  stuff is WIP. See #2773.
	wpapcap2john: Bug fix and some refactoring.
	wpapcap2john: Bug fixes and refactoring.
	wpapcap2john: Minor fix for -v showing TS for hit.
	wpapcap2john bugfix (cosmetic)
	Mute a couple of OpenCL runtime build warnings. See #2810.
	GPG-opencl: Add missing algorithms (cosmetic)
	Make sure our definition of CPU name matches what was actually defined
	  with the cpuid tests. Closes #2764.
	CircleCI tweaks. The log was completely unfathomable.
	CircleCI bugfix
	Fix a regression caused by 599a1674: The shared SWAP64 macro need to
	  be type agnostic (type may be vector).
	No-op change: Unify whitespace.
	wpapcap2john: Drop stray debug text.
	Only bail on UTF-16 BOM's when input encoding is UTF-8. Closes #2812.
	Travis CI seem to have a broken VM announcing AVX2 but not fully
	  supporting it. Disable AVX2 for now.
	wpapcap2john: Correction of MAC address outputs in supplemental JtR
	  input file fields. We output STA MAC as uid and AP MAC as gid.
	  This way, user can select all hashes authenticating to a certain AP
	  using the --group option, or all hashes from a certain STA using the
	  --user option.
	wpapcap2john: Fix the support for reading airodump .ivs files.
	wpapcap2john: Switch to using stdint.h types.
	wpapcap2john: Further tweaks to airodump-ng .ivs file support.
	Relax the UTF-16 BOM check in wordlist and PRINCE modes to only warn,
	  not bail. The rationale is some low quality wordlists contain a mix
	  of encodings but likely mostly UTF-8. See #2812, #2802.
	Tweaks for UTF-16 BOM check vs. MPI/fork (reduce repeated messages).
	wpapcap2john: More tweaks. Output more unique handshakes, yet try to
	  avoid pure dupes. Fix an endianness bug that caused mishaps.
	gpg-opencl: Get rid of build warning due to missing #include. Closes
	  #2816.
	wpapcap2john, major rewrite: Keep state of AP/STA pairs instead of
	  just AP. This is needed for some elaborate attacks. Suppress
	  consecutive dupes from ivs parsing. Add EAPOL breakdown diagnostics
	  (-v -v -v) Improve option parsing. Improve checks of replay-count
	  (or not) and timing checks. Add support for outputting anonce-fuzzed
	  hashes where needed (happens automagically when needed, with
	  detected endianness). Add -d option (reduce dupe suppression, mostly
	  for debugging). Try to tell real AP's handshakes apart from the
	  attacker's. Lots of code clean-up.
	wpapcap2john: Typo that for some reason only affected MinGW.
	Move cygwin/ethernet.h to cygwin_ethernet.h because I love having
	  thousands of files in a single directory (not really).
	wpapcap2john: Add -f <num> forced anonce fuzzing. This will fuzz +/-
	  <num> for both LE and BE (assuming incrementing last word of
	  anonce). Also tweaks for the auto-fuzzer (in some cases we can
	  detect fuzzing is needed even without -f option).
	wpapcap2john: Handle (merely print in -vv) EAP Identity Responses.
	Fix regressions after merge.
	Use "-sj8" in all 'make' examples. See #2820.
	wpapcap2john: Fix a cosmetic problem with -m combined with -vv. Fix a
	  BSSID source mixup with ethernet encapsulation. Fix handling of
	  handshakes with unknown ESSID (post-pone/warn and finally print
	  anyway, using MAC). Fix -e option that was broken for a while.
	wpapcap2john: Indicate local (i.e. probably randomized) and multicast
	  MAC addresses (-vv).
	doc/EXAMPLES: Update some old abbreviations the are no longer
	  unambiguous. See #2616.
	wpapcap2john: Detect Ipv4 mcast MAC addresses.
	wpapcap2john: Avoid wrong output of "WPA3" for WPA2 keyver 3.
	Multibit format: tweaks for better OpenMP scaling (marginally
	  successful). See #2846.
	Fix a silly bug where many formats used omp_get_num_threads() instead
	  of the intended omp_get_max_threads().
	Fix a bug with non-OMP introduced by 00655ad63
	Fix a few formats that failed to use the PH_MASK_* macros and thus
	  failed after recent core merge.
	Fix a "bug" where dynamic did not adapt to new binary/hash sizes.
	Fix about one ppm of the whitespace and/or code style violations.
	Bump the default for mem-file-size to 2 GB.
	Revert to using 1 GB -mem-file-size for 32-bit systems but keep it at
	  2 GB for 64-bit. Also update docs (and avoid future discrepancies).
	OpenCL: macOS driver/runtime bug workarounds. Closes #2923.
	Add JSON version of --show=types (as --show=types-json).
	Mask mode: refactor a global variable name so we know its origin.
	Mask mode: Bug fixes for min/max length and ETA/progress. Closes
	  #2882.
	Markov mode: ETA/progress fixes. Closes #2799, see also #2779.
	7z2john.pl: Update from upstream 7z2hashcat.pl (1.2, Nov 16 2017)
	gpg2john: bug fixes for -DDEBUG builds.
	--show=types-json: Output booleans and numbers correctly and start
	  numbering lines from 1 instead of 0. Mute fields that are empty
	  strings or boolean false.
	Fix comments in john.c according to code style.
	Register dynamic formats last. We certainly don't want it to have
	  precedence over optimized formats. The old comment about it needing
	  to be registered early (bc of thin formats) does not seem to apply
	  anymore.
	Fix a build warning for status.c LLu vs. PRIu64 after core merge.
	Avoid lots of build warnings for PRI[ux]64 on some systems.
	cracker.c and wordlist.c bug fixes after core merge.
	Travis conf: Do not allow ASan or macOS failures.
	--show=types-json: Escape control chars (any 8-bit stuff is currently
	  assumed/required to be UTF-8 and not escaped).
	Change run-time CPU detection for AVX2 to actually only check for AVX2
	  but neither of BMI1, BMI2, MOVBE and FMA3.
	MPI benchmark: For MPI frameworks lacking reduce for uint64_t,
	  re-introduce the old bug of taking the sum of each half without
	  carry. Better than nothing and I'm not sure it ever hits us anyway
	  in a benchmark. If it does, well, it's just cosmetical.
	--show=types[-json]: Ignore pot file(s) when --show=types is used, for
	  speed-up (it's not used anyway).
	Fixes for new CPU detection in ./configure (eg. non-Linux) See #2966,
	  #2972
	Make CircleCI builds silent again. The output is too large even
	  without it.
	Move CircleCI-MinGW.sh from src to .circle See #2962
	Bug fix: simd-intrinsics.h had an obsolete macro clashing with
	  non-SIMD builds.
	Fixup: Last commit accidentally had things commented out instead of
	  removed.
	.editorconfig entries for autoconf files (.ac, .m4)
	Temporary bug workaround for PPC/ARM SIMD.
	Bug fix for AVX512 CPU detection/fallback.
	Autoconf: Add --enable-simd=foo option in a way that doesn't add it
	  when building john.o (which may break CPU fallback). And some more
	  clean-up. See #2862. Closes #3002.
	Autoconf fixes: --disable-simd: Do not add simd-intrinsics.o for
	  non-intel.
	AC cpuid fix: Enhance Claudio's excellent tests to use autoconf macros
	  instead of the less safe "bastard compile". Also adds it to AVX512*
	  tests in the same manner. See #2881, #3002.
	AC: I was using mic.h where I shouldn't. It made no harm but was
	  confusing.
	Avoid merge conflicts whenever core bumps version.
	Refactor some file names with perv... sorry, reverse polish notation.
	Fix a problem with cpuid checks in ./configure on x86-32. See #3041.
	Temporary bug workaround: Do not probe 32-bit x86 for better than AVX.
	  See #3041.
	Remove temporary workaround for 32-bit cpuid checks, and implement
	  them. Also fix missing stuff in x86-sse.h.
	x86.S, some clean-up.
	x86.S cpu detection bugfix for AVX2 and higher. See #3041
	NT-old: Honor the --disable-simd configure option. Closes #3044.
	Add INSTALL-FEDORA and also change all references to eg 'make -j8' to
	  'make -j4' because that seems to be a faster overall suggestion and
	  bumping it is documented.
	Fix a major f*up with the last commit. We changed charset files.
	The -D option to gcc defines the macro to 1, no need to say it.
	INSTALL-FEDORA: Add proper name for libbz2
	Bug fix for SAP-G format, problem introduced in 27c9bf17. SIMD_COEF_32
	  was tested before defined. Also down-tunes OMP_SCALE so it resembles
	  the multiplier used for length sorting. Closes #3050.
	Autoconf changes for using NEON on ARM64.
	Autoconf: Honor --disable-neon for aarch64 (actually cosmetic).
	Autoconf: Add -Wno-error=cpp for --enable-werror
	NEON autoconf tweaks.
	Some manual clean-up after Dhiru's poorly reviewed grep|sed sessions.
	  Closes #3062
	Test using --enable-werror for the bots
	Autoconf: Avoid outputting "configure: configure:" in output from
	  AC_MSG_NOTICE.
	Autoconf: Add -Wno-error=#warnings for clang when --enable-werror.
	Autoconf: Unify comments (using dnl so they don't end up in the
	  compiled script), replace some comment that drifted away from what
	  it referred to and drop some obsolete comments. Also adds default
	  CFLAGS for when we can't test compiler flags (and this is the only
	  no-op change).
	Further clean-up of autoconf scripts.
	Drop some CUDA artifacts and fix bench.c diff against core for MinGW
	  timing.
	SunMD5 would segfault at OMP_NUM_THREADS=1 after Dhiru's recent
	  clean-ups.
	OpenMP: argon2 still used omp_t and scaling at single thread.
	Drop some spurious OMP_SCALE stuff from OpenCL RAR format.
	timer.[hc]: Code style fixes.
	Loader bugfix for testdb cost ranges.
	keystore format was freeing stuff in done() that was still pointed to
	  by the salt db. Change to mem_alloc_tiny (the alternative would be
	  using dynamic salt).
	Add shared CPU autotune code.
	Add optional autotune for all applicable formats.
	NETLM format: Enable tuning for non-OMP builds. Add correct max keys
	  per crypt and scaling.
	OMP autotune: Use threads == 1 for non-OMP.
	Tweaks for MKPC tuning.
	Tweaked MKPC and then OMP_SCALE for wpapsk-pmk (core i7)
	Tweaks for MKPC tuning. We shouldn't go below MIN_KEYS_PER_CRYPT.
	Fix for generic legacy builds.
	OMP autotune: Cosmetics
	WPAPSK: Tune MKPC and OMP_SCALE for core i7M, incl. non-SIMD.
	Ignore any preset OMP_SCALE (ie. always autotune) if we're not an
	  intel arch. See #3091
	Autotune: Tweaks/bug fixes.
	KeePass and MySQL formats: Tune MKPC and then OMP_SCALE. See #3091
	sha256crypt format: Tune MKPC and then OMP_SCALE. See #3091
	sha512crypt format: Tune MKPC and then OMP_SCALE. See #3091
	raw-MD5 format: Tune MKPC and then OMP_SCALE (including for non-SIMD).
	  See #3091
	NT format: Tune MKPC and then OMP_SCALE (including for non-SIMD), see
	  #3091
	mscash2: tune MPKC and OMP_SCALE for core i7 with and without SIMD,
	  see #3091
	mscash: tune MPKC and OMP_SCALE for core i7 , see #3091
	pkzip: tune MPKC and OMP_SCALE for core i7 , see #3091
	phpass format: Tune MKPC and OMP. See #3091
	SunMD5: Tune MKPC & OMP, see #3091
	Revert omp_autotune() from crypt-md5 format. It's not ready for it.
	Revert formats that currently crashes on --tune=auto, see #3091
	AzureAD: Tune MKPC and OMP. See #3091
	Autotune bugfix, null pointer dereference. Closes #3100.
	Minor tweaks to autotune.
	Argon2: tune MKPC then OMP_SCALE. #3091
	Argon2: Avoid reading past buffer.
	One of the Travis builds lacked --enable-werror
	OpenCL: Add shared "CTX version" of MD5. Closes #3105.
	RIPEMD formats: Tune MKPC and then OMP_SCALE for core i7
	raw-sha1-ng: Tune MKPC and OMP_SCALE
	HDAA bugfix for --enable-openmp-for-fast-formats
	raw-md5-flat bugfix for --enable-experimental-code
	raw-md5-flat: Tune MKPC and then OMP_SCALE.
	CRC32 format: Tuned MKPC and OMP
	HAS-160 format: Tune MKPC and OMP
	Tiger format: Tune MKPC and OMP, and enable OpenMP for normal builds.
	HDAA format: Tune MKPC and OMP, and enable OpenMP for normal builds.
	PST format: Tune MKPC and OMP
	32-bit bot-build have some problems with HDAA now that I can't
	  reproduce. Trying to decrease mkpc.
	HDAA: Reverting all changes until I got it straight with the build
	  bots.
	omp_autotune(): Remove some obsolete code.
	Autotune bugfix and tweaks
	chap format: Tune MKPC and OMP.
	Clearquest: Tune MKPC and OMP
	citrix NS10: Tune MKPC and OMP
	DMD5: Tune MKPC and OMP
	Dragonfly formats: Tune MKPC and OMP
	EPI and EPIServer formats: Tune MKPC and OMP
	Fortigate, tune MKPC and OMP
	GOST: Tune MKPC and OMP
	hmac-MD5/SHA1/SHA2 formats: Tune MKPC and OMP
	HSRP format: Tune MKPC and OMP
	IKE format: Tune MKPC and OMP
	known_hosts format: Tune MKPC and OMP
	krb5tgs: Tune MKPC and OMP
	MDC-2 format: Tune MKPC and OMP
	Money format: Tune MKPC and OMP
	Mongodb format: Tune MKPC and OMP
	Mozilla format: Tune MKPC and OMP
	krb5pa-md5 format: Tune MKPC and OMP
	Mssql12: Tune MKPC and OMP
	Mysqlna format: Tune MKPC and OMP
	Stribog formats: Tune MKPC and OMP
	Pomelo format: Tune MKPC and OMP
	Oracle12c format: Tune MKPC and OMP
	Lotus85 format: Tune MKPC and OMP
	krb5-3/17/18 formats: Tune MKPC and OMP
	Krb5asrep format: Tune MKPC and OMP
	SSH-ng format: Set to always auto-tune MKPC/OMP. The needs are way too
	  different between cost 1 and 2. Perhaps they should be two different
	  formats. See #3091
	Ecryptfs format: Tune MKPC and OMP
	BKS format: Tune MKPC and OMP
	KDE KWallet format: Tune MKPC and OMP. This format needs cost
	  functions added (and a re-tune). It's probably best ran at
	  --tune=auto due to big difference between costs.
	ZipMonster format: Tune MKPC and OMP
	ZIP format: Tune MKPC and OMP
	Whirlpool formats: Tune MKPC and OMP.
	VNC format: Tune MKPC and OMP
	VDI format: Tune MKPC and OMP
	TCP-MD5 format: Tune MKPC and OMP
	Xmpp-scram format: Tune MKPC and OMP
	SSPR format: Tune MKPC and OMP
	SNMP format: Tune MKPC and OMP
	VTP format: Tune MKPC and OMP
	Truecrypt formats: Tune MKPC and OMP
	Snefru formats: Tune MKPC and OMP
	Skein formats: Tune MKPC and OMP
	Raw-sha3 format: Tune MKPC and OMP
	Sha1crypt format: Tune MKPC and OMP
	SAP-G format: Tune MKPC and OMP
	Salted-SHA1 format: Tune MKPC and OMP
	raw-SHA384: Tune MKPC and OMP
	Raw-SHA224 format: Tune MKPC and OMP
	raw-Keccak format: Tune MKPC and OMP
	RAR5 format: Tune MKPC and OMP
	RACF format: Tune MKPC and OMP
	PWSafe format: Tune MKPC and OMP
	Postgres format: Tune MKPC and OMP
	Pgpsda format: Tune MKPC and OMP
	PFX format: Tune MKPC and OMP
	PDF format: Tune MKPC and OMP
	PBKDF2-HMAC-SHA512 format: Tune MKPC and OMP
	OpenVMS format: Tune MKPC and OMP
	PBKDF2-HMAC-MD5: Tune MKPC and OMP
	Panama: Tune MKPC and OMP
	Padlock format: Tune MKPC and OMP
	Oracle format: Tune MKPC and OMP
	OldOffice format: Tune MKPC and OMP
	O5logon format: Tune MKPC and OMP
	O10gLogon format: Tune MKPC and OMP
	Notes format: Tune MKPC and OMP
	MD2 format: Tune MKPC and OMP
	ODF format: Tune MKPC and OMP
	Lastpass format: Tune MKPC and OMP
	KRB5PA-SHA1 format: Tune MKPC and OMP
	Keyring format: Tune MKPC and OMP
	iTunes format: Tune MKPC and OMP
	GELI format: Tune MKPC and OMP
	Ethereum format: Tune MKPC and OMP, for slowest salt. Using faster
	  salts in a real run, --tune=auto might speed things up considerably.
	EncFS format: Tune MKPC and OMP
	EIGRP format: Tune MKPC and OMP
	DPAPImk format: Tune MKPC and OMP
	Django-scrypt format: Tune MKPC and OMP
	Dashlane format: Tune MKPC and OMP
	CloudKeychain: Tune MKPC and OMP
	Blackberry ES10 format: Tune MKPC and OMP
	Bitcoin format: Tune MKPC and OMP
	axcrypt format: Tune MKPC and OMP
	FDE format: Tune MKPC and OMP
	AIX-SMD5 format: Tune MKPC and OMP
	XSHA512 format: Tune MKPC and OMP
	NETHALFLM format: Tune MKPC and OMP
	NETLMv2 format: Tune MKPC and OMP
	7z format: Tune MKPC and OMP
	Strip format: Tune MKPC and OMP
	ssha512 format: Tune MKPC and OMP
	SL3 format: Tune MKPC and OMP
	Ensure HMAC formats don't get precedence over eg. MSCash ones (the
	  former are very promiscuous since they don't really have a tag)
	Common mscash code, fix warning message to reflect actual format.
	Unicode fix for early use of conversions, eg. in valid().
	RAR3 formats: Add self-test for #2899
	Whitespace fixes after bfacbbfd (upstream has whitespace violations)
	  #2899
	Further unrar tweaks: Drop a check we did that upstream doesn't, and
	  fix a cosmetic bug testing an unsigned variable for -1
	Bugfix for 32-bit SSE4.1 and SSSE3 detection. Closes #3119.
	SSPR OpenCL format: Optimizations, bug fixes. Run 32/64-bit code in
	  the inner loop instead of 8-bit PoC CTX-style. Add MD5 salt type.
	  Use a looped kernel. More than 12x boost - closes #3118.
	Add CPU detection for SSE4.2, partly because it was trivial now and
	  partly because the CRC32 format actually uses it.
	Enhancement for --show=types option vs. pot file truncated hashes. Now
	  shows full hash as 'canonHash' and truncated one as 'truncHash'.
	  Also adds a json '"truncated":true' when applicable.
	Cosmetic fix for SSPR OpenCL algorithm_name.
	Bugfix for scrypt format when converting Perl format hashes to
	  canonical. Spotted by chance when looking at #3127.
	Add "Constant Buffer size" to --list=opencl-devices.
	Revert Jumbo's old BENCHMARK_LENGTH -1000 hack (it predates Git
	  history), and instead *always* smash passwords when benchmarking -
	  and in a much better way for OpenCL formats in particular. They may
	  otherwise show an inflated benchmark speed due to way less thread
	  divergence than in real use.
	Nick a hashcat workaround for some nvidia bug.
	OpenCL: Much faster AES code. It can do tens of GB/s on a Titan X and
	  is needed for KeePass format.
	Lotus5-opencl missed sourcing opencl_misc.h
	More fixes after recent OpenCL commits, after build-bots' complaints.
	  I tested all formats on a few systems and they did not even warn.
	Keepass OpenCL format. This includes new shared OpenCL code for
	  Twofish and ChaCha20 and uses the new fast AES code (which is the
	  heavy part).
	Disable keepass-opencl from Travis Ci bot check. I'm pretty convinced
	  it fails there due to silly driver bugs.
	Tighten self-test check for lacking FMT_HUGE_INPUT
	GELI format lacked FMT_HUGE_INPUT.
	Fix benchmark speed reporting of very fast formats (eg. LM-opencl w/
	  mask). This bug was introduced at core merge 844df7388 because the
	  replaced int64 "add32to64()" function assumed unsigned whereas the
	  new code did not.
	DES-opencl and LM-opencl: Add an implicit LUT3 that was missing. Also
	  source omp.h in files that need it.
	Office OpenCL: Drop a redundant AES_set_decrypt_key(). See #3142.
	Many formats: Drop silly redundant memsets and useless error checking
	  when calling AES set_key.
	Fix for recent LUT3 substitution. This bug had no impact because the
	  macro is normally not used.
	truth.pl: Add some tweaks and usage blurb bits. Even I did not
	  remember how to use it.
	Keyring-OpenCL: Do everything on GPU-side (AES and MD5 was CPU-side).
	  Closes #3147.
	ZIP-opencl: Do everything on GPU-side.
	Drop FMT_OMP from Zip-opencl
	DMG formats: Add "version" as a second cost. Loosely related to #3129.
	Add shared OpenCL DES code.
	DMG OpenCL: Do everything on GPU and drop OpenMP. Massive boost,
	  especially for v2 low-iteration-count hashes (more than 35x with
	  Titan X using non-OMP). Closes #3129.
	Keepass-opencl fix for some less rigid devices.
	Enable keepass-opencl in Travis CI.
	Revert "Enable keepass-opencl in Travis CI.". It was a good change,
	  but not enough for ol' Travis.
	Replace shared OpenCL HMAC-SHA1 with a more versatile one.
	Truecrypt-OpenCL: Do all work on GPU.
	PGPWDE-opencl: Do all work on GPU.
	Openbsd-softraid-opencl format: Do all work on GPU.
	bitlocker-opencl: Fix a buffer overrun (ASan fault).
	Drop the many JUMBO_JTR clauses in formats.c. The idea had some merits
	  but it ended up utterly confusing.
	formats.c: Fix a problem with self-test vs. certain highly-optimized
	  formats that simply can't have set_key() called again with same
	  index. Problem seen in SL3-opencl, which was segfaulting.
	OpenBSD-SoftRAID OpenCL: Work around an nvidia driver bug merely by
	  re-ordering stuff a little. The commit also includes some no-op
	  changes replacing constant numbers with macros, for safety and
	  clarity. Closes #3154.
	OpenCL AES tweaks and bugfixes, better handling of different memory
	  types (avoiding copies).
	OpenCL AES: Use void* for set_key so callers don't need to cast.
	Add a couple more min/max length variables to options struct, to keep
	  apart actually requested vs. calculated limits.
	mask.c: Typo and brainfart combined to a minor bug.
	Minor fix for incremental: Allow -min-len=0 to override a longer
	  default. Options checking bugfixes. It's amazing how it keeps ending
	  up incorrect.
	Markov mode: Honor a format's minimum length (bug introduced with
	  recent changes).
	mkv.c: Simplify expression for min length check (no net change).
	TACACS-plus format: Minor fixes while preparing for OpenCL version. No
	  point of storing full ciphertext if we only use 8 bytes of it.
	Add NVIDIA LUT3 options for OpenCL MD4/MD5 kernels. They are just for
	  reference, not used. Also, stop using the ones that were already
	  defined for RIPE-MD-160 (TrueCrypt format) because the optimizer
	  ends up better without it.
	Ensure we're not disabling LUT3 for SHA1 or SHA2 (where it does good)
	  when we do so for eg. MD4 or MD5 in multi-algo formats.
	Twofish, GOST and Blake256: Omit some "sensitive data wiping" that we
	  don't need or want in this application.
	NTLMv1/MSCHAP formats: Add an atomic guard before or'ing into shared
	  bitmap. See #3160.
	Fix a truncation vs. rejection bug introduced recently. Closes #3164
	OpenCL: Add new options --lws=N and --gws=N for forcing local and/or
	  global work sizes. Unlike the good old environment variables
	  (LWS/GWS), the new options will be stored in the session file
	  ensuring a resumed session keeps same values.
	rar2john.c: Fix buffer overflow w/ long path/file names. Closes #3114
	Refactor common-opencl.[ch] to opencl_common.[ch]. Otherwise no-op.
	Fix cosmetic bugs in size output from --list=opencl-devices.
	Monero format: cn_slow_hash() had a 2 MB stack-variable that caused
	  many systems to segfault (esp. with OMP). Changed it to alloc/free
	  since it wont affect speed anyway. Also some minor tweaks to Monero
	  itself. See #3156.
	Bitwarden format: Do not decrypt more than needed. See #3156. This
	  probably fixes the segfaults as well - we were reading past the end
	  of salt->blob - but I could never reproduce that segfault. The
	  OpenCL format had it right already.
	CircleCI script: Use '#!/bin/bash -e' for catching any error.
	Keepass formats: Bump MAX_CONT_SIZE to 16 MB. Some kernel rewrite was
	  needed for handling that. Closes #3169.
	Mask mode: Never stretch a hybrid mask. Closes #3189.
	Add a FMT_MASK flag, telling us the format supports internal mask.
	  Warn user if such format is used without mask acceleration. Closes
	  #3046.
	OpenCL LM and DEScrypt: Add FMT_MASK flag.
	cracker.c: Do not use a copy of db->fmt->params, it's volatile in
	  Jumbo at least after soon coming mask mode changes.
	Revert "OpenCL: warn if --dev lists more OpenCL devices than fork"
	OpenCL: Bail out if --dev lists more OpenCL devices than fork or MPI
	  nodes. Closes #3176
	Tweaks for poor-mans-multiple-GPU vs. fork/MPI. See #3176.
	Add --list=format-all-details output for internal mask generation. Add
	  format group --format=mask, eg:
	Prepare a bunch of OpenCL formats for having reset() called again
	  during a crack (eg. after changing internal mask).
	OpenCL formats bug fixes. Due to the way things are freed, we need to
	  use calloc() or we may get into trouble. Also drop some artefacts.
	LM-opencl: Revert all recent changes until I figure out what the heck
	  is wrong with it (build bots fail, double free despite using
	  MEM_FREE macro)
	doc/MASK: Document the "--test --mask" feature and some other internal
	  mask details.
	Remove dead code and superflous zero-initializations of
	  globals/statics.
	oldoffice-opencl format: minor tweaks.
	Revert some "dead code removal" that wasn't dead code >.<
	OpenCL SHA1 kernel: Bugfix for mysql-sha1 when using internal mask.
	  Due to double non-CTX SHA-1, initial key is thrashed and need
	  rebuild for each internal mask candidate. Closes #3198
	Internal mask formats: Prepare for better mask mode support.
	  De-obfuscate some of Sayantan's code. Various fixes.
	Drop many assert()'s from Sayantan's code. We've had them for years
	  and they never triggered. A few were replaced with proper code
	  (message and error).
	Mask mode: Enhance mask-stretching, plus other significant
	  enhancements and bug fixes. We can now stretch a mask like "?dword"
	  and iterate lengths (eg. --min-len=5), for zero or more digits
	  prepended to "word".
	Mask mode, fix session resume.
	Update best64 rules from upstream (which is hashcat). Closes #3202.
	Shared OpenCL pbkdf2-hmac-sha1 format. Allow not defining OUTLEN
	  (salt->outlen will be used instead) as long as you instead define
	  MAX_OUTLEN to whatever the biggest length is.
	OpenCL PBKDF2-HMAC-SHA256: Add support for multi-limb output (ie.
	  output length beyond 32). Closes #3172.
	Add "hashcat logic" flag when sourcing base64.conf, and fix a bug in
	  rules.c for handling that. Closes #3208.
	Ansible CPU format: Use "skip bytes" correctly. 2x boost just like
	  that. See #3171, #3172, #3211. GPU format fix coming soon.
	Add "skip bytes" functionality to OpenCL PBKDF2-HMAC-SHA256, for a 2x
	  boost in Ansible format. See #3171, #3172, #3210.
	New Ansible kernel with on-board HMAC-SHA256 for the last 5% boost.
	  Now we're close to optimal. See #3171, #3172, #3210.
	Add mask info to the "Proceeding with..." messages printed when
	  resuming.
	Mask mode: Allow stretching a mask like PASS?dWORD --> PASS?d?dWORD.
	  We will find the first range and repeat it.
	Benchmark tweaks: Show GPU utilization even with 1-second benchmarks,
	  and add a "mask accel" notice inside the algo name brackets when
	  applicable. Also move the note that we are benchmarking with UTF-8
	  or a codepage into the brackets.
	bench.c: Move the "GPU util" figure from benchmark to the first speed
	  output line, to cut a little on line lengths.
	More tweaks for benchmark output: When benchmarking with a codepage,
	  include its name in output. Also fix generic legacy build.
	KRB5-ASREP CPU format: Bug fixes. The magic spell "// XXX" is proven
	  ineffective, it actually does not fix things. See #3213.
	OpenCL shared AES code: Bugfix for (unused as of now) AES_cbc_encrypt,
	  and add CTS mode functions. This in preparation for KRB5-ASREP
	  format enhancements. See #3213.
	OpenCL shared HMAC-SHA1 code: Bug fix for a use-case we don't have
	  yet. This in preparation for KRB5-ASREP format enhancements. See
	  #3213.
	KRB5-ASREP CPU format: Don't produce 32 bits of key when we only need
	  16 (2x boost for etype 17). And fix a cosmetic bug.
	memory.[ch] and opencl_misc.h: Drop most of the ridiculous number of
	  "dump_stuff()" functions and add macro shortcuts for dumping an
	  array or variable:
	KRB5 AS-REP OpenCL format: Do everything on GPU (2x boost) and drop
	  OMP. Don't produce 32 bits of key when we only need 16 (another 2x
	  boost for etype 17). And fix a couple of bugs. Closes #3213.
	NVIDIA bug workaround for krb5-asrep-opencl. An alternative
	  workaround is to use --force-vector=2, See #3214.
	rar2john was using dump_stuff() stuff without sourcing memory.h
	KeePass OpenCL format has its own memcmp_pmc() and can't use the
	  shared one.
	There were artefacts left from older "GPU util" reports when
	  benchmarking, producing a wierd output with several-formats --test.
	  Also, do the sensor readings a bit earlier so we don't get lowered
	  figures.
	Some quick fixes until I understand WTH is wrong with Windows builds.
	Ethereum-presale-opencl: *Use* the PBKDF2 kernel instead of bloody
	  copying it! Closes #3215.
	macOS fixes after changing the PBKDF2-SHA256 kernel.
	Ethereum Presale formats: Exploit the fact they did not use a proper
	  salt for PBKDF2. Huge boost when attacking many salts.
	Bug fix for Ethereum Presale no-salt-exploit.
	Add a little safety around Presale no-salt-exploit stuff. Some oddness
	  with self-tests (I think) could trigger problems.
	Allow SAP B and G formats to crack "half hashes" taken from
	  RFC_READ_TABLE. To enable this, set john.conf "SAPhalfHashes = Y".
	Fix a misplaced line (after using patch -F3) in fvde-opencl.
	zip2john bug fix for certain files. See john-users ML:
	  http://www.openwall.com/lists/john-users/2018/03/26/15
	JtR normally does not apply rules to an empty word. Hashcat does, so
	  this commit makes us do so too if "hashcat logic" is turned on.
	Mask mode: Start iterating from given mask's length if no --min-len
	  was given. Also fix a bug where we sometimes failed resetting the
	  format although GPU-side mask changed.
	Add current device's "internal mask target" to
	  --list=format-all-details.
	Fix a problem with !OS_TIMER systems where sig_timer_emu_tick() was
	  called before we had any handler in place for it. Closes #3226.
	bt.c: Do not use alarm(3) because it may clash with our other uses of
	  timers. Adjust the figure for where we print a warning about many
	  loaded hashes. See #3226.
	Fix a tpyo in bt_hash_type_*.c
	Mask mode: When iterating but no min-len given, do not consider a
	  default mask's length for min-len.
	Cosmetic bug fix: After recent changes, status lines would sometimes
	  include a "current mask length" even though not iterating over
	  length.
	krb5pa-sha1-opencl: Do everything on GPU (similar to
	  krb5asrep-aes-opencl). This rendered a 50% boost and GPU util now
	  99%. See #3216.
	KRB5PA-SHA1 formats: Revert shrinking of a few buffers. I really can't
	  see why but ASan tells me it's needed (single-block AES so 16 bytes
	  should do, but 32 is needed).
	Drop a shared pbkdf2 macro that should be local to formats. Drop some
	  redundant artefact from PBKDF2-HMAC-SHA512 OpenCL formats.
	OpenCL HMAC-SHA256 bugfix (copy/paste bug from SHA-1, never surfaced).
	OpenCL GELI format: Do all work on GPU-side. This commit also adds
	  shared OpenCL code for HMAC-SHA512. About 3x boost non-OMP and GPU
	  util now 100%. See #3216.
	GELI-opencl, fix algo name after post-processing moved to GPU-side.
	zip-opencl: Avoid a warning on some platforms.
	GELI-opencl: Work around an AMD bug.
	Shared HMAC-SHA-2 OpenCL code: Fix bugs that never surfaced yet
	  (alternative code path, still not tested at all).
	PEM format: Cosmetic (code) bug fix.
	OpenCL PEM format: Do all work (3DES/AES and ASN.1 decoding) on
	  GPU-side. Boost is in the order of 10x and GPU utilization went from
	  N/A to 100%. See #3216.
	Minor completion of PEM formats' algorithm name.
	ODF format: Post-process on GPU (Blowfish, SHA-1) and join with
	  ODF-AES so we only have one format just as for CPU (cost added).
	  See #3216.
	Rename ssh-ng format to just ssh, and sshng2john.py to ssh2john.py.
	  Closes #3231.
	Documentation fix after renaming ssh-ng format. See #3231.
	Have autoconf check for function instead of trusting OpenSSL version
	  number. Closes #3163.
	SSH format: Tweak the "cost" stuff so we can tell 3DES from AES.
	  Closes #3229.
	SSH format: Drop a sub-percent optimization and instead optimize the
	  generic function and stop initializing large arrays to zero right
	  before filling them with other data.
	OMP/MKPC auto-tune bugfix. See #3229
	mask.c: Avoid dupe output with fork/MPI.
	unicode.h bugfix (not used right now).
	Correction of hex representation of a new line character in doc/RULES.
	  This little "bug" has been with us all the way since 2012.
	Keystore-opencl: Move work from set_salt to get_salt. Do not
	  re-transfer keys when not changed. Use packed key transfer (GPU-side
	  mask still needed) and bump max password length to max. Bump GPU
	  salt size, there was never any reason to cripple the format in that
	  regard. We (now) only transfer actual used size. The OpenCL 1.2 spec
	  mandates a minimum size of 64 KB so that is what we currently go
	  for. We could also opt for dynamically switching to global memory if
	  (and only when) a larger size is needed.
	Shared OpenCL code for HMAC-SHA256 fixes.
	PEM formats: Add 2nd cost "cipher".
	Assorted OpenCL macOS tweaks/bug workarounds. This makes PEM-opencl
	  work with the Intel(R) HD Graphics 630, and oldoffice-opencl with
	  AMD Radeon Pro 560 Compute Engine (and the latter fix may help other
	  formats too).
	Adjust core count (which in turn affects speed index) for Intel GPUs.
	  Closes #3238.
	Assume an unknown AMD is a GCN, since most others should have died
	  from age by now. This is a temporary workaround for #3237.
	Correction of 2nd cost description for PEM formats. Closes #3236.
	Fix some bogosities in blockchain CPU format.
	Blockchain OpenCL: Move CPU post-processing to GPU. Some 13x boost and
	  GPU utilization (with single-thread CPU) up from 5% to 99%. See
	  #3216.
	KeePass formats: Add 3rd cost "algo" for testing purposes.
	OpenCL shared AES: Clean up, separate basic AES from cipher modes and
	  OpenCL memory type handling. Introduce alternative code (the one we
	  used prior to 1a0704f) for use by buggy OpenCL runtimes in some
	  cases. See #3235.
	OpenCL: Improve shared debug stuff.
	OpenCL: macOS+AMD bug workaround for TwoFish on GPU. See #3235.
	Work around a macOS runtime bug for AMD GPU. See #3235.
	Revert the disabling of bitselect for OSX. There was regression
	  (sha256crypt format now failed w/ CPU). Narrowing it to only
	  disabling bitselect in swaps did not help.
	Add support for knowing core count of nvidia Volta. This is untested.
	Move the AES-XTS code from Truecrypt kernel to the shared AES code.
	Reduce transfer size a little for md5crypt-opencl.
	Fix a few stupid ass bugs sneaking in while I looked the other
	  direction.
	Truecrypt OpenCL: Bugfix after recent moves of code.
	OpenCL: Move check_pkcs_pad() from DMG kernel to opencl_misc.h, and
	  drop the copies in agile and pem kernels.
	Keychain-opencl: Post-process on GPU. See #3216.
	Shared OpenCL: Fix a compiler warning. See #3239.
	STRIP OpenCL: Post-process on GPU. See #3216.
	Lastpass OpenCL formats: Post-process on GPU. See #3216.
	STRIP and Lastpass OpenCL: Don't re-transfer same key data.
	Allow using custom mask placeholders along with --test
	OpenCL: Ensure --force-scalar always equals --force-vector=1.
	Change phpass-opencl from hard-coded vector width 8, to variable width
	  and use whatever the device announces as preferred width. Also bump
	  max. length from 15 to 39 and get rid of ALL use of 8-bit data types
	  in the kernel (NOTE: test vectors changed so boost is even better
	  than the looks of it). See #3216.
	A couple of issues found when researching candidates for #3242: Drop
	  "Blowfish" from encfs formats' algo name. It was incorrect. Drop old
	  now unused 'any_cracked' variable from keyring-opencl.
	phpass-opencl: Packed key transfer.
	Fix an ASan warning seen in WPAPSK-opencl (benign, read beyond stack
	  buf).
	Revert "phpass-opencl: Packed key transfer". It was prematurely pushed
	  upstream.
	Bug workaround for shared SHA1-CTX for macOS w/ AMD GPU. This makes a
	  few more formats pass self-test, at least PGPdisk, OpenBSD-SoftRAID,
	  krb5pa-sha1 and krb5asrep-aes. See #3235.
	Add 2nd cost "algorithm" for PGPdisk, for benchmarking purposes.
	Revert shrinking a buffer in pgpdisk (CPU). It was needed due to a
	  stoopid function using more than requested of it.
	EncFS OpenCL: Post-process on GPU (AES-CFB, HMAC-SHA1, checksum).
	  Addresses #3242.
	PGPdisk OpenCL: Post-process on GPU (AES/TwoFish/CAST). Addresses
	  #3242.
	PGPdisk-opencl: Separate kernels per salt, for better optimizations.
	PGPSDA OpenCL format: Post-process (CAST) on GPU. See 3242.
	Ethereum OpenCL format: Post-process (Keccak) on GPU. See #3242.
	Ethereum-presale OpenCL: I was confused and introduced a bug in recent
	  commit. GLOBAL_SALT_NO_INIT means the PBKDF2 salt is __global but
	  not the "salt" struct!
	RAR5 OpenCL: Post-process on GPU. Closes #3242.
	7z-opencl: Correct case in algo name.
	Shared OpenCL MD5: Avoid using "volatile" driver bug workaround unless
	  needed. The Intel(R) HD Graphics 630 took a huge performance hit
	  while it worked fine without it (the workaround is needed for AMD
	  Radeon Pro).
	Jim decided to put a test vector with "1 iteration" in
	  pbkdf2-hmac-md5. That's OK but it shouldn't have been the first one.
	  Benchmarks were off and even worse, auto-tune was f*cked too.
	Drop the pull-request template (I see no need for it) and trim the
	  issue template down a bit. The more text, the less chance Joe Blow
	  will read it.
	Add/remove/tweak workarounds for macOS OpenCL runtime/driver bugs. See
	  #3235.
	De-optimized OpenCL kernel to some extent for office 2013, works on
	  macOS now (and shouldn't really affect better devices/drivers). The
	  runtime optimizers are so buggy it's a mystery they work at all. See
	  #3235.
	More of add/remove/tweak workarounds for macOS OpenCL runtime/driver
	  bugs. See #3235.
	Change uint in host code to uint32_t. See #3246
	More of add/remove/tweak workarounds for macOS OpenCL runtime/driver
	  bugs. See #3235. Also drop/rework a dangerous (in terms of
	  potential bugs) nvidia optimization and replace with a safe one (for
	  any arch).
	Finally found the problem with macOS/AMD crashing while building
	  md5crypt OpenCL kernel. The check for support for amd_bitalign was
	  flawed and macOS never supports proprietary stuff. See #3235.
	OpenCL: Re-implement more optimizations for aligned buffer in shared
	  MD4/MD5/SHA1/SHA2 code (and fix a bug). See af150a18.
	Fixes for MINGW OpenCL builds, kudos to BotPass. See #3246.
	Fix warning message when running OpenCL format with CPU
	  post-processing and OpenMP is disabled. Closes #3248.
	opencl_common.c: The buffer for build options were allocated as
	  PATH_BUFFER_SIZE instead of a more logical LINE_BUFFER_SIZE. The
	  former is only 256 bytes on some systems (POSIX has it as 256).
	  Closes #3251.
	Revert a Makefile change (#3246) that broke MinGW buids on build bot.
	Re-apply the Makefile fix but now also fix the ever-broken CircleCi
	  script. Closes #3246.
	A couple more MinGW fixes from #3246 (from BotPass' 2nd patch).
	bcrypt-opencl: Enforce "CPU kernel" for OSX with Intel HD Graphics.
	  Closes #3245.
	Keystore-opencl: Do not allow a GWS larger than 'count'. Closes #3254,
	  see also #3223.
	OpenCL Lotus5, oldoffice and o5logon: Use new scheme of LWS=NULL for
	  less-than-full batches instead of rounding GWS up to LWS multiple.
	  See #3223.
	OpenCL Office: Use new scheme of LWS=NULL for less-than-full batches
	  instead of rounding GWS up to LWS multiple. See #3223.
	OpenCL GELI: Use new scheme of LWS=NULL for less-than-full batches
	  instead of rounding GWS up to LWS multiple. See #3223.
	OpenCL Keyring: Use new scheme of LWS=NULL for less-than-full batches
	  instead of rounding GWS up to LWS multiple. See #3223.
	OpenCL KRB5PA-MD5: Use new scheme of LWS=NULL for less-than-full
	  batches instead of rounding GWS up to LWS multiple. See #3223.
	OpenCL NTLMv2: Use new scheme of LWS=NULL for less-than-full batches
	  instead of rounding GWS up to LWS multiple. See #3223.
	Minor cleanups in a few OpenCL formats.
	OpenCL PGPdisk: Use new scheme of LWS=NULL for less-than-full batches
	  instead of rounding GWS up to LWS multiple. See #3223.
	OpenCL PGPSDA and PGPWDE formats: Use new scheme of LWS=NULL for
	  less-than-full batches instead of rounding GWS up to LWS multiple.
	  See #3223.
	OpenCL shared check_pkcs_pad() was slightly too promiscuous; it let
	  anything with a trailing null through (possible false positives, so
	  no sweat).
	A couple of minor FORMAT_NAME vs. FORMAT_LABEL fixes.
	Debug function tweaks, and minor fixes in int128.h. This is a no-op.
	cprepair: Avoid a conflict with memory.h
	Many OpenCL formats: Use new scheme of LWS=NULL for less-than-full
	  batches instead of rounding GWS up to LWS multiple. See #3223.
	GPU mask: Decrease verbosity needed for seeing auto-tune mask
	  multiplier.
	The "spinning wheel" cursor sometimes left an artifact after use.
	Bitlocker formats: Drop the fake test vectors that messed with
	  reported benchmark speed, and set a better autotune target that will
	  actually make the format perform good (although a bit unresponsive)
	  IRL.
	Stop piggy-backing arguments and drop the notion of "max crypt_all
	  time" from OpenCL autotune, it was an artifact. Closes #3278.
	wpapcap2john: Handle QoS packets with four addresses. Closes #3282.
	Internal mask: Fix a cosmetic bug with MaskLengthIterStatus=Y where
	  we'd output the old length instead of the new one, and incorrect
	  ETA/progress.
	Mitigate a benchmark regression introduced in e5b031e. See #3289.
	Autoconf: Add a way to check if -Wno-foo is supported. This has to be
	  implemented by checking if -Wfoo is supported because the "no-"
	  forms will soft-fail.
	OpenCL PBKDF2-SHA1: Support longer candidates.
	OpenCL DMG format: Support longer candidates. Test vector needed!
	dynamic.conf clean-up. Sort entries and update the "synopsis". Closes
	  #3346.
	dynamic.conf clean-up. Change a few ($p,$s) to ($p.$s). See #3346.
	Define out (unless -DDEBUG) three very slow test vectors from DMG
	  formats. See #3344.
	Ethereum bugfix. There was a race condition with new_keys variable,
	  it must be reset outside the parallel section. Closes #3344.
	WPAPSK and -PMK formats: Add support for PMKID. Closes #3356.
	Avoid a problem with some internal-mask formats reading stale data in
	  get_key(). Addresses #3358.
	wpapcap2john: Support reading TZSP encapsulated files directly. Closes
	  #3282.
	WPAPSK/PMK formats: Drop some duplicated code. Closes #3359.
	WPA formats: Add a missing salt_hash() function, greatly speeding up
	  loading of many hashes.
	wpapcap2john: Add support for getting PMKID hashes. Closes #3364.
	Meta data tweaks for wpapcap2john output.
	Usage blurb fixes for wpapcap2john
	wpapcap2john: Tweaks for edge cases and lack of (or late) ESSID clues.
	wpapcap2john: Support reading pcap-ng format. Closes #3371.
	Brainfart fix in wpapcap2john. Not sure why some compilers accepted
	  it.
	wpapcap2john: Handle mac filtering of addr3 and addr4, and fix some
	  edge- cases where BSSID was possibly picked from wrong field. Closes
	  #3373.
	wpapcap2john: Replace some repeated code with a more robust function.
	mask.c bugfix, see #3381.
	OpenCL: Avoid anonymous unions. Some buggy AMD/clang runtime seems to
	  have problem with it. Closes #3387.
	AC: Ignore PERL_UNICODE=SDA for plugin dependency check. Closes #3380.
	Avoid calling init() for --list=(...) options with ZTEX formats. See
	  #3379.
	AC: Find OpenSSL on macOS Homebrew without any special options. To
	  achieve this I had to disable pkg-config by default, because it's
	  broken. Actually I can't remember having seen a non-broken
	  pkg-config in my entire life so it's probably a good thing in most
	  cases but it might break some other system so you'd have to add
	  --enable-pkg-config to the configure options. This hopefully
	  addresses #2347.
	There's something wrong with our scatter intrinsics (FLAT_OUT option)
	  for AVX512 and the MIC, we just disable using them for now. See
	  #2273.
	simd-instrinsics.c: Code style, no-op.
	Bug fix for our 'vscatter' pseudo-intrinsics, and re-enable it
	  (currently affects AVX512 and MIC). Fixes #2273 properly.
	Drop john.conf boolean option WordlistMemoryMap and replace it with a
	  numeric option WordlistMemoryMapMaxSize defaulting to one terabyte.
	Multibit format: Add FMT_UTF8 flag, and disable a test vector that is
	  encoding-specific (it will fail for any encoding not having this
	  character). Closes #3393.
	listconf.c: OpenSSL deprectated SSLeay functions for version
	  enumeration. Handle both situations. Closes #3396.
	Ensure we show AVX512 "level" (eg. AVX512F, AVX512BW) in algorithm
	  names.
	Alignment bug fix for VS build of argon2_core.h, found by coincidence.
	Fix comments in john.conf - eg. "there" vs. "their" and over-long
	  lines.
	Travis CI: Include -list=build-info (CircleCI already got it).
	We go out of our way to safely fetch a silly run-time version figure
	  from OpenSSL despite them being complete bastards, renaming the very
	  function that could otherwise have been used to work around their
	  crazy decisions. Closes #3402.
	Fix incremental mode's ETA calculation when CharCount (in john.conf)
	  is lower than actual number of characters available. See #3404.
	Change our vswapxx pseudo-intrinsics so they just return the result,
	  without changing input. This sometimes allow optimizations. Neither
	  our OpenCL macros nor the johnswap.h CPU macros modify the input.
	pseudo-intrinsics.h: Cosmetics
	Enable AVX-512 for bitslice DES in simplest possible way. Closes
	  #2274. See also #3399.
	AVX-512 adds rotate instructions. Using them makes for a terrific
	  boost (25-50%) for all hash functions! See #3399.
	05272574c broke AMD NEON, this fixes it (and more).
	getopt.c: Do not consider an abbreviated option to be ambiguous when
	  the first alternative is a prefix of all others. See #3404.
	Internal: Command-line override of CharCount,
	  --incremental-charcount=N. See #3404.
	Pseudo-intrinsics: Alternative vswap32() for AVX-512F and others
	  having non-emulated vcmov and vroti.
	Only use the alternative s0/s1 functions for SHA-512 if we emulate
	  vroti (this is another 20% boost for AVX-512).
	SIMD code, cosmetic changes/future logic.
	Alternative SHA-2 sigma functions for OpenCL. The ones for SHA-256
	  tested 2% faster on nvidia. The ones for SHA-512 are slower because
	  we have native rotates.
	zip2john: Try old pkzip function when "strong encryption" clause
	  fails. See #3411.
	Optimize vroti16 for AVX2 (used in MD5). We've had this optimization
	  for SSSE3 up to AVX but missed it for AVX2 until now.
	john.c: Tweak the "Use the --show option..." message for formats that
	  have a prepare() function (suggesting to use --format as well).
	  Closes #3412.
	SHA-2 Sigma/sigma alternatives for SIMD and OpenCL code. 3% boost for
	  AVX2.
	SHA-1 optimization with ternarylogic, another 5% boost for AVX-512.
	Add a vternarylogic emulator for AVX2 (only for debugging).
	SHA-2 SIMD and OpenCL shared code: Add yet another set of alternative
	  sigma functions. These use vternarylogic or LOP3.LUT. This was again
	  a regression for nvidia so not used there, but it made another 10%
	  boost for AVX-512 and a compound boost over last month of 70-77% for
	  SHA-2. See #3399.
	Support correct speed calculation on nvidia Turing (untested).
	AC: Change positive output of HT test to read "maybe". Closes #3418.
	README.md: Change from travis-ci.org to travis-ci.com
	--loopback mode: Add a notice about what permutation rules are in use.
	pseudo-intrinsics.h: Fix a bug affecting eg. ppc64, introduced in
	  05272574. See #3428.
	rar2john: Fix a bug where we would pick a zero-byte file as target
	  despite a comment saying we wouldn't. Closes #3431.
	Dynamic: Change an erratic unsigned long to uintptr_t. See #3122.
	Add a self-test for salt_hash() returning zero with zero-size salt.
	Autoconf: Fix for OpenCL detection problem with macOS Mojave. Closes
	  #3429.
	OpenCL cloudkeychain: Drop an unused variable.
	OpenCL: Disable kernel binary caching for macOS - some bug of theirs
	  make it problematic. Closes #3434.
	OpenCL DMG & krb5-sha1 formats: Do not use bitslice AES for macOS. See
	  #3435.
	OMP auto-tune fix for sha256crypt et al, who uses a multiplier in
	  init(). See #3436.
	Pseudo intrinsics: Drop union members that are not used.
	sha2crypt CPU formats: review OMP tune after fixing the bug in
	  23bff737.
	Autoconf: Change -Wno-stringop-truncation to
	  -Wno-error=stringop-truncation and add -Wno-error=format-overflow.
	Update doc/INSTALL-UBUNTU, kudos to @junquera. Closes #3439.
	Bump SIMD max. salt length in HMAC-SHA256 format to accomodate for
	  some JWT tokens. Also see #2318. Closes #3443.
	Bug fix for previous commit. See #3443.
	Rules dupe suppression was saying it removed "!! hashcat logic ON/OFF"
	  duplicates. I'm not 100% sure it actually had any ill effect but for
	  peace of mind I changed the code so it doesn't remove them for sure.
	Suppress over-detailed logging of dupe rule suppression unless
	  verbosity is bumped to the max.
	Add a rules subdirectory under run and put more hashcat rule files in
	  there. We already had best64, which was merely renamed.
	Shared Unicode stuff: Add strlen32() for future use.
	RAR formats: Add a padding check for very small files, to mitigate
	  false positives due to CRC32 collisions. Closes #3451.
	rar2john: Bump file name buffer size to ensure it can hold worst-case
	  UTF-8 as well.
	zip2john: Fix a few potentially uninitialized variables after a42fd75
	  #3447
	Update CREDITS-jumbo and CHANGES-jumbo.git files
	Update Unicode stuff from 7.0.0 to 11.0.0. A bug was also fixed in the
	  script I use to process data, so some dupe entries were pruned.
	RAR formats: Change the logic for method 0x30 padding check so we get
	  early rejection for large files if they have any padding at all.
	Add a build #warning when Electrum is not built because of missing
	  zlib. Closes #3456.
	It seems that MESA defines cl_amd_media_ops but then doesn't support
	  it. That must be the dumbest bug ever. Closes #3454.
	RAR bugfix after recent changes (we had false positives).
	zip2john: Add another warning, when needed, about the assumption that
	  all files have the same password. Also mutes some erroneous partial
	  diagnostic output. Closes #3464.
	Debug stuff and workarounds for #3450, #2457. General audit of shared
	  OpenCL code, for uninitialized variables and unified error messages.
	  Do not blindly trust OpenCL drivers' compliance.
	Refactor john-mpi.[ch] to john_mpi.[ch] and move the #if HAVE_MPI to
	  the header. Closes #3463.
	zip2john tweaks. See discussion in #3462.
	zip2john: Fix a silly bug and a memory leak introduced by previous
	  commit.
	Fix a bug where loopback mode would interfere with --max-len option.
	pp.c: Sync with upstream as of bffda8c (Thu Jul 5 11:53:15 2018
	  +0200). No significant changes.
	Update .gitignore
	Fast subsets cracking mode, with full Unicode 11.0.0 support.
	Add a debugging verbosity level, --verbosity=6 and have "plaintext"
	  format print its candidates at debug verbosity.
	Single mode: Split on upper-case initials when loading words.
	Legacy build fix.
	Another legacy build fix.
	Colorize output for cracked administrator passwords.
	Rules: Add WN rule command, which is like TN except it toggles shift
	  instead of merely case. That is, it does what TN does but it also
	  toggles eg. 1 <-> !, 2 <-> @ and 3 <-> #.
	Enhance the default loopback ruleset: Use the new ShiftToggle instead
	  of the alphabet-only NT toggler. Also add three really basic rules,
	  suitable for loopback.
	OpenCL: Numerical error codes were sometimes printed twice because
	  get_error_name() already adds it to its output string.
	OpenCL: Print node number on error.
	New WN rule can't be used with -c rule rejection so could produce a
	  humongous number of duplicates for a case insensitive format (eg.
	  foo and FOO). This had me figure out a canonical way to fix that
	  and similar problems without using a rule flag. It's effective on
	  most rules that use conv_* arrays.
	Add "toor" and "sa" as admin names (exact match except for case).
	Tweak the handling of --max-len=N option vs. rules, for a huge
	  performance boost in many situations. See #3467, #3468.
	--rules=NT: Add rule reject flags and length reject commands, for some
	  boost in general and when using --max-len=N option in particular.
	Expose min_length constant in rules (#3471)
	OpenCL: Use a min. KPC better optimal for Single mode. See #3467.
	Ensure the capping of min. KPC doesn't roll over to negative. See
	  #3467
	Ensure a large salt count doesn't result in too much memory use. The
	  default limit is set to 4 GB but it's a john.conf setting.
	Wrap opencl_common.h in #if HAVE_OPENCL so we can source it even for
	  non-OpenCL builds.
	Drop #ifdef guards around '#include "opencl_common.h"' now that the
	  header itself is wrapped.
	Single mode: Fix bugs with --max-len handling.
	Minor fixes for warning messages.
	Fix bugs in human_prefix() and have it return a tiny-alloced string.
	  The latter meant I also had to move it to misc.c.
	Add rule constants for min_length-1 and min_length+1. See #3471
	Editorconfig: Give up on using length 8 tabs for single.c
	Change single mode's key buffer's index and offset type to 32-bit for
	  OpenCL ansd ZTEX builds. 16-bit is not enough for them. Also improve
	  the way we try to adopt to the buffer size limit: First decrease
	  max. length (if larger than 16). See #3467.
	Rules logging tweaks and bug fixes.
	Tweaks for 32-bit single key buffer size/index.
	7z2john.pl: Update from upstream.
	rar2john: Avoid compressed files shorter than 4 bytes, to avoid false
	  positives. See #3477
	rar2john: Avoid compressed files shorter than 4 bytes, to avoid false
	  positives. The previous commit was incorrect. See #3477
	rar2john: Minor enhancement in file choice - we now pick the file with
	  smallest *packed* size of all files that have a larger *unpacked*
	  size than the minimum (which depends on method - for stored files we
	  can use 1-byte files because there is reliable padding but for
	  compressed files we need at least four bytes for avoiding false
	  positives from CRC-32 collisions in case both early rejection and
	  actual uncompress happens to pass (seen once, with 1-byte compressed
	  file in #3477). If we're seeing two files with same packed size we
	  pick the one with smallest unpacked size (as long as it's larger
	  than minimum).
	Single mode bugfix for when we had to decrease max_length in order to
	  fit in max. size buffers. We need options.eff_maxlength to be
	  updated in order not to read past buffer later. See #3467
	Bugfix: --max-cand option wasn't working with Single mode.
	OpenCL: Tweak kernel binary caching and fix some weird bugs with it.
	  We now make/use cached binaries for anything except: - nvidia unless
	  on macOS (nvidia has their own caching but not on macOS) - CPU on
	  macOS (it's somehow b0rken in their runtime).
	rar2john: More minor tweaks for picking "best" file from archive in
	  terms of performance, data size and immunity against false
	  positives.
	Temporary security fix. See #3482 and #3484
	Rename common-gpu.[ch] to gpu_common.[ch].
	rules.c (almost no-op): Move stuff around in rules.c so they appear
	  under correct comment labels such as "Crack rules", "Added in Jumbo"
	  and "Hashcat specific". Also update doc/RULES a little.
	rules.c (no-op): Add most of codepage-specific stuff to new header
	  files to get it cleaner and easier to overview or compare to upstrem
	  john proper.
	Add new early-reject rules, see #3468
	Single mode: Reset max. length and min. KPC to original values when
	  done, in case we're running batch mode.
	Change .editorconfig for a few core files where I officially give up
	  maintaining a tab width of 8.
	Single mode tweaks for better OpenCL performance.
	Single mode: If we're running forked, divide the max. buffer size so
	  we don't end up eating more memory than was intended.
	Bugfix for toys unable to provide fork.
	Warn about too few candidate passwords. See #3386
	The 'bench_running' timer flag has long been mis-used for other
	  things.
	Add min/max length limits (if given) to the "Proceeding with..."
	  message that goes to screen when session is resumed. Also enable
	  that message for batch mode, even if not resuming.
	cracker.c: Don't mute KPC warnings when iterating mask. Also fix an
	  MPI logic bug in single.c.
	Bugfix in OldOffice-opencl after 9cc4e0193.
	Fix bugs in Jumbo-specific part of ldr_split_string() (and improve it
	  to boot!), and fix a performance bug with list_add_global_unique().
	  Closes #3494.
	Our shared enc_isupper/lower functions were stupidly slow. Fix them
	  and add enc_isdigit(). Using this, vastly improve the Jumbo-specific
	  pass in ldr_split_string() but make it optional (should have been
	  from the point of introduction).
	Reduce pot sync log messages, only show them for mother process. Also
	  drop some old debug info, the pot sync functionality is well tested
	  now.
	Turn off self_test_running flag earlier in case of --skip-self-tests.
	Drop the separate GET_NEXT_MULTIPLE_VW macro and have
	  GET_NEXT_MULTIPLE vector-aware instead.
	Comment tpyo in rules.c
	Single mode: Dynamically increase SINGLE_WORDS_PAIR_MAX if we have a
	  large key_count, currently using log2(key_count).
	Add john.conf option RelaxKPCWarningCheck, defaulting to true. If set,
	  we only warn if count is less than (min_kpc - min_kpc / num_salts).
	  This means we don't warn at all for single-salt/unsalted. For 10
	  salts, we allow 10% less than min_keys without a warning, for 100
	  salts we allow 1% and so on. See #3386
	Update docs with warnings about MPI. Also fix some over-long lines
	  and miss-spellings of the terrific word "automagic" ;-) Closes
	  #3493.
	Update docs with information on single mode operation with GPU. Closes
	  #3504
	Change the default for RelaxKPCWarningCheck to false, but mention the
	  setting with the warning output (the 10th/last line, and only for
	  main process). See #3386.
	Single mode on GPU prioritizes speed over resumability. Add a user
	  setting to change that. See #3467.
	Bug fix in the "marie -> mary" rule stemming from john proper. See
	  https://www.openwall.com/lists/john-users/2018/12/06/1
	Single mode with OpenCL/ZTEX: Log SinglePrioResume setting.
	OpenCL "speed index" function: When resorting to using vector width as
	  a factor, use sizeof(long) instead of sizeof(int). See #3502
	Revise the workaround and debug stuff for OpenCL + MPI race condition.
	  We now only ever do it for MPI and only when actually running more
	  than one process. Also, we don't create any lock file - instead we
	  lock the kernel source file for writing (although we don't touch
	  it).
	Prince mode: Ensure "last" buffer for rules_apply is aligned.
	Print LWS/GWS info at normal verbosity, just not for benchmarks.
	  Optionally agree on LWS and GWS for whole MPI cluster.
	OpenCL: Optionally synthesize -lws -gws to session file if applicable.
	Rules: Add a hack for recognizing Hashcat's '-' command even if not in
	  "hashcat logic" mode..
	Add some rules optimizations (mostly rejection flags/commands).
	Add optimization flags to KoreLogic rules.
	Stacked rules. New option --rules-stack=(SECTION[,..]|:rule[;..]) adds
	  a second pass of rules, applied after normal processing.
	Document the important difference between --stdout=LENGTH and instead
	  using --stdout --max-len=LENGTH.
	Change john.o optimization from -O0 to -O1 due to this:
	Refactor FMT_UTF8 --> FMT_ENC. This is a no-op change, binary should
	  stay identical. See #3509.
	Use the new FMT_UTF8 flag to ensure some format gets correct input
	  encoding. Closes #3509
	Update .gitignore with some common test/temp-files patterns.
	Introduce a few UTF-8-32 functions in unicode.c, and use them in the
	  Subsets mode. See #3510.
	Halve the memory use for Single mode buffers, for OpenMP builds
	  without OpenCL support. We should make the choice at runtime
	  instead! See #3467
	Mute stringop-truncation warnings from gcc. We believe they're all
	  false positives. We do NOT mute them for ASan or memdbg builds so
	  when we want to see them for auditing code, they'll be there.
	  Closes #3499
	Replace some strncpy's where we require padding, with a function that
	  does the same but shouldn't trigger gcc warnings - and that has a
	  name telling a reviewer it's deliberate. See #3499, #3127
	Single mode: - Bugfix: params.h was using HAVE_OPENMP where _OPENMP is
	  correct. - Let ZTEX-builds (non-OpenCL at that) use 16-bit index and
	  32-bit offsets just like OpenMP, for a usable 32K KPC and roughly
	  half the memory footprint compared to OpenCL which has 32-bit
	  indeces as well.
	--list=build-info: Show effective limits for Single mode.
	Fix "Proceeding with..." messages for lengths when hybrid mask is in
	  use.
	Add compiler directives for suppressing some gcc format-overflow false
	  positives. See #3521
	OpenCL: Drop some obsolete bug workarounds. See #3525
	UTF-8 to UTF-16 conversions in shared code and OpenCL kernels: Drop a
	  few redundant checks that apparently wasn't optimizaed away.
	Add a shared function for converting UTF-8 to UTF-8-32.
	Self-test: Add a few sanity checks for format flags.
	SAP H format: Drop an erroneous FMT_ENC flag as well as a
	  re-implementation of fmt_default_split().
	SAP H format really expects UTF-8 so we set that flag (with it's new
	  meaning as of recent changes) to get warnings if target encoding is
	  something else.
	Update CREDITS-jumbo and CHANGES-jumbo.git
	Fix undefined behavior, similar to eefe9047
	Change nice(20) to nice(19), see #3513
	Portability fix for idle.c
	All perl scripts: Use perl from PATH instead of hard-coded
	  /usr/bin/perl
	Cosmetic fixes to -list=build-info
	Cosmetic changes to single mode warning texts.
	Add a free() in cracker.c to aid in finding real leaks. Closes #3543
	cracker.c: Change last commit so it's like upstream john proper
	  instead. The free was removed by Jim in de7b7c63 back in 2013 as he
	  changed the alloc to mem_alloc_tiny for unclear reasons. Then at
	  some point that was reverted by a core merge without the free
	  getting its way back.
	ETA/Progress fixes (some were b0rken after --rules-stack).
	Drop an accidentally committed debug line.
	Tweak the human_prefix function for more correct output. Drop a
	  similar function in opencl_common.c and use shared one.
	Single mode: Call crk_done() after we're finished. Closes #3554
	WPAPSK salt_hash() improvement: Use the last four bytes of MAC address
	  instead of first four. Since the first three are vendor-id, they are
	  much less unique.
	Add run/oui.txt as of 2018-12-26 11:04Z and a Makefile target for
	  manually updating it. See #3567
	--stress-test option: Avoid printing warning more than once.
	--stress-test option: Add stats.
	All perl scripts: Drop '-w' when using 'env perl' and instead ensure
	  all scripts have 'use warning;'
	Single mode "proceeding with" message showed wordlist rules intead of
	  single rules. Closes #3571.
	pass_gen.pl: Stop using OpenSSL stuff where not needed.
	Improve Single mode restore w/ --rules-stack. Closes #3541.
	rules.h: Add missing "external" to a variable declaration.
	single.c: Fix a hard-to-see typo introduced in 5be3ed4908
	rules.c bugfix: Word pair rules with implicit '+' would not update
	  length so could erroneously fail min/max length checks.
	Update misc.c
	Slight change of logic for automagically increasing
	  SingleWordsPairMax.
	unit-tests target: Fix backwards dependencies. (#3586)
	AC: Do not enable unit tests when --disable-native-tests is used.
	  Closes #3601
	UTF-8 tweaks for WPAPSK formats. Remove a ridiculous hard-coded test
	  in formats.c that complained about the change. Closes #3593.
	WPAPSK-PMK formats: Bail out if user clearly has misunderstood the
	  format. Closes #3585.
	Add a --single-retest-guess=BOOL option, overriding john.conf
	  equivalent. See #3594.
	Fix an academic memory leak (only happens at exit) in single.c. See
	  #3594
	Add a limit for recursion depth with SingleRetestGuessed. The default
	  limit is 10000 but can be overridden in john.conf. Closes #3594.
	Bugfix in leet format's valid(). Closes #3584
	Re-print the single mode warning about disabled recursion at session
	  end. (#3604)
	unique: Add support for large buffers/hash tables, and other tweaks.
	unique: Improve options parsing (any option can now come before or
	  after the output filename).
	Unify hccap2john output format with wpapcap2john (don't dash the
	  MACs).
	Add a safe-guard against logins/plaintexts that are printed to the
	  screen with some weird encoding upsets your terminal.
	Fix Progress/ETA bug introduced with stacked rules.
	Fix a division by zero in unique.c
	cracker.c: Detect when a reset() call lowered min. kpc, adjust
	  warnings accordingly (#3674)
	Fix for "make clean" on eg. OS X w/ proper gcc after unit-tests
	  changes. Closes #3675.
	No-op re-order of some john.conf sections before core merge.
	axcrypt2 OpenCL kernel: Drop unused variable.
	Decrease compiler optimization level for unicode_range.c and add a
	  dependency on it for subsets.o. Closes #3636
	unicode_range.c: Work around brain-dead clang claiming to be
	  compatible with gcc despite it isn't. Closes #3691
	Avoid printing device list errors more than once under --fork
	OpenCL auto-tune tweaks. Add backward GWS runs.
	Revision of x86-sse.h and x86-64.h after core merge. Also drop some
	  obsolete stuff from DES_bs_b.c, see #3696
	Change auto-tune password length, as well as length of default mask
	  for "-test -mask", to 7.

JimF (1545):
	configure: removed many function checks (for #910)
	phpass: non-OMP builds were no SIMD, fix #916
	configure: Added arm-NEON instruction detection logic, #911
	change execute bits
	configure: removed many size checks per #910
	bleeding-jumbo version. Set to 1.8.0-jumbo-1+bleeding-jumbo
	bleeding version: changed per magnum
	configure: added LARGEFILE_SUPPORT to many 32 bit systems which were
	  missing it
	configure: LARGEFILE_SUPPORT, added a check for 32 bit systems
	configure: broken case statement
	wrap all include limits.h which were not prior wrapped
	wrap all include locale.h which were not prior wrapped
	haval: failure to build after HAVE_TYPES_H code added
	sph hashes: failure to build after HAVE_TYPES_H code added
	configure: header wrappers for termios.h and sys/params.h
	autoconf: updated logic for _LARGEFILE64_SOURCE, added -DEBUG to ASan
	  added -BSD to 32 bit freebsd ASFLAGS
	autoconf: Removed the header includes that were not needing wrapped
	MODES: document. Added Markov/Mask. Fixes #904
	base64_conv: fixed length is get_len where mime has trailing =
	pass_gen: added sapH
	New POC format, sapH, still very slow
	pass_gen: some debugging stuff left in sapH, removed it
	sapH: added OMP, still only oSSL
	sapH: added cost and did some small speedups reusing buffers better.
	pass_gen.pl: added SIP hash
	sip: added new test vectors made with pass_gen.pl
	SIP: changed to use proper binary, vs the cracked way.
	loader: fixes #930 dynamic hex not being removed from .pot load
	Makefile.in some defines needed. Problem showed up in #933
	cygwin: Fixed #932 fseeko link fail GetFileSizeEx
	SIP: Fixes #923 Format now actually works
	SIP: a bit faster, and smaller salt. Preload CTX
	SIP: wrong buffer size used
	listconf: format-tests. If nothing can be output, then do not output
	loader: incresed number of parms being loaded from file, for scrypt
	scrypt: ScryptKDF.pm data was NOT loadable from a file. #938
	scrypt: fixed 938
	scrypt: changed ScryptKDF signature to be a single field
	truecrypt: fixed unified format. Fix #941
	rsvp: fix #937 Caching had to be for each type
	rsvp: use array for new-keys, and made more extensible
	rsvp: depending upon clearkeys does not work for self test code
	pass_gen: added RSVP hash
	dyna_salt: Fix salt_smash_check. Fix #920
	Bugs in split and FMT_SPLIT_UNIFIES_CASE fixed
	self-test, always call clear_keys before adding new keys
	gost: needed split-unifies-case
	Added FMT_SPLIT_UNIFIES_CASE to these are formats with hex hashes
	places ishex() and other helper functions into common.[ch]
	moved include from .h to .c after 4770e4c
	blackberry-es10: added UC only validation of hash
	HDAA: added proper valid
	IKE: improved valid to only accept lc hex
	LUKS: improved valid to only accept lc hex
	PDF: improved valid to only handle lower case hex
	rawsha512_opencl: fixed split non-case issue
	base64_convert: added upcase/locase to length of hex. Reformatted .h
	  file
	removed execute bits
	HDAA: fixed dupe salt detect logic. fix #951
	HDAA: stop silly memory usage, and free things up, during salt()
	autoconf: added a couple echo statements for plug processing
	autoconf: added probe and check for perl before usage
	formats.c: salt dupe logic working for dyna_salts also
	kwallet: fixed salt dupe problem (#953)
	formats.c: some helpful commentted out code for tracking down salt
	  dupe problems
	base64: reduced memset overhead. Only clear bytes when needed
	dynamic_21: removed this format hash totally
	Build: hopeful fix for aes.a always built, #957
	pfx: added comment about salt
	build: fixed circular autoconfig-stamp-h problem, got auto-autoheader
	  working again
	dynamic: disable a lot of dynamic hashes
	formats: allow OMP_SCALE modification at runtime, in john.conf
	OMP_auto_scale: I had not left the multiplier at 1.0, my bad.
	blockchain: OMP_SCALE 2.3x increase on AMD, please check on Intel
	crc32: OMP_SCALE 42% increase on AMD, please check on Intel
	crc32: scale not set on last commit
	EPI: added OMP, and OMP scaling
	Fortigate: better handling of OMP_SCALING
	gost: OMP_SCALE tuning
	dahua: OMP_SCALE tuning
	hmacSHA2: OMP scaling
	mongodb: OMP scaling
	mssql12: OMP scaling
	mysqlna: OMP scaling
	postgres: OMP scaling
	racf: OMP scaling
	sapB: OMP scaling
	ssh_ng: OMP scaling
	omp_scaling: added comments on a couple formats
	sapH: changed OMP scaling computation for later in SIMD
	oldoffice: OMP Scaling
	VMS: OMP scaling
	tcp_md5: OMP SCALING
	gost: OMP_SCALE, was wrong scale
	mss1l12: wrong OMP_SCALE used in ad8faae
	mysqlna: wrong OMPSCALE used in 2221cbb
	postgres: wrong OMPSCALE used in 3524196
	IPB2: changed how OMP_SCALE is built in init, and adjusted scale a bit
	EPI: forgot to add FMT_OMP to flags
	sapB: valid() fix #959
	sapG: valid() fix #960
	base64_convert: fix #968
	base64_convert: pure formatting difference, no code change
	mediawiki: fix #961
	added element to gitignore after fixing makefile
	formats.c: handle possible floating point rounding issue
	unicode: overflow, fix #963
	zip format: enhanced valid, fix #966
	7z: fixed valid() bug: fix #962
	base64_convert: handle to_len. Fix #965
	configure: plugin_deps.pl skip warning about autoconfig.h fix #970
	plugin_deps.pl: autoconfig.h was not output if not there. File needed
	  closed also
	base64_conv/lastpass_sniffed: last buffer overread problems fixed.
	  Fix #964
	base64_conv: finished up mods. Now all converts honor to_len
	encfs: fix bug #971
	HDAA: fix #972
	pkzip: fix #973
	pdf: fix #974
	office: valid fix #975
	KRB4: bug fix (realm buffer too small), and valid() fix #976
	pbkdf2-hmac-sha512: prepare bug: fix #977
	KRB4: removed a warning
	pbkdf2-hmac-sha512: fix #977
	office and opencl: created a office_common set of functions
	office-common: removed execute bit
	office-common: comment and eol at end of file. NO code change
	encfs and opencl: created an encfs_common set of functions
	md5ns: Converted to thin dynamic format. OMP/SIMD benfits
	md5ns: warning of unused variable
	cryptmd5: created an cryptmd5_common set of functions. Added {smd5} to
	  GPU, but not working
	luks: Here is a version that is twice as fast, and does not have ASAN
	  errors
	LUKS: added SIMD code
	md5ns: changed so that native hashes get written to .pot file
	md5ns: improved ALGORITHM text
	bcrypt / opencl: created a BF_common set of functions / data
	dragonfly: OMP_SCALE adjustments
	sha1crypt / opencl: added sha1crypt_common functions and data
	dyna_salt memory leaks, reported on #980'
	memdbg: added 4 new information getters for memory blocks
	dyna_salt: Updated. Changed dyna_salt_create to actually do something,
	  in memdbg mode
	cuda_cryptmd5: fix #984
	dyna_salt: removed redundant code
	pass_gen.pl added dyna types: 1013 1016 1400 1401 1501 1502 1503 1504
	dynamic: larger hashes. Fixed max PLAINTEXT length, as found by test
	  suite
	dynamic_2010/2011: fix #987
	dynamic flat hashes. Same issue as fixed in 3494a53
	cryptsha512: was not cleaning its salt buffer
	dynamic: flat SIMD buffer cleaning bug fixed
	ssh-ng: add #debug compile switch to new type2 bcrypt hash. Fixes
	  -test time to execute
	zip: retuned OMP_SCALE, and -test wallclock is much better, and c/s
	  are same
	rawsha256-cuda needed a wrap
	cryptsha256: added tests into common code. Fixed a couple of failure
	  to zero out salt issues
	pass_gen: a couple fixes after last change adding all the dyna, to get
	  -tstall to work properly again
	cp737 encoding fix for greek lower final epsilon. Fix #993 fix #994
	cp737 lower. There is a LOW_ONLY field. That is what should have been
	  used, and now is
	additional fix needed after d33e727
	rar: propre fix for #1000 and #1001 ASAN read issues
	rar: removed debugging line
	removed comments no longer required, and set allocation back to what
	  it was
	autoconf: check buildability of asan. fix #1006
	list=build-info: output memdbg, DEBUG and ASAN status
	rawmd5u: fixed overflow bug, found by ASan
	small edits listing user number on hash
	mscash1: changed to allow standard OMP_SCALE adjustments
	mscash2: changed to allow OMP_SCALE, improved performace a bit
	pass_gen: allow unicode input and base64 output, by splitting out
	  unicode input as a new function
	dynamic: better base64 handling. Added peoplesoft hash
	pass_gen: added dyna_1032, peoplesoft hash
	dynamic: fix to get phpass working. It uses CryptBS layout
	mediawiki: thin dynamic, now store hashes in the native format into
	  the .pot file
	phpass: changed thin format to store native hash in .pot file
	mediawiki: small clean up after .pot output format change
	phpass: cut/paste coding bug
	PHPS: thin format now outputs raw original hashes
	base64_conv: problems handing NULL data, for crypt conversions
	rar: ASan bug, #1010
	wordlist: unfreed memory block in -pipe mode
	bench_cost: got dyna_salt remove working properly
	dynamic: now fully handles base-64 of MIME, Crypt and CryptBS types.
	  Fix #1007
	dyna_1033: changed expression shown on screen output
	dynamic_1033: hide this format. It is only a fake testing format
	dynamic documentation: #874. There may still updates to be made
	IKE: fixed salt-dupe failure problem, #953
	SSH: added dynamic salt. Removed salt-dupe problems. #953
	PFX: dyna_salt. removed salt-dupe problem. #953
	dyna_salt.h: needed a #define wrapper
	pkzip: converted to dyna_salt. Removes dupe-salt problem. #953
	pkzip.h: had some code left for an earlier tried method, that was not
	  needed
	relbench: [handle the new speed for cost] message ignored. Fix #1013
	PRINCE: make sure to disable in john.c if no GMP
	ecryptfs: error, valid not getting only the $1$ signature
	ecryptfs: completed fix #1017
	dyna_salt warning correction. Fix #1021
	removed DOS line endings
	prince: removed warning, AND better handle this in non-memdbg and
	  memdbg modes
	pass_gen: added 2 new pbkdf2-sha1, fixed line wrap problem in base64
	  code
	pass_gen: changes for rsvp processing
	pass_gen: added aix-smd5, and some -mode=xx to allow certain formats
	  to share salts
	wowsrp: This format was broken. It only handled even 64 byte binary,
	  but for modular math, this will NOT be the case
	pass_gen: added sha1crypt, tiger, whirlpool. Modified pp_pbkdf2 to
	  also do pbkdf1
	pass_gen.pl: pbkdf1 caused bug in pbkdf2. Fixed
	chap: enhanced valid
	pass_gen.pl: added, hsrp known-hosts chap and dynamic_1010
	wowsrp: small changes. There should have been cases still not
	  correctly finding values, even though they did not show in the TS.
	  Lack of memset for nonGMP, the todo length was wrong on GMP, and
	  likely would have caused ASan overread errors.
	pass_gen.pl: added blackberry-es10, citrix-ns10 and clipperz-srp
	  hashes
	clipperz: Fixed this SRP format. Fix #1028
	wowsrp and clipperz: added split and proper canonization code. Fix
	  #1027
	dahua: it is a raw format, but we were treating it salted in tests
	added dahua. Some cleanup on clipperz-srp
	pass_gen.pl: added fortigate, lp and lastpass
	lastpass_sniffed: salt-dupe code was broken. #1031
	lastpass_sniffed: Wrong (WIP) code left in non SIMD section
	scrypt: salt-dupe problems. #1031
	truecrypt: #1031. Only a comment, since this format does not have
	  duplicate salts.
	Added hashes for: rawmd2, mdc2, mongodb, mysqlna, o5logon, postgres.
	  Added get_username() but not heavily used yet
	pass_gen.pl: added pst format
	pass_gen.pl: added raw-blake2
	luks: fixed dupe salt problem (dyna salt). #953
	added keccak (512-256), siemens_s7, skein (256-512, BUT they are not
	  compatible), ssha512 and tcp-md5
	prince: portability stuff
	pass_gen.pl: fixed small bug found in dupe-salt script running
	mozilla: fixed dupe salt problem. #1031
	pass_gen.pl: some changes needed help in the salt-dupe finding project
	SKEY: fixed salt dupe bug. #1031
	pass_gen.pl: added strip format
	pass_gen.pl: ns-md5 was nto working any more. Fixed
	wpapsk: salt dupe removal fix, remove binary from salt. #1031
	pass_gen.pl: code changes to allow some formats to use the same salt
	  values
	pass_gen.pl: added stub functions for ALL current JtR formats not yet
	  handled
	Salt Dupe removal code broke format due to salt hashing
	dynamic_fmt: big bug in NON SIMD builds. Found from warning messages
	  on a MIPS-64 build
	dynamic: changed location of min-plaintext-length
	sha1crypt_common.c: Error compiling on BE systems
	hmacSHA384/512: Fixed failure on 64 bit BE systems
	formats.c: added some additional debugging information when we have
	  hash/binary failures
	krb5-18: BE64 port, and some simplification
	dynamic_17: fixed be issue on mips64 build: #1032
	unicode.c: E_md4hash fixes on BE allowing unaligned access, mips64be
	EPI: fixed core on unaligned systems (salt hash accessed 4 byte align)
	md5ns: fixed core on unaligned systems
	truecrypt: fixed BE problems with this format
	cloudkeychain: BE failures fixed
	LUKS: BE fixes
	EFS: fixed BE problems
	added strrev function to configure and supporting code
	mpz_int128: removed recursion from in128tostr and about 4x faster
	PRINCE: problems when building using GMP
	configure: ARCH_ALLOWS_UNALIGNED moved to static headers. Fix #1034
	pass_gen: comments only
	scrypt: corrected pointer alias issues causing scrypt to fail on
	  MIPS64. #1032
	formats.c: Added some debugging code, to help in porting to BE, or
	  finding other errors
	pp.c: 32 bit issue, and GMP issue fixed
	removed spurious file. This header is in escrypt, and somehow an old
	  version was put into src root
	sybase-prob (feal8), fixed on 64 bit BE, #1032
	another spurious header from escrypt folder
	formats.c: inadvertant code removed in 131064f
	formats.c: re-enabled extra debugging for get_hash failures
	office_2007: salt dupe logic. We decrypt now, vs encrypt.
	pass_gen: phase1 of rewrite, to unify output. #1039
	Makefile.legacy: added a couple newer objects
	pass_gen.pl, updated to allow Lophtcrack type hashes to work with
	  unified output
	pass_gen.pl: added bitcoin
	dynamic: some length problems in the preloads. x86 shorter than SIMD
	Dynamic: changes made to thin formats. Set plaintext length(if thin
	  sets it to 0). Also, salt_compare function was missing
	mediawiki: upgraded thin format for better linkage to dynamic
	dynamic.conf: comment about dynamic_1033 missing
	pass_gen: dynamic_1033 was missing
	md5-NS: upgraded thin format for better linkage to dynamic
	formspring: upgraded thin format for better linkage to dynamic
	asaMD5: upgraded thin format for better linkage to dynamic. NOTE,
	  broke before. plain-len was set to 32, but max should be only 12
	osc: upgraded thin format for better linkage to dynamic.
	pass_gen.pl: dynamic_17 was totally busted, trying to set specific
	  salts
	phpass: upgraded thin format for better linkage to dynamic.
	pixMD5: upgraded thin format for better linkage to dynamic.
	pass_gen.pl: recent change, the unified output, broke PHPS
	PHPS: upgraded thin format for better linkage to dynamic.
	options/listconf: added asAN and unified version string. Fix #1005
	crypt-descrypt: for length-13, we never disable, since they are in ST
	  code
	added UID to crack outputs (optional). Issue #517
	wpapcap2john: placed bssid into uid field, we had the connecting mac
	  in that field before
	hmailserver: converted to dynamic_61 thin format. Now has OMP, and
	  SIMD usage
	sapG: improved OMP scaling (slight, only 10% or so improvement)
	XSHA512: improved OMP scaling
	logger: helps with -fork multi process screen overwrites. DOES NOT
	  fix, just makes better
	changed _asAN to _asan for JtR version string
	dynamic: FLAT and not-sse2safe salted formats extended length of salt
	  and passwords
	john.c: in cygwin, some aborts leave tty input in unstable state.
	  CYGWIN only
	cygwin: -fork updates. Also improved logger.c LOCK_DEBUG logging
	cygwin: removed prior jtr stty echo at exit.
	logger.c: added fcntl locking (ONLY for cygwin at this time), vs flock
	pp: mute some warnings
	dynamic_1505: was crashing on travis for clang builds
	dynamic_1505: input length fix, (again)
	dynamic_1505: converted to flat format only. Non flat could only have
	  11 byte password, with 12 byte salt. Just too small
	john_bashcompletion: Update to handle new usage screen that does not
	  list formats
	options: remove format list from normal usage string
	options: usage string slightly changed
	pass_gen: added agilekeychain
	pass_gen: agilekeychain code was not properly saved. a few changed
	pass_gen: added blockchain
	blockchain: improved detection and eliminated FMT_NOT_EXACT
	blockchain: first check was looking over too much data.
	blockchain: Now handles the V2 hashes. We may want to work more on
	  this, and use native mime hashes, etc
	blockchain-opencl: Added v2/iteration changes to opencl version
	cryptsha512: changed comment to match actual code
	cryptsha256: same comment problem as seen on cryptsha512
	cryptsha256: got SIMD code working
	memory: added dbg funtions for 8 byte SIMD not doing byte swapping,
	  i.e. SHA512, but flat buffer
	cryptsha256: some tweaks done when porting code to cryptsha512
	cryptsha512: added SIMD. Also moved test vectors to common code
	cryptsha512: bug in non-OMP builds
	cryptsha512: error, any 2 limb hash was broken. All passwords over 15
	  bytes were failing
	cryptsha256 and 512: fixed for 32 bit cygwin OMP builds (worked around
	  compiler bug)
	cryptsha: removed debugging code. These formats are working fine now
	cryptsha512: added more test vectors, and found bug for length 32 and
	  48 hashes
	hmac-SHA256/224: added SIMD
	hmacSHA256/224 some small fixes, found when porting SIMD to sha512
	  algorithms
	hmacSHA512: added SIMD
	hmac-sha512/384 would not compile in non-SIMD mode without this change
	hmac-SHA384: added SIMD. Some debug code still commented out, for now
	hmac-sha256/224, use PAD_SIZE for the prep_ipad. It is the correct
	  size
	hmacSHA512: removed some DOS line endings. Switched to using PAD_SIZE
	  for size of prep_[io]pad
	hmac-SHA2 stuff: Removed debugging commented out code. Changed
	  OMP_SCALE for sha512 formats, SIMD
	xsha512: added SIMD
	removed DOS line endings
	hmacSHA384: bug fix and a couple changes trying to find the OMP bug
	  #1063. Still a problem
	ssha512: added SIMD
	ssha512: error building/running NON SIMD
	hmac-md5: change to prior commit. #1067
	configure: removed memdbg-ex from configure. That mode was written as
	  a last resort, hail marry attempt to find memory bugs. It does not
	  work for all formats, and should not be used that way.
	XSHA512: inc needed added to pragma for non-SIMD. Not sure why it did
	  not complain on SIMD builds, but I added it there also
	XSHA512: fixed bug for passwords under 4 bytes, in SIMD code. Key was
	  not cleaned properly
	base64-conv: fix for input text length being more than actual
	  available input text. Fixes #1071. A new -l test added also
	base64-conv: some fixes for last commit
	base64-conv: some fixes for last commits
	base64-conv: switched from strlen to strnlen
	drupal7: Added SIMD logic
	drupal7: minor text editing
	office_2007: SIMD code added
	office-2007: removed the crypt buffer, was not really needed
	office-2007. Changed interface to non MMX function to simplify
	  crypt_all code. Same type logic will be used for 2010 and 2013
	office2010/2013 added SIMD. Debugging code still there, commented out
	office2010/2013 debugging stuff removed
	office simd formats. Some simplifications
	office: lengthened plaintext length and removed a couple of warnings
	office: added max length password test cases
	ecryptfs: added SIMD (debugging code still there, commented out)
	ecryptfs: cleaned up comments
	pwsafe: Added SIMD code. 4x improvement
	keyring: added SIMD instructions
	SAP-H: added SIMD logic
	sse-intrinsic: SHA formats, added SSEi_FLAT_RELOAD_SWAPLAST flag. Fix
	  #1082
	Sybase-ASE: added SIMD logic
	blackberry-es10: added SIMD instructions
	pass_gen.pl: added ability to do shorter salts for sha256crypt
	cryptsha256: handle shorter salts on SIMD code.
	pass_gen: special code got left in
	sha512crypt: added SIMD ability to handle shorter salts
	cryptsha2: added code to help easily build withing SIMD (for testing)
	net-[md5|sha1]: Salt align problems on clang. #1081
	cryptsha2: mute warnings. Fixes #1080
	sybase-ase: unify case, and improve valid. Fixes #1087
	dynamic: SHA384/SHA512 added SIMD instructions
	(magnum:) Re-applied Jim's "bcrypt / opencl: created a BF_common set
	  of functions / data" (but updated to current core). Original commit
	  8c0a72f.
	siemens-7 had 2 $ in the hash.
	siemens: only validate a 1. Since we now have split, a 0 should not
	  be valid any more
	dynamic: in a debug build, we do NOT disable any dyna format. #956
	dynamic: calls dynamic_FIX_SALT_TO_HEX if hash is dyna on --show=left
	  fixes #986
	MMX_COEF_SHA[256][512] changed to SIMD_COEF_[32][64]. Also changed
	  PARA for SHA2 functions
	cryptsha[256][512] a little cleanup of MMX name tags, also goes with
	  #1099
	dynamic:sha384. Some typo corrupton
	SIMD: #1099. Switched from (SIMD_COEF_32>>1) to SIMD_COEF32_BITS.
	  Added that define to x86-sse.h and x86-64.h
	SIMD: #1099. Changed define name of MMX_TYPE to SIMD_TYPE_STR
	after const added to count, gcc at times in the pragma omp
	blockchain: fixed promiscuous valid issue once we change to strtokm
	django_scrypt: issue seen when switching from strtok to strtokm
	SKEY: do not use strtokm at this time.
	gpg: change to work with strtokm, skipping over prepended delimiter
	kwallet: fix for promiscuous valid when switching to strtokm
	mozilla: fix to skip prepended delimiter, strtokm
	ssh-ng: fix to work properly with strtokm
	strip: Fix to work with strtokm
	memdbg: Try to maintain 16 byte alignments, since we are using allocs
	  now for crypt/input buffers
	dynamic: Regression problems (32 bit and memdbg) in dynamic after
	  3b6727f
	dragonfly: we missed a done
	dragonfly: we missed a done
	net-md5/sha1. Quasi thin format. We have to call dynamic.methods.done
	  by hand here, since we overloaded it
	memory.c: alignment versions of mem_alloc and mem_calloc
	dynamic: redone, to use the aligment versions in memory.c
	dynamic: redone, to use the aligment versions in memory.c, prior patch
	  was incomplete
	dynamic: redone, to use the aligment versions in memory.c, prior 2
	  patches were incomplete
	dynamic: redone, to use the aligment versions in memory.c, prior
	  patches were incomplete
	mssql12: buffer alignment with new mem_calloc for SIMD code
	many formats. Fixed 32 bit builds for SIMD after moving to calloc
	many formats. Fixed 32 bit builds for SIMD after moving to calloc
	many formats. Fixed 32 bit builds for SIMD after moving to calloc
	memdbg: got this working with new mem_aligned code. Also got VC ported
	  over
	memdbg issues and a memory leak found in VC port
	cygwin. Do not add _XOPEN_SOUR=600 define for _posix_memalign. It
	  causes tons of warnings, and cygwin works without it
	memdbg.h missing from these 2. Also a memory leak found and fixed once
	  memdbg was there, in office
	raw-sha512-ng: fixes crash in 32 bit builds, alignment
	VC port, without memdbg with new _malloc_aligned
	VC port, _malloc_aligned. Hopefully last fixes
	VC portability issue (_malloc_align)
	misc.[ch]: added new strtokm function, and a #define to switch all
	  strtok to use it
	Mute warnings about different parameter types in function declaration
	  vs definition
	memdbg: mute warning, size_t vs long param issue.
	VC compiling in jumbo.h
	plugin.c: added a comment about very suspect looking code
	config.c: switched to using strtokm
	markov: use strtokm and now start and end can be empty, with just the
	  : chars
	raw2dyna switched to using strtokm
	raw2dyna: revert strtokm change
	markov: level is now an optional param
	Some SHA512 formats were getting failures on VC debugging builds
	memory.c: bug in non-aligned arched for alter_endianity_w64.
	mask_ext: added missing memdbg.h include
	dynamic: binary align to 8 bytes
	cygwin build problem fixed. #1250
	dynamic: fix #1208 warning about pointer bool conversion.
	regen-lost-salts problem. Fix #1154
	dynamic format honors --disable-omp-for-fast-formats. Fix #1334
	dynamic disable OMP was not right. It always was disabling. Now it is
	  controlled by configure, and can be turned on
	-stress-test problems for thin dynamic formats. Fixes #1135
	required changed to get MSVC to build again with SIMD
	dynamic: work to get SIMD_PARA working for dyna with multiple hash
	  types, where the para do not match
	dynamic: fix problem where including dyna headers could turn off OMP
	  in john.c
	dynamic PARA problems fixed core crash for PARA=4 md4. #1127
	rar2john. Removed warnings seen on 32 bit builds
	dynamic. After 3e0b41d 32 bit builds where we had MD5 asm were failing
	  at link. #1334. NOTE, dyna 1401 and 1503 core and I do not know why,
	  yet
	MSVC issues with OpenMP build.
	dynamic: honor --disable-omp-for-fast was broken.
	dynamic: removed MD5_Go code. #1298
	changes needed to at least compile on my sparc
	pufferfish. jumbo.h required for VC to build (no snprintf)
	has-160: fixed BE failure
	dominosec8: ported to work for BE systems. #1345
	dominosec8: memdbg found a memory leak
	stribog: memory leak
	PO: removed MD5_go logic, replaced it with oSSL
	dynamic: Dos line endings
	md5_go: removed this module. Fixes #1347
	strcasestr: added to autoconf for systems without this function. Fix
	  1366
	small fixes to b383434
	has160: required memdbg.h being added
	many source files missing memdbg.h
	pomelo: after adding memdbg.h, the format was crashing in memdbg_on
	  builds
	memdbg: allow greater than 16 byte alignment. Fix 1200 Never align
	  better than requested Fix 1195
	aix_ssha: This would not build on non x86 systems
	memdbg: added memory.h include to the memdbg header
	memdbg: improved test code in john.c by adding the memdbg checks on
	  exit
	hmacSHA384: fixed core on non-aligned 32 bit systems
	XSHA512: would not build on non x86 systems
	memdbg: bug fixes in EXTRA checks, after recent changes
	XSHA512: fixed failures in non SSE builds
	dynamic: updated todo comments with items which have been completed
	memdbg: the dereference of uint32 data for fence post checking is no
	  longer done, so remove those unused defines
	sse-intrinsics: wrap the sha256 and sha512 in #define logic
	x86-64 non-SIMD build help. #1370
	x86-64 added -mno-mmx to the ignored list. #1370
	john.c: setvbuf portability issues. Likely there are other
	  portability issues using that function
	final status line in --wordlist mode did not contain percentage. Fix
	  #1372
	markov: fix core if force run where level is too small
	PHPS: address sanitizer found bug. This format requires 3 byte salt
	  (legacy code build). Fix #1261
	dynamic: removed some older todo comments. Allow better debugging
	  within VC
	dynamic_1506: remove the StartInX86Mode flag
	memdbg: mute warnings seen on 32 bit compilers from recent changes
	pseudo_intrinsics: pure SSE2 could not be built
	oracle12: Fixes to make work on BE system
	Some changes needed to get current MinGW64 to compile
	testparas.pl: perform the testing longer.
	testparas.pl: added seconds param, and extra information to final
	  table
	Mingw64: strip needs to use the proper cross compiler strip
	django-scrypt: if N too large, the kdf aborts, but we were not
	  trapping it. Fixes 1413. This probably should be in valid also
	pbkdf2-hmac-sha1: stack overflow possibile: Fix #1411 and #1412
	pbkdf2-hmac-md5: added proper valid() Fix #1388
	configure: removed warning messages about Expect not found
	scrypt lib code: validation checking. Fix #1385
	ssh: Improved valid, checking whether we can get the salt properly or
	  not
	vtp: buffer overwrite. Fix #1391
	vtp: domain_name length check in valid. Also, fixed overwrite problem
	  where we had an array of pointers, and not an array of chars.
	gpg: improvement to valid(). Fix #1417
	gpg: Handle a default algorithm. Fix #1418
	keepass: fixed valid(). Fix #1419
	luks: improved valid. Fix #1386
	base64_conv: handle binary or whole files with the utility. Fix #1423
	crc32c: changed test vector to be proper for ripper12345 starting
	  from ripper
	crc32: added crc32c to the format. Fix #1422
	crc32c: improved performance of non-SSE4.2 code. crc32, reduced
	  complexity of crc32c setup code
	base64_conv: mute warnings
	crc32: Unified all CRC32 / CRC-32C function into crc32.[ch]. This DOES
	  change the core files (crc32.[ch]), but was given the go ahead to do
	  this. Fix #1379
	pass_gen.pl: Fixed dynamic parsing that uses a negative salt length.
	  Added dynamic_1017
	pufferfish: added proper valid checks. Fix #1390
	oldoffice: Improved valid to fix ASAN found buffer read overflow. Fix
	  #1410
	office: improved valid. ASAN buffer read overflow. Fix #1409
	wbb3: Segment fault. Fix #1434
	opencl_pkbdf2_sha1: Same fix as done to core. Fix #1411 Fix #1412
	opencl_gpg: Same fix as done to core format. Fix #1417
	oldoffice-opencl: same fix as on core. Fix #1410
	Add support for more NTP hash types. Partly reverts 4556eb4
	django: buffer overflow. Fix #1408
	clipperz: buffer overflow. #1407
	MinGW64 warnings. MinGW64 can no longer handle %I64 modifier for long
	  long
	MinGW64. %I64 reverted.
	bitmap-perf-test: attempt to correct MinGW64 build on CirclCI
	MinGW64 warnings. and modification to all %ll* to LL* and %zu to Zu
	  within printfs. #1439
	opencl-rawmd4: fix warnings for sprintf parms #1441
	MinGW64 warnings muted. #1439
	--list=format-all-details, added more details to A $ format line
	MinGW install doc. Missing package
	Small debugging change to the build script to see Makefile
	CircleCI debug take 2
	CircleCI removed debugging for now
	pbkdf2-hmac-md5: attempt to quiet CircleCI until we figure out problem
	Missed another ctx reference
	MD[45].[ch]: make the structures appear closer in binary layout to
	  oSSL
	md4.c: fix is a global cut/replace screw up
	configure.ac: fixed oSSL search for cross compile
	CircleCI-MinGW.sh: no longer requires OPENSSL_LIBS after fixes to
	  configure
	dynamic-thin: Enhanced so a temp dyna script can be PART of the thin
	  format file
	dynamic_thin updates. A couple fixes and warning muting
	thin-dynamic: made changes to allow native test hashes in test script
	dynamic: added 2 new flags, for pre-compute in sha1/sha256
	dynamic.conf: added missing comments, and set coldfusion salt-len to
	  64
	pass_gen.pl: updated with 3 dynamic formats from dynamic.conf
	configure.ac: OpenSSL issues between no-pkg-config and cross compile,
	  etc. #1451
	NETLMv2: Buffer overflow. #1405 #1406
	django: fixed core dump. Fix #1397
	NETNTLM buffer overflow. Fix #1405 Fix #1406
	uint_xx cleanup: Fix #1457
	MIN/MAX code cleanup. Fix #1456
	SKEY: proper valid. Fix #1396
	salted_sha1: Improved valid. Fix #1395
	pomelo: improved valid() Fix #1389
	dynamic: #1453. Added all hash types to the crypt() and crypt()
	  optimizations
	dynamic: some optimization of types md5(md5(....)...))
	dynamic_1501 optimization
	dynamic: Added true dynamic expression building format
	updated copyright notifies in dynamic_compiler
	pfx: fixed memory leak
	pfx: fixed memory leak fully. Fix #1246
	dynamic_compiler. Remove the @ chars from expression. added memdbg.
	  Added a testing main() function
	gpg: mem leak. fixed #1245
	gpg: missed a big-num memory leak
	pass_gen.pl: updates to get_token function, to match what is being
	  done in the dynamic_compiler code
	hmacMD5: fixed core. Fix #1472
	dynamic_compiler. Some rename, and moved a function into
	  dynamic_compiler_plug.c. #1477
	renamed dynamic_compiler_plug.c to dynamic_compiler.c. Fix #1477
	dynamic_compiler: real working. Still much work to do, but many
	  hashes ARE fully working
	dynamic_compiler: error, md4/md5 salt-as-hash were getting 40 byte
	  length for the salt
	pbkdf2-hmac-sha1: buffer overflow in prepare. Fix #1478
	dynamic_compiler: Handles more expressions, still more work to do
	dynamic_compiler: added gost, ripemd, tiger and whirlpool types
	dynamic_compiler: had to add MGF_INPUT_xx_BYTE for hashes not 16 byte
	  long
	pass_gen: fixed a bug in gost processing for dynamics
	dynamic_compiler: added unicode. initial gost tables properly. logic
	  for salt length
	dynamic: unified $salt/$pass to be $s/$p
	dynamic_compiler: added todo list, changed salt logic. Some pure
	  whitespace editing
	pass_gen: removed all _64e hashes and replaced with _64c. _64c will
	  use crypt alphabet
	-list=build-info: lists SIMD information
	opencl and cuda wrapper defines not present
	load_one_format (john.c). Do not lower case format name IF it is a
	  dynamic= hash. They are case sensative
	pass_gen: fixed some errors in constant validation checking. Removed
	  all md5u() types. Now utf16() must be used instead. It gets same
	  results, but removes this ambiguity
	dynamic_compiler: many fixes and enhancements
	dyna_compiler: static added to many functions. Some md5u() stuff was
	  still left and removed
	dyna_compiler: removed or commented out unused or not yet used static
	  functions. Fixed a couple bugs in ripemd256
	dynamic: normalized unicode() -> utf16() for dynamic expression
	  strings
	dynamic: fixed wrong comments. Fixed bug in dyna_85. Fix #1488
	dyna-big-crypt: removed spurious comment (not implemented hash)
	dynamic_compiler: Starting work to hook in the compiled dyna back into
	  existing dyna hashes
	dyna-compiler. SALT_AS_HEX was not properly building test strings.
	  f6aef52
	dyna-comp: got the padding functions working properly
	dynamic: Fixed problem loading test strings (example was dyna-29) if
	  the array of test strings had any types not loaded, then all the
	  rest were not being used. Now we properly pack them into the array,
	  and use them
	dyna-comp: fixed 2nd-salt not working
	dynamic: bigcrypt-md4 was broken. Fixes #1479
	dynamic: got uc() and lc() working properly in both the format and
	  compiler
	dyna-preloads: incorrect comments fixed
	dyna-big-crypt: Fixed issues in many types. Wrong length for
	  md5-overwrite for outputs other than hex. Key clean problems
	  switching between BE/LE formats (or 32bit to 64 bit). Issues
	  mentioned in #1463 and #1491
	dyna-compiler. Fixed mem leaks and SHA512 was not working (mentioned
	  in #1463)
	dynamic-preloads: comments about flags used
	dynamic: Fixed big problem caused by new self-describing thin dynamic
	  which is a LATE loading format. They get loaded and initialized
	  AFTER john has called init(), and the working set of data for the
	  dyna format was mangled. This patch keeps it. Also, looking at
	  buffer over flows for dyna-39 Asan problems (#1489 #1490)
	dyna-compiler: we have only consts from 1 to 8, not 1 to 9 Always
	  output max key-length, so that we get 110 bytes. hexify constants
	  (convert : into \x3a)
	dyna-compiler. 2 script output issues. Buffer overflow on
	  convert_old_to_new. #1490
	ishex() and other hex stuff from common.c Changed to only work with
	  even number of characters. #1494
	ishex() additional fixes. #1494
	dynamic_big_crypt.c: this file has been REMOVED, and is now
	  autogenerated by ./configure. #1491
	dyna-big-crypt: some cosmetic changes to last checkin
	dynamic_big_crypt: Fixes build problems
	dyna-big-crypt: still build problems on clang and cirleci
	dyna-big-crypt: echo some debugging, to try to figure out why they can
	  not compile
	dyna-big-crypt: hopefully this will fix circleCI build. I really do
	  not know why it can not build/run dynamic_big_crypt_chopper.c file
	dyna-big-crypt: last change to try building early, was not building a
	  new dynamic_big_crypt.c at all
	dyna-big-crypt: changes to the .c and .sh to hopefully at least get
	  Travis functional again
	dynamic: added haval256_3 and haval128_4 hash types to dynamic
	dynamic: haval added to compiler, and some other bugs fixed
	dynamic: modifications to get dynamic-big-crypt.c building properly
	  even on cross compiled systems.
	PHPS2_fmt_plug.c: chmod to 640
	2 more source files with wrong mode (set to 640)
	dyna-compiler: Now ALL internal formats that can work with
	  dyna-compiler, DO properly work
	dynamic: LARGE change. Added all HAVAL hashes (15 varient) Converted
	  large hash type linkage code into #define macros (in all but 2 spots
	  in dynamic.h) Removed deprecated *_base16 flat hash functions
	dynamic: some more define macro repetative code reduction for large
	  hashes
	dynamic: haval fully integrated, and fully working. Found numerous
	  other areas where I could use macros to reduce source size using
	  macros.
	dynamic_big_crypt.c: produce this file in Makefile #1491. Still work
	  to do. The chopper file will be ported to Perl
	dyna-preloads.c quiet 2 unused var warnings. Added new format type:
	  -format=dynamic-all That type will test all dynamic, including any
	  disabled dynamic formats
	dynamic_big_crypt_chopper: ported to perl. Changed make process some
	dynamic-big-crypt-gen: changed how script is executed in makefile.
	  removed a comment left in from debugging development
	dynamic_big_crypt.c generation, changed commenting
	Dynamic: Added MD2, Panama and Skein hash algorithms
	dynacomptest target added (builds the thin test engine for dynamic
	  compiler this tool is a decent parser test engine, and I also use it
	  to create dynamic large hash test strings
	dynamic_compiler: added lc($p) and uc($p) syntax
	dynamic: added lc() and uc(). Better format label
	dyna_compiler format: label string had last byte missing
	dyna-compiler: space pad string pasting macros. Added lexical error
	  handling for mixing p, uc(p) and lc(p) (and u)
	Compile fix for nt2/rawmd4 for 1032054 for any non SIMD build
	dyna-compiler: Fixed upper case hex hashing in inner functions like
	  md5(MD5())'
	some plugged hash files unplugged. Fix #1525
	base64 length for valid usage. Returns -1*len if string not pure
	base64. last change had bug in the check for pure string logic
	dyna-compiler: added symple function exponentation such as
	  md5($s.$p)^4 which is md5(md5(md5(md5($s.$p))))
	silence a couple warnings
	dyna-compiler: set BENCHMARK_LENGTH properly
	dynamic_compiler_fmt: was not showing proper label if expression ended
	  with exponent
	pix/mdc2. Fixed benchmark length. Fix #1536
	fixed salted dyna hashes listing no salt len. Fix #1535
	dynamic salt length. Needed to be negative in this one
	configure: target for dynacomptest needed CPPFLAGS
	dynamic: bare hashes with but no additional salt work if user in
	  field 1
	sse-intrinsics: recent changes in 9783278 totally broke my VC builds
	md4.c: undid some changes in abe2cdb. #1526 references this also
	dynamic: fix salt crash problem. Fix #1545
	dyna-compiler: handle both and (and , , )
	pufferfish: fixed bug in valid. Fix #1546
	sapH: fixed bug where there were spaces in the hash. Fix #1547
	base64_convert: bug in new return -len for non pure strings. Fix #1551
	dynamic: salt buffer read of invalid data. Fix #1554
	wow-srp: handle odd length hex and better validation. Fix #1553
	openssl-enc: valid() problem. Fix #1550
	BE issues (missing johnswap.h) and problems building with HAVE_SHA256
	  false, but using oSSL
	Fixed crash on !ALLOW_UNALIGNED systems. Change required when dyna
	  flags went from 32 to 64 bit integers
	dynamic problems on BE due to recent optimizations
	dynamic a couple tweeks for big crypt building
	removed link for pwsafe2john from legacy makefile
	dynamic problems under BE systems with the set_input2_len32 function
	dynamic: had to add set length_32 with clearing back into the command
	  list, crashes on SSE 64 bit (but not on my AVX2 64 bit??)
	dynamic_compiler. magnum fixed $u handling on raw hashes. Fix #1541
	dyna-compiler: change prepare to always call expr_normalize
	dyna-compiler: rolled back 1c9f842
	dyna-compiler: corrected prepare always normalizes hash
	dyna-compiler: removed commentted out code
	dyna-compiler: prepare adds dyna= signature to all valid raw hashes
	dynamic: increased buffer count for MIC
	dynamic_types.h: auto scale size of arrays based upon with of
	  SIMD_COEF
	sha3: fixed Asan overflow in input string. Fix #1492. Whenever using
	  Keccak functions we need to round up to next even by 8 offset
	dyna-compiler: some salt_as_hash types were missed
	dynamic: big crypt 64 bit SIMD hashes had key cleaning problems. Fix
	  #1563
	pass-gen: dynamic expression was not handling upper case hashes
	  properly
	dynacomptest removed from default target. It still can be made, but
	  must be explictly requested. (request from @magnum)
	dyna-big-crypt: 64 bit SIMD cleaning for more cases
	Added -format=dynamic-all to tests for the CI builds
	dyna-compiler: Computing max length of input password was not taking
	  into account hash type, or length of sub hashes.
	dyna-compiler: improved test shell. fixed a couple bugs turned up by
	  the test shell
	dyna-compiler documentation. VERY thin, but it is a start
	wrong file attributes
	dynamic_big_crypt.c in unused was way out of date
	dyna-compiler: Track length of both input buffers independantly, to
	  compute max input length allowed. Also, distinguish between 64bit
	  SIMD, 32bit SIMD and non-SIMD in length computations, because they
	  each have a different max length allowed
	100% white space cleanup. no code change
	dyna-compiler: added a library of pre-built scripts. It is sparse ATM,
	  but I will be able to add formats which the compiler does not
	  optimize well
	dyna-compiler: added a ,nolib flag to the expression to force NOT
	  using the lib scripts
	dyna-comp: added debug dumping of scripts read in from the compiler
	  lib
	dyna-compiler-test.sh: switched to ksh. Ran on my cygwin before, but
	  when I tried on ubuntu, it was no go
	dyna-compiler: Added some hashes to the optimized lib. Fixed a couple
	  bugs
	dynamic: Added dup flags, Tiger and TIGER
	dyna-preloads: Removed some depricated flags
	dyna-parser: added TIGER flags, fixed bug in MD5 flags
	dyna-compiler: additional optimizations. Speed same or better for
	  almost all dyna types
	dynamic was not building properly unless building SIMD
	dyna-compiler: Had some bugs for RIPEMD128 and the HAVAL hashes in
	  picking right key-hex and salt-hex length
	dyna-compiler: pretty print the script in ,debug mode
	fixed trailing whitespace problems. #1567
	dyna-compiler: Fixed ASan error, when we walked backwards past our
	  buffer
	simd build problems under VC
	dyna-comp-test: changed from /bin/ksh to /bin/bash. Use local .pot
	  file so the logic will work properly
	dyna-compiler: added O=# flag to control optimization
	dynamic: renamed some flags. Fixed bug where pass to offset other than
	  32 was failing
	dynamic: added a specific comment at each point where we need to edit
	  the dynamic files when adding a new digest type into the code
	added a .editorconfig file (see editorconfig.org). This is just a
	  start. We may want to change this
	.editorconfig. LOL, Saved before I updated Notepad++ with the plugin
	  and had no trailing lf
	dyna-compiler: added first -O2 optimization (post script creation
	  pinhole optimizations) Currently only 1 optimization, but there will
	  be more (and the 1 is a pretty good one). Optimization is
	  MGF_KEYS_INPUT, and will only be done if the script allows it
	adjusted file attributes
	dyna-compiler: added O=3. This optimization level tries to build a
	  script in intermixed SIMD. It is not perfect yet, but does work
	dyna-comp-test.sh had rm commented out for some debugging
	dyna-compiler. Better mixed SIMD code. Parse more complex expressions
	  properly
	dyna-big-hash: added 4 temp vars. had to adjust simd code also. This
	  is early WIP code. Right now, there is no way to use these vars,
	  just write to them.
	crypt: failing to build right, and coring on legacy build. Fix #1471
	Removed all FMT_MAIN_VERSION defines. Fix #1185
	stray source got inserted in last update
	pkzip/zip: switched internal code to use strtokm and ishexlc. Cleaned
	  up a bunch of crap because of using unsigned chars all over the
	  place. Fix #1123
	more formats changing mem_calloc_tiny to calloc/free. #1110
	more formats changing mem_calloc_tiny to calloc/free. #1110
	more formats changing mem_calloc_tiny to calloc/free. Fix #1110
	64 bit raw sha formats were not aligned properly for 32 bit builds
	x86-sse.S: changes from last core merge which needed to be mirrored
	  in our jumbo specific code
	raw-sha384: fix buffer overwrite. Fix #1577
	depricate john.local.conf. added new include syntax and a new
	  john-local.conf file can be made, both in the $JOHN directory and in
	  the local directory. #1495
	.gitignore updated with john-local.conf found anywhere in the tree
	dynamic: MGF_SET_INP2LEN32 was not working since adding the @dynamic=
	  hash type. Fix #1579
	more work deprecating out john.local.conf file. #1495
	I had C on the mind, and used wrong include type for john.conf
	mssql05: buffer overflow (ASan error) found with jtrts
	putty: buffer overwrite. #1582
	files would not compile in non-SIMD builds
	bug in non-SIMD builds
	non-SIMD compile failure
	dyna-big-crypt: fix crypt_only code. Fix #1585
	trip: would not build in non-SIMD mode" ;
	removed last traces of kwallet2john.c
	dynamic was failing for any MD5_X2==1 build, i.e. many non-SIMD
	added non-SIMD build to Circle-CI. #1598
	added non-SIMD build to Circle-CI. #1598 (try 2)
	added non-SIMD build to Circle-CI. #1598 (try 3, likely to fail,
	  since sudo could not run)
	added non-SIMD build to Circle-CI. Fix #1598
	added non-SIMD build to Circle-CI.
	circle-CI. Added 32 bit-any and 32 bit-sse2 build/test
	CircleCI. I think the script was not properly exiting upon errors for
	  many cases
	configure: if fmt_externs.h or fmt_registers.h fail, then bail and
	  reset makefile back to the stub. #1590
	changed link for windows pre-build
	dynamic: problems building on non LE systems
	build on sparc failing. ar -s by itself was not valid. But -s can be
	  combined with other options (looking at gnu ar)
	dynamic: commented out a slow hack, as it appears to no longer be
	  needed
	make process had problems under Solaris
	mask.c: Added ?W which is ?w with case switched for all characters.
	  #1612
	mask: updated document to match new behavior
	mask: ETA was 1/x the correct time in -fork=x mode
	dynamic: base64 input was not properly validating in all cases. Fix
	  #1625
	dynamic: fix problem where salted dyna format requires saltlength to
	  be set by the designer of the script, but it is not set. Fixes #1611
	pass_gen: output error message if a NON supported or mistyped hash
	  name is tried. Fixes #1639
	pass_gen: if testing just 1 format, do not output the ^D message.
	config: Could not .include [section] which did not have a colon char,
	  such as [Options]
	HAVE_BIO_NEW: disable some items if that function is not available:
	  #616
	Fixed busted Makefile.in from last commit
	Makefile.in: extra space left when moving PROJ stuff out of main
	  asignment
	pseudo_intrinsic.h: failed to build with MSVC after 3884f8f
	recovery.c: created config var to protect restore files. Default is
	  off. Fix #1635
	external: The error file was using the global file name, not the file
	  name for the external object. Fix #1650
	dynamic_compiler: bug, first character of constants was not being
	  picked up
	dyna_compiler: fixed core if an empty constant value provided in the
	  expression
	dyna_compiler: Building test strings before validating the hash fits
	  in our SIMD buffers could cause a crash
	loader.c: ldr_in_pot var useful for more than just builds with
	  HAVE_CRYPT
	base64_convert.c: some stack overwrite conditions fixed
	has-160: rename the fmt_main structure so it is found after raw-sha1
	Merge of raw-sha1 and nsldap, and start of common raw-sha1 code for
	  GPU
	non-thin phpass-md5. This needs LOTS of work, but will compile/run
	phass-MD5 thick: Rewrote. Now with SIMD and OMP. #1672
	phpass: scrubbed thin format stuff. Will rename fat file when I know
	  things ae happy.
	phpass-MD5: made format label, and output string compatible with older
	  thin version
	dmg2john.c: Removed headers (ossl/evp and hmac, and gladman). These
	  were not needed, code not in this file
	cq: busted cmp_all
	added new file, just a header, to easily do hmac-sha1. For removing
	  gladman code. #1686
	hmac_sha1.h: added digest length, so that a shorter than 20 byte
	  buffer can be used
	all gladman code REMOVED. The only thing it was there for was
	  hmac-sha1. We now have that function of our own making. #1686
	Opps, missed this for gladman code removal. It was done just was not
	  in last git commit
	failures on travis? Does not have problems in cygwin, but hopefully
	  this fixes the problem
	hmac_sha1: new code was failing on 32 bit builds
	bitcoin: was not building on my sparc box
	luks2john: removed oSSL BIO_base64 junk. #1686
	Luk2john was not building correctly
	Legacy build: luks2john
	hmac_sha1: port for VC
	openbsd-softraid: removed evp_hmac_sha1, replaced with hmac_sha1
	changed name of hmac_sha1.[ch] to hmac_sha.[ch] to make it more
	  generic and so I can add more sha* hash types
	2 files missed in header name change
	fixed some warnings in certain builds. Also added wpapsk-opencl to
	  self_test_full_body function check
	hmac_sha: added sha256 and sha512 hmac
	encfs: removed oSSL hmac-sha1, replaced with JtR code. #1686 still
	  have AES to work on to complete
	rawSHA1-ng: added new common code, including {SHA} handling
	7z, recent changes needed fixed for VC to compile
	raw-sha1-linkedin: updated to use common interface and {SHA} signature
	  into .pot file. #1613
	formats: added some commented out code to help find out why a source
	  would be different
	salted-sha1: created common code for use in CPU/GPU code to keep
	  validation code the same
	attributes
	dmg: replaced oSSL hmac-sha1 with our own code
	.pot: allow multiple .pot files to remove already cracked items. Fix
	  #1623. Also document john-local.conf and removed references to
	  john.local.conf
	encfs_common: Obviously chainedIV is not being tested. We need to add
	  a test vector for that type
	encfs: right or wrong, this sets the logic back to original. The h[]
	  array is not preloaded in the ChainedIV now. Not sure if that is
	  right or wrong way
	new single mode rules found
	hmac_sha: if a system did not have SHA256/512 in openCL it would fail
	  to build
	single rules: improvements to the recent group of new rules
	luks: fixed non-inline processing. Was reading 0 bytes from file. Fix
	  #1696
	single: added configuration for guessed_keys->count extra work.
	  Default is to do this work (like core). but we can now override it.
	  #1706
	single: added logging of two configuration set items
	.pot extra load. Ported to mingw and msvc
	MSVC, .pot reload. Changed to a do{}while
	agilekeychain-opencl: added test vectors: #1637
	added test vectors to bbes10, luks and sha3-512. #1637
	pass_gen: simplified the large hash dynamic macros. Will be adding
	  more soon so wanted it simpler
	dynamic: added 4 SHA3 hashes and 2 Keccak hashes
	dynamic: Moved disabled dynamic formats over to their own conf file
	dyna_compiler: Bug in keccak-512 outer function
	pass_gen: added sha3 and keccak dynamic formats, and added these
	  hashes to the expression parser
	pass_gen: added MD2 to the dynamic hash types
	dynamic: lowercase for -list=subformats. #1717
	created error_msg() function. #1714
	fixed usage of pexit to error_msg. Fix #1714
	missed file in last commit (pexit to error_msg change)
	dyna-compiler: invalid parsing. using *_b64 in function search. Should
	  have been *_64
	dynamic: fixed issues found with fuzzer, base-64 encoding and re-crypt
	  problems
	pre-built dyna-big-crypt.c: base64-recrypt and keccak fixes
	dynamic: normalized case of all hash functions. Fix #1717
	pass-gen: normalized case of hash names of unused dynamic expression
	  hashes
	mem_align. Fixed globally, and no performance hit, Uses proper define
	  macro
	formspring: force valid to honor the 2 byte salt.
	several formats needed format flag bits set
	added FMT_SPLIT_UNIFY_CASE
	format.c. Calls to free() changed to MEM_FREE(). VC was crashing,
	  since all allocs are done using the _aligned_malloc, thus the native
	  free() can not be used
	formats: make fmt_case_unify tests happen against every test case
	removed deprecated code. This was only there for VC, and now we handle
	  this differently in memory.[ch] for VC
	PHPS/PHPS2: fixed to properly unify case in split
	formats.c: Added additional logic in the unify-case function which
	  will be required to properly handle compiled dynamics
	formats.c: eliminate false positive failure to unify case happening in
	  mysql
	dyna-compiler: for now, disable FMT_SPLIT_CASE. In the end, this
	  format may need to be setup to handle split_case, but until I figure
	  it out, this allows it to pass -test-full
	nuked clan (nk) input hash case bug (#1472)
	fixed split-case bugs. Some for #1742
	dynamic_big_crypt: better handle larger SIMD alignment issues
	fixed split-case bugs. Some for #1742
	split case bugs. #1742. added upcase hex to common
	revert 56d5b15
	common.c: Added some common defines for types. Added a length variant
	  to the ishex*() functions. Added u and l variants to hexlen
	IPB2, fixed bug. We can not treat itoa16 as a string. Fixes #1766
	Start using the common defines for HEXCHARS, base-64, etc in common.h
	dynamic: removed deprecated, unused internal function. Fix #1768
	recent calloc change (9e100b4) boned VC builds
	fixed new common hexlen function. DMD5 format, properly ignore case.
	  #1742
	dynamic: sph_ripemd spelling error
	krb: adjusted for case/split issues
	added a --show=invalid command. #1773
	some tweaks to --show=invalid and dox.
	dynamic_IS_VALID now preloads on first call. subsquent calls are
	  instantaneous
	dynamic loading. Improved the isValid function to FULLY cache, and
	  only do the real work 1 time
	enabled display of count of valid and invalid hashes for a
	  --show:invalid usage
	several formats: corrected many split/case issues. #1742
	numerous formats. Fix salt-case bugs. #1742
	rawsha512-ng. New problems on my VC builds. THis code moved into
	  psuedo-intrinsics, but was left in this file also.
	configure: changed != xno to = xyes for some display results (crypt,
	  mmap)
	many formats. Fixes for split-case bug. #1742
	many formats: fixed salt-case bug. #1742
	enhanced check for FMT_SPLIT_CASE problems. There still are formats
	  left to be found but this patch finds a large class that can be
	  found automatically
	split-case bug. Last push had issues in opencl-o5logon format
	simd-intrinsics: removed non-portable debugging crap
	fixed numerous compiler warnings from recent split-case improvments.
	  #1785
	memory leaks fixed in new -test-full code (dyna salts)
	mssql-* fixed split/case bugs. These changes must have been missed
	  with committing all the files last week
	split-case bugs: The last of the known bugs are fixed. Also 2 new
	  methods added for finding these, but they still need more work to
	  get right
	travis-CI and CircleCI. Changed from -test to -test-full. Not 100%
	  sure this was done right, we will see
	-test-full fixed memory leak in salt for a test
	some -test-full missed on circle. Add a john-local.conf to have no
	  formats disabled
	some changes in handling of Disabled:Formats, to make easier better CI
	  testing
	problems with travis.yml, not sure what the problem is, possibly echo
	  can not be used ???
	jumbo.h: we had a VERY busted header wrapper. OMG, failure to set
	  the define, lol. I think this was my F-up
	add jumbo magic define, so we KNOW when code is being built jumbo or
	  not. This allows better merging of john master code, whichc we do
	  not control
	merged -test and -test-full into 1 function. Removed flag for
	  -test-full. It was not needed. -test-full is now a required numeric
	  param that tells the level to test. formats.c reworked, to make a
	  simpler merge from master branch, and it documents differences
	  between master branch and bleeding. #1792 and #1795
	jumbo.h. Recent proper header wrapping was causing problems with VC
	  builds
	4th split-case bug test, full generic. But has some bugs and
	  whitelisting to do. Only runs at -test-full=1 level
	rar (fixed split-case bug). bcrypt, white-listed split-case check 4,
	  #1742
	EPI, chap, openssl-enc. split-case problems. #1742
	wbb3, putty, lotus5-opencl. split-case problems. #1742
	revert changes from 399217f
	last of the split-case bugs. Fix #1742
	split-case test-4 is now to be run at level 0
	fixes and code clean up for inline vs _inline for _MSC_VER builds
	formats.c: memory leak in -test-full mode, found with memdbg
	foramts.c: fixed asan read problem, and memory leak for -test-full
	  mode
	keystore. remove memdbg warning by switching to tiny_memory
	  allocation
	asn1 changed mode to 644
	pem: remove salt clean warning.
	asn1_plug: include required for VC build
	PEM: core crash found by fake CI on my sparc system
	rawSHA1. Fixed BE problems. #1861
	nt, raw-md5, raw-md4: Fixed BE problems. #1861
	nt: BE problem. #1861
	Keccak: BE problems: #1861
	dyna-big-crypt: put SIMD wrapper around a couple functions. #1874
	Azure AD added to pass_gen.pl
	AzureAD format added. (CPU only)
	AzureAD execute permissions
	Azure AD: removed FMT_OMP_BAD. this one is not bad
	luks: BE issue. #1861
	pass_gen.pl: start to normalize the -loops param
	rollback changes from da7d26a
	pass_gen.pl normalized adjustable loop counts for all formats, using
	  -loop= value
	pass_gen.pl: -loops= default for django was wrong. Changed it to 10k
	pass_gen. Help screen for dynamic was not always being displayed
	dyna-compiler. Auto-Escape constants with colon char in them
	dyna-compiler. Handle ) char in constant strings
	dyna-compiler. Allow @ char in constants
	bcrypt performancce improvement on AVX/AVX2 systems. Fix #1199
	john.c: correctly handle * char for dynamic= format: Code by
	  @magnumripper. #1747
	add config var to disable runtime-CPUID checks
	revert john.c changes to CPU_detect code location
	reverted other CPUID-ignore code. Left as commented out
	revert ignore-CPUID logic
	asa-md5: handle salts from 1 to 4 bytes, not fixed at only 4. Fix
	  #1887
	john.conf: removed left over traces of the IgnoreCPUID stuff
	dynamic-self describing documetation update
	hmac-SHA256: New larger salt logic was busted for salts of varied
	  sizes
	hmac-SHA256: changed the SIMD salt structure
	added onlyhex salt type for dynamic. This will use salt dictionary
	  with only low case hex
	dynamic_generic_expressions: Got working with re-gen salts logic.
	  #1463
	makefile.in: memdbg.o this one should not have been added
	hmac-SHA256: Added JWT hashes to format. #1904
	hmac-SHA256: a little more safety in the JWT convert logic.
	hmac-SHA256: still more validation checking in split.
	rawsha1-linkedin: binary function not declared static
	vdi added to pass_gen.pl (still have 128 bit to do)
	aes-xts: moved to its own file, to make it easier to use by multiple
	  formats
	wrong create bits
	VirtualBox .VDI encrypted disk format
	VDI: added aes-128-xts code and vectors
	VDI: compile problems on non SIMD systems.
	vdi2john: new conversion program for Virtualbox encrypted disks
	made AES-XTS into more generic function. Now there are params for
	  128/256 bit AES, and a param to do decryption vs encryption
	VDI: Ported properly to BE systems.
	base64: hex2raw conversion was null terminating???. Caused buffer
	  overflows. Raw data should never had this done to it.
	verbose message removed \n char. Fixes #1958
	dynamic (many formats), fixed problems with OMP runs
	some porting issues for MSVC
	dynamic: Fixed threading problem.
	dyna: fixed other OMP failures
	revert a7af331
	fix build problem for CircleCI (mingw in general) after 0e235c7
	last patch would not compile. malloc vs mem_all0c_tiny use different
	  params :(
	jumbo.c: removed memory.o dependancies
	Many formats. Removed undefined shifting of signed ints. #1957
	postgres: failure to load with user names of variable lengths. Problem
	  found with Test Suite
	postgres. Longer user name added to self test vectors. Without the
	  salt cleaning, the ST will fail
	john.c: avoid loading test db in -skip-self-test mode. Fix #1967
	bt.c: switched setitimer to getitimer. Fix #1966
	pass_gen.pl. Added QNX hashes
	qnx: cpu, non-SIMD format. #1970
	change mode bits
	qnx: added fmt_split_case, founnd by the CI
	qnx: moved split to common code
	qnx: removed split, and valid() fail hashes with upper case
	qnx. Bug in valid, and added max length sha512 hash that works
	  currently
	sha512: added QNX hashing bug to generic sha512 source
	Fixed numerous warnings on my sparc system. Possible uninitialized,
	  missing headers, etc
	qnx: improved speed of sha512 (for 128%pwlen==0 passwords). Also fixed
	  memory leaks in get_salt/valid
	base64_convert: major overhaul. Now buffers adhere to max size
	  requirements, INCLUDING null padding. NO extra bytes needed
	opencl_rawmd5: ASAN overflow fix. Fixes #1979
	pass_gen.pl Added special code to get SHA512-qnx hashes to work. The
	  pod is in unused, and the code is currently commented out within
	  pass_gen.pl
	Found out a local perl mod does not need execute bit. Thought it did
	pass_gen.pl: fixed bug in get_salt() where a charset would not be used
	  unless there were 3 args. Changed qnx hashes to use get_salt with
	  hex-low
	.editorconfig ending \n missing from the new .pm file
	axcrypt: fixed asan overread bug. Fix #1987
	dynamic: added McAfee master unlock password
	dynanmic-expressions. Handle NULL bytes in constants. Fix #1985
	fuzz: cygwin port problems fixed
	fuzz: remove files upon successful fuzzing test. #1969
	bench: make -test=0 deterministic in the number of times things are
	  run
	bench: commented out debugging code was not right
	fuzz: rolled back file removal code. That change was likely very wrong
	  thing to do
	legacy generic build fixed for usage with new test_db logic
	config: emit warning when a List.*** section is replaced with another.
	  #1988
	bench.c: generic build. New ldr_* functions could not be static
	stribog: #warning is not portable
	config.c: warn for multiple List.* sections if -verb is > 3
	gost3411-2012-sse41.h: use a john header, so systems without
	  inttypes.h work
	stribog: warn for __GNUC__ and _MSC_VER
	hmac-sha384 and 512. Salt not aligned properly. Fix #2000
	dynamic-compiler.c: ASAN error. #2004
	dynamic-compiler.c: Possible buffer overflow cases. #2004
	qnx-sha512. avoid div by 0
	raw-sha1-axcrypt: handle raw 32 byte hex hashes
	gpu_sensors.h: made adjusments to compile under cygwin (win32)
	hmac-SHA*: Salt alignment was wrong
	formats: ST failures. provide additional help when -verb>3 is used
	  (failure hash, etc)
	formats: bugs in new printf strings for debugging
	QNX-sha512. Figured out some issues, and now all hashes should match
	  the buggy QNX implementation
	sha2, remove execute bit
	formats: better self test failure verbage under higher verbosity
	  settings
	pass_gen: added SXC hash creation
	raw-sha: common code was WAY too promiscuous in prepare/split
	  converting any 40 byte line into an SHA1 hash
	pass_gen.pl: added VNC protocol
	vnc: moved key loading into get_key. Use ECB instead of CBC mode.
	  About 20% improvement in speed
	vtp: improved multi-salt speed tremendously
	vtp: attempt to get OMP working on the CIs
	VTP: Fixed OMP bug also improved speed some by not double buffer
	  copying
	pass_gen: added VTP hash
	cloudkeychain. Fixed issues found with jtrts
	pass_gen: added cloudkeychain
	pbkdf2_hmac_sha256.h: muted compiler warning
	AzureAD: moved MD4 code into OMP section of format
	wowsrp: cache first SHA1 for multi-salts
	wowsrp: rolled back 3a94817. It was busted even though ST passed
	hsrp: doubled speed (or slightly better)
	racf: simplify encryption. Speeds it up a bit
	racf: improved multi-salt speeds by caching schedule setup. #2023
	SybaseASE: improved multi-salt speed about 3.5x. #2023
	wbb3: improved multi-salt speed some (about 20%)
	dynamic: large update. Added ability to crypt to an offset in the
	  buffer. Fixed several bugs
	mask: problems expanding ?d inside groups. #2029
	mask: replacement skipping in groups had to handle escaped [ and ]
	mask: handle non set custom placeholders
	mask: abort on undefined placeholders, and abort on empty groups.
	  #2034
	mask: proper abort logic
	unicode: expose utf8_to_utf16_be to the world
	keystore: cache password work. Setting up for SIMD conversion
	keystore: added SIMD logic
	keystore: fixed ASAN error, and hopefully ST failures on CIs
	keystore: fix for overwrite, hopefully fixes CIs
	keystore: disable SIMD until I can figure this out
	formats: change to sprintf did not match params. Warning came from
	  circle-CI build only?
	AxCrypt-Auditing-HOWTO.md: removed UC2 and DOS eol problems. Fix #2041
	configure: enable a couple of compiler warnings which were not being
	  enabled
	keystore: removed warning, changed cmp_all logic to do the real work
	  for SIMD runs
	remove clang warnings from john.c and cracker.c. Created new itoa
	  functions
	pass_gen: added keystore (not 100% sure it is correct, but I think so)
	hopefully fix errors on MinGW build for CircleCI
	krb5tgs: mute compiler warning
	pass_gen.pl: made a tweak on keystore, to make it mimic ITW hashes
	  better
	keystore: got SIMD code corrected. buffer overwrites
	keystore: hopefully working properly with PARA_SHA1 > 1
	keystore. adjusted copywrite
	ax-crypt: fixed ASAN overread. Fix #2042
	pass_gen.pl: still a nit in keystore
	editorconfig: set utf-8 to be default encoding for all edited files
	gitignore. Added *.tmp to files to be ignored
	keystore-opencl: Fixed bug for binary passwords. Improved performance
	  about 2.5x. Created common code to share with CPU version
	bug in bench.c. When testing multi-salts, the salts were NOT being
	  allocated with approved alignment
	bench.c: last checking had problems. Now simply using mem_alloc_tiny
	remove -x bit from file
	bench: reusing mem_alloc_aligned. Changed memory.c to handle
	  alignments < sizeof(void*)
	ssh: mem leak. #1247
	dyna_salt: The init function now returns the format that was linked
	  in, so we could undo if we need to
	ssh: removed problem with dyna_salt leaking. Changed loader.c to call
	  dyna_salt_init at an earlier time (prior to calling valid)
	memdbg.c: added code (commented out) in checkShapShot_possible_exit()
	  so that all memory in the list, even freed is shown
	zip: emit 1 time warning when older hash signature seen. Fix #2061
	logging: added optional date signature to start of log lines (default
	  is NO date signature)
	memdbg: would not build under Makefile.legacy
	logger: give option to log datestamp in UTC
	hmacMD5/SHA256. Found bug in computation of bit count. Still does not
	  fix all problems
	hmac-MD5/SHA256. Same bug as prior, but still does not fix things
	hmac-md5: Possibly fixed.
	hmac-SHA256: same corrects as provided by hmac-md5
	pass_gen: hmac-md5 and hmac-sha256 now generate random length < 184
	  byte salts
	hmac-md5 and sha256: normalized buffer defines based around PAD_SIZE
	  (and PAD_SIZE_W for when used as offset into ARCHWORD_32 arrays)
	pass_gen: made long salts for hmac-sha224, 384 and 512
	hmac_*: got long salts all working properly. Changed code so each
	  format is much more similar to all others. We may merge files at
	  some time
	hmac-SHA224/256: Merged into a single format file
	hmacsha224 file delete was missed
	hmac-SHA384/512: merged into a single file. Some small changes to
	  hmac-SHA256 also
	hmac-sha384: bug in non-SIMD logic.
	logger: place fork# after date. Also added date logging when using
	  --log-stderr command line switch
	memory.c: Failure allocating aligned 0 byte. Showed up on sparc
	old_office: fixed memory leaks
	pbkdf2_hmac_md5 and md4: These were not working on BE system. Now
	  they do
	removed BE swapping from pbkdf2 code. Greatly simplified BE stuff
	last BE change missed a few files
	dyna-compiler: fixed core when using constant data under certain
	  situations. Fix #2067
	zip: was not processing zip files with external linked files. Fixes
	  #2063
	opencl-zip: same bug as was in the CPU version
	XSHA512: stop strcpy of data past end of buffer. #2065
	memory.c: return null on 0 size, and added some asserts
	memory.c: cosmetic changes
	john.c: In cygwin, when using -fork, the tty is screwed upon exit (no
	  echo). This simply fixes it for cygwin builds
	cygwin: proper fix for screwed TTY after -fork mode run
	SHA512 formats (cpu/opencl/cuda). Use more of the common code in
	  rawSHA512_common_plug.c
	zip/openclzip: created common code for tests, valid and binary
	phpass. Made common code for CPU, Cuda and OpenCL. #978
	phpass: common code failed on non-SIMD systems
	pass_gen.pl: added pbkdf2-hmac-md[45] hashes
	pbkdf2-hmac-md4: common code for CPU and OpenCL. Fixed bug in opencl
	  and increased max salt length to 115 bytes for both CPU and GPU code
	exe bits set, and cleared
	opencl-pbkdf2-md4 kernel simplify code a bit
	pbkdf2-hmac-md5: common code for CPU and OpenCL. #978. Saltlength set
	  to 115 bytes
	pass_gen: increased max salt length possible for other pbkdf2-hmac
	  formats
	editorconfig: added .cl to normal handled text file group
	pbkdf2-hmac-md[45] opencl kernels. Reworked code to avoid 2nd limb
	  array. When adding long salt to sha1, I was not able to get it
	  working until I removed that 2nd array
	sha1-crypt: added 115 byte max salt logic
	pbkdf2-hmac-sha1: made common code for CPU/GPU. Extended salt length
	  to 115 bytes
	pass_gen: pbkdf2_hmac_sha256 was not putting out longer length salts
	  properly
	pbkdf2-hmac-sha256: created common code between CPU/GPU #978. Extended
	  salt max length to 115
	sha1crypt: reverted max salt length to 64 bytes. pbkdf1-hmac-sha1
	  still allows 115 byte salt, this format simply validates 64 byte max
	  salt length
	some tweaks missed on common code for pbkdf2-sha1 and sha256
	pbkdf2-sha512: common code added for CPU/GPU formats. #978
	mscash/mscash2. Common code changes, cuda/openCL/cpu. #978
	gpg: common code created for GPU/CPU formats. A LOT of common code.
	  Still probably more to do
	recent common code changes. Missed memdbg.h include in some files
	gpg: improved performance on multi-hash for sha1/ripemd160 by
	  properly aligning data in 64 byte blocks. There was about a 10-20%
	  improvment due to stopping of buffer copying. However, this change
	  does not appear on the -test=x line, since none of 2 test hashes use
	  multi-hash length. For sha256 and sha512, it should never end up in
	  multi-hash mode, unless larger keys are needed
	gpg/gpg-opencl. Improved sharing. Added all formats to openCL format
	  (reverting to CPU code). Other improvements and bug fixes
	SHA512 common code. Setting wrong alignment in binary. Only affected
	  32 bit builds
	gpg-opencl: issue warning when running and there are hashes which
	  would use CPU code. Added some comments
	opencl SHA1 CTX model. Code moved from gpg kernel code, into a header
	  file so it can be used by other kernels
	wrong exec bit set
	gpg-opencl. Kernel code now handles > 16 byte keys. Also updated CPU
	  code to better match GPU code for this function
	added a .git pre-commit hook file. Everyone could use this local hook,
	  but it has to be linked from JtR root to .git/hooks/pre-commit
	  before it will do anything
	pre-commit hook. Edit was missed
	pre-commit hook. Added additional txt file checks
	pre-commit. Was getting exit 1 on certain conditions
	cleaned up a couple of file problems, mode and DOS lines
	pbkdf2-hmac-sha2.h Missed adding git commit -m "pbkdf2-hmac-sha2.h
	  Missed adding defined(OPENCL_FORMAT) in the opencl-pbkdf2-common.c
	  file. This was triggering warning about static code not being used.
	  Fixes #2070
	pre-commit. Slight changes again.
	pass_gen. removed -vector option, added -outformat=s option. options
	  can be normal, raw, user, vector. Since we have a common output
	  function, this was easygit add ../../run/pass_gen.pl !
	pass_gen. updated usage screen (names now format to width of console).
	  If -vector mode, then there must be only ONE hash listed
	cuda builds: include johnswap.h. Fix #2076
	typo in cuda_cryptmd5_fmt_plug.c
	v1 changes for external-hybrid mode
	recovery. File locking problems in cygwin worked around. #2068
	external:hybrid documentation
	fixed problems in external_hybrid_example script
	external.c: fixed a bug in hybrid external mode. Now working
	some edits to doc
	external-hybrid. Changed some variables, and fixed bug in fix_state
	  for hybrid runs
	restore testing format added.
	restore-tester, got OMP working for OMP_NUM_THREADS > 8
	restore-tester format. A fake format that can be used to help fix
	  issues in restore, or pause, making sure john misses no candidates,
	  and does not rerun words
	hybrid-external. Handle bug found by magnum, where a filter failure
	  was also aborting the entire crack loop
	recovery. Hack fix for cygwin, now done for all runs-over-win32
	  systems
	external-hybrid. Got restore working 100% correctly
	external-hybrid. Added logic (I hope) for utf32 processing
	external-hybrid. Changes for utf32 were not right
	restore_tester format. Proper porting to VC. 20ms delay for each
	  candidate check
	restore_tester format. Proper porting to VC. 20ms delay for each
	  candidate check
	removed this file from the fork
	external-hybrid. Corrected a couple issues pointed out in #2027
	wordlist: Fixed restore problem if wordlist was fully preloaded in
	  memory. #2082
	wordlist: restore. Fixed issues between restoring mem_map and
	  non-mem_map builds. #2082
	unused/restore_tester format. Added multi-salt format
	salted hashes, proper restore for the salt, #2082
	Revert "salted hashes, proper restore for the salt, #2082"
	multi-salt save-restore logic. Code added to validate salts are
	  exactly the same upon recover as they were when the .rec file was
	  saved
	deterministic salt order within salt sorts
	dynamic salt sorting. Wrong logic before
	restore_tester format: added 3rd type, salted-hashed. Also casecmp in
	  valid, so that multiple hashes can have same salt
	salt-resume logic, using deterministic sort order salts and unique
	  hash salt detection
	dynamic md5 salt generation was using wrong data
	loader: removed comment about experimental sorting, since now we
	  always sort
	restore-tester format: moved to TestSuite project
	file added to gitignore, and .pre-commit.sh hook was incorrectly
	  flagging a deleted file as not having an EOF
	loader. Removed sort by salt count, so that salt sorting is
	  deterministic
	base64_convert. Problems in base64 to base64 convert if last block was
	  not full length. Fixes #2088
	pass_gen.pl: added racf
	rar5-opencl. Recent common code changes broke this format. #2093
	pbkdf2-hmac-sha1: small issues not properly common code converted.
	common-opencl: split() was not being called during auto-tune running.
	  Caused common code pbkdf2-sha1 to core
	memdbg: removed tiny logic from realloc. Removed some strange code
	  from header
	memdbg: reworked MEMDBG_realloc. Fixed #2062
	wpapsk: sort salts deterministically
	oldoffice: assure full salt is used in salt-sorting
	oldoffice: removed redundant calls to dyna_salt_init within
	  salt_compare
	korelogic.conf: updated Rules:ReplaceSpecial2Special go handle more
	  characters. Fixed some bugs. Then replaced entire rule list with 2
	  rules
	korelogic.conf: merged more, using the rules PP
	external: restore problems. #2099
	external-hybrid restore: The ext-v1 record did not have proper \n
	  ending the record
	recovery.c: changes writing .rec file for cygwin/mingw/msvc. May
	  relate to #1949
	recovery.c. Improper mingw define used
	common.h / common-opencl.h Moved the get_power_of_two macro into
	  common.h. Fix #2091
	command line rules. Fix #2105
	elite external-hybrid mode added to john.conf
	updated extern:leet script.
	external:case mangler (hybrid external) added to john.conf
	extern-leet: Removed some conversions which were pretty rare in real
	  world test cracking
	external-hybrid restore. Always chomp the line, not just on success
	external-hybrid resume was not right
	cracker.c: multi-salt restore records were often being written for
	  non-salted hashes
	rexgen: case alphabets. Renamed to cased, so it works, now that rexgen
	  has removed the case option internally
	single: fixed memory leak if externs are used
	regex: port issues for VC
	leet external-hybrid. Some additional max candidate checks
	john.conf: external-leet, more adjustment to total work
	dynamic: improved performance for single mode work. Does use more
	  memory, but its at least 2x faster.
	mask.c: vc and mingw can not handle %hhu
	Changes required to incorporate PasswordPro/HashCat rules
	rules: rules_count was not counting rules properly, nor doing dupe
	  removal in HC mode
	Rules Hashcat. Added documentation
	exe bit removal
	dynamic: allow valid() to not fail on salts with embedded null bytes
	  (which can not have the $HEX$ removed from the salt string)
	hash-cat-rules. Add some warnings about the git add
	  doc/RULES-HashCat HashCat ON logic
	symlink: remove warnings about undefined execv function
	new hashcat rules, changed HashCat into hashcat (text strings users
	  will see)
	external. Allow enumeration of external hybrid words
	config: recent change leaving trailing space on read lines impacted
	  parameters. They were not being found properly
	rules: Changed HashCat into hashcat.
	rules: hashcat logic. Proper handling of code in rules_reject. Only
	  skips the - reject code, and does all other
	Rules: Added ONM which omits a range of characters
	rules: added eC and e?C which are extended title case rule
	make debug was failing to link (missing assert)
	rule x rule stacking (perl script). Also john config processing in
	  perl module. #2122
	jtrconf.pm: removed experimental warning, by dereferencing the arrays
	jtr_rulez.pm: Moved this common module here, was in test. I plan on
	  using this for other john utils, so wanted it in a general location
	jtrconf.pm: needed hard copy, or we were pulling back the reference
	  later
	perl config code, better default basepath
	rulestack perl script. Improves finding the other modules
	RULES-hashcat. pure white space change
	sha2.h: updated for older oSSL, so that include of just sha2.h was
	  enough. gpg_common and other code just includes that header
	added HC p command. Added Onm command Fixed numerous bugs in new HC
	  type rules. Fixed E and added 'e' command. Handle spaces properly
	  interspersed in rules as valid character data.
	unicode.c Would not compile if UNICODE_NO_OPTIONS was used
	rules.c: removed undocumented McXyz handling in c and C rule
	  operations
	rules.c McXyy change for c was not correctly done
	config: in HC mode, we were NOT processing [ leading rules. We were
	  silently ignoring them but not using them
	dynamic big crypt: Wrong years in copywrite notice
	POC for generic code to handle VERY LARGE non-hash types
	keepass was crashing after we set LINE_BUFFER_SIZE to small value.
	  This is a hack fix, but gets things working for now
	super long hashes now truncated in the .pot file
	korelogic 1 line leet line had some issues
	gost: sse4.1. changed code so it builds in 32 bit mode with or
	  without -O2
	potcheck.pl. Right now, just a skeleton script. #2161
	potcheck.pl: -validate and -longline_fix should be working now
	loader: increased file line buffer, to handle max sized value, AND the
	  password
	potcheck.pl: line buffer should have been 1k, not 4. Also, lines are
	  trimmed to 256 bytes, not max size, BUT max size is used for
	  -validate switch
	potcheck.pl. Constant changes does at request of Magnum. This should
	  now be done for -long and -validate switches
	loader.c: revert commit 7856266
	base64 (and common) changed int into size_t where needed
	configure: added potcheck.pl logic to configure script. It will abort
	  if there are any LONG lines in ../run/john.pot
	base64_convert.[ch] More work on size_t. commmon.[ch] reverted
	base64: changed int into size_t
	fuzz.c: returned buffer size to 0x30000. Fix #2166
	fuzz.c: permissions
	rar2john. Fix for 31-32 bit size, and FIXME comment about getting 64
	  bit length buffers
	rar2john: Handle > 32 bit lengths. Fix #2170
	added .log message directive code into rules scripts. #2140
	common.ch: removed unused base64 functions. From comment in #2132
	added .log processing to prince and single modes
	radius2john better handling of very long salts
	radius2john.pl: long salt was WRONG dynamic type
	radius large salt documented
	base64_convert.c: pure white space changes.
	dynamic.conf: added mongodb, salted, MiTM
	pkcs12: added SIMD logic. #2176
	pfx: added SIMD sha256. improved validation. Added hmac-algo to
	  formats cost
	pfx-ng. Hopefully fixed problems with SIMD crashes for SHA256
	pfx-ng. disable SIMD for SHA256 until the problem is found
	palshop: improved performance
	pfx-ng: added SIMD for sha512 and corrected SIMD for sha256
	scam: added SIMD code. Fix #2186
	bks: non-simd was failing
	rar2john: size_t can not be used for 32 bit builds. Must be a 64 bit
	  value
	scram: adjusted header include order, so that we can turn off SIMD for
	  speed testing
	pkcs12: would not build properly on non-SIMD systems (sparc)
	XSHA512: was still returning binary align warning for sparc-32. Now
	  no warning returned
	rawSHA512_common: quiet silly compiler warning
	o5logon: fixed crash on requires alignment systems
	phpass: fixed core on requires align CPU
	pbkdf2-hmac-sha1. Fixed failure on BE systems
	gost.h: some builds were having macro redefine problems for
	  bswap_32/64 macros. Now gost.h uses johnswap.h macros instead of
	  trying to recreate them
	.pot hash trim. Added $ for any format with binary_size>0. #2188
	pfx_ng can ONLY handle 30 byte passwords, at this time
	pfxng. Some debugging code slipped in on last commit
	krb5tgs: fixed already cracked hash removal logic. Fix #2188
	hmac-sha: added hmac-sha224 and hmac-sha384 to the easy jtr interface
	pfx-ng: added non-simd sha224 and sha384
	pfx-ng: bumped PLAINTEXT_LENGTH to 48, which seems to be the max that
	  openssl can generate
	SSHA512: Fixed ASAN buffer overflow bug
	zipmonster format: added SIMD logic. Could still be improved some
	zipmonster: fixed crash in some SIMD builds
	radius changes in dynamic conf, due to very large salt changes
	zipmonster: 25% improvement in speed for SIMD code
	zipmonster: another 25% improvement in speed for SIMD code
	zipmonster: small improvements in ossl, a bit in SIMD, and removed
	  original commented out SIMD hex-upper code
	zipmonster: some changes when I was trying to track down the SIMD
	  core problem was left in. Now removed
	testing code was inadvertantly pushed
	chopped hash .pot support added to certain questionable formats. #2117
	.pot chopped file valid() processing moved into common code in
	  loader.c
	additional work normalizing FORMAT_TAG type defines
	Additional normalization of FORMAT_TAG defines. #2196
	Additional normalization of FORMAT_TAG defines. #2196
	Additional normalization of FORMAT_TAG defines. #2196
	Additional normalization of FORMAT_TAG defines. #2196
	Bugs in last normalization push. #2196
	Additional normalization of FORMAT_TAG defines. #2196
	Additional normalization of FORMAT_TAG defines. #2196 (all completed)
	loader.c: auto-pot chop logic. One condition was failing. Needed
	  shorter length
	regex 1.4 integration, and full restore logic
	rar2john: improved performance quite a bit for large rar files
	line endings
	common: change hexlen*() functions to all be size_t
	rpp: reset refs, so that rpp can be run more than 1 time (needed for
	  rulez-toolz projects
	improved XSHA512. Part of changes made tracking down core on sparc
	  systems
	cisco-asa: added a short salt
	wrong format tag length used
	atoll for systems without atoll. #2220
	Makefile.in: added jumbo.o to genmkvpwd for non-atoll systems. #2220
	pass_gen.pl: added zipmonster, asamd5, mongodb_scram, has160, fgt,
	  iwork, palshop, snefru hashes
	pass_gen: added mdc2, efs and keyring hashes
	memory.c: fixed crash in argon in memdbg mode. #2226
	argon: some changes to build properly on certain systems
	memdbg.h: fix build problems for mingw on circleCI
	loader changes needed for -show to work properly. chopped pot issues,
	  and chopped pot with BIN_HASH data also.
	mscash: wrong length used for signature check. #2225
	off by one error in strnzcpyn() found with jtrts.pl, when adding
	  palshop and eigrp hashes
	radmin: avoid buffer overread (asan) bug
	argon2: merged 2 formats into 1. Put tags on extern functions, and
	  made many others static. #2229
	argon2i: removed the older format file
	oracle-9i sniffed hash (new format)
	oracle9i. This one is actually CASE SENSITVEgit add
	  oracle9i_fmt_plug.c even though oracle is not. This is due to the
	  password being encrypted. I am not 100% sure it is case sensative,
	  OR if the encryption is alway the lc of the password. We need more
	  research on this onegit add oracle9i_fmt_plug.c
	oracle9i-sniffed. Used asan to find some bugs causing CIs to fail in
	  -test-full. Did not core on cygwin
	oracle9i: fixed bus error on Sparc. Hopefully this will fix clang
	  crash on TravisCI
	oracle9i: removed const from iv (causing core on clang build), and
	  simplified sha1 key building function
	oracle9i (o3logon). Added OMP, fixed overflow in prepare. Changed
	  format label to 03logon
	oracle format: Some straggler FORMAT_TAG normalization
	whirlpool. Fixed buffer write-overflow error in split. (found with
	  ASAN) #2237
	whirlpool. Improved valid, to keep certain non whirlpool hashes from
	  passing. #2237
	hexlen?() functions, added a return if the string was solid hex or
	  not, for validations
	oldoffice: remove warnings caused by hexlen change
	o3logon: change buffer size to right size, and added SHA1 to algorithm
	  name
	hexlen?() functions had off by 1 bug detecting extra bytes.
	pem: bug in valid, which recent changes to hexlen function made show
	  up
	pem: re-add proper validation
	validation enhanced on several formats (some cores and ASAN errors).
	  #2239
	validation enhanced salted-sha1. #2239
	validation overflows and cores. keepass and o3login. #2239
	formats.c --test-full=0 was too agressive on salt-unifies. It was
	  even calling the code for formats with salt being fmt_salt_default.
	  That is now fixed
	dynamic: added new dynamic string type: utf16-be with function
	  DynamicFunc__setmode_unicodeBE
	configure: fail-abort if --enable-foobar but foobar can not be
	  loaded/used/found. #2241
	salted-sha1 ASAN overflow. #2246
	winzip: better valid, and split to canonize the magic field
	salted_sha1: better validation, and fixed ASAN problems (salt buffer
	  overwrite)
	wbb3: fixed overflow error caused by sub par valid function
	wbb3: valid was not quite right. The salt is used as is, and not
	  converted back to raw from hex
	base64_convert.h: adjusted header comment about negative return, since
	  all returns are not size_t so the negative logic is no more
	salted-sha1: More work to fix overflows. #2246
	winzip: common split code for both opencl and CPU. #2245
	dynamic_1590 created. This added to handle IBM AS/400 salted sha1
	  hashes
	keepass: improved valid, to avoid buffer overwrite. #2249
	pass_gen.pl changed episerver to use ../run/pass_gen.pl[1] (the
	  unicode ready buffer). Added eigrp hash
	keepass: revert valid change, to get CIs working again
	keepass: removed non-inline file code within valid. It was causing
	  crash problems. #2249
	as400-ssha1 thin dynamic format
	as400-sha1: fixed compile warnings, and warning about not fully
	  cleaning the binary buffer
	local changes should not have been committed
	pass_gen.pl: commit 4223342 was incomplete and broke the usage page
	unrarcmd: we add num items, but were only clearing 1. If more than 1
	  item added, undefined data would be present
	pass_gen: Removed Basename lib requirement
	pass_gen.pl: Removed Term::ReadKey as a required module to print the
	  usage screen. If found it will be used, but the script does not carp
	  if the module is not found. #2251
	pass_gen: removed String::CRC32 and wrote my own pp crc32 function.
	  #2251
	fuzz: Some constants changed to sizeof. Output a completed after each
	  format test during --fuzz run
	o3logon: adjusted code to make --fuzz work with this format
	o3logon: reworked changes to valid for fuzzing, as per @magnumripper
	  suggestions
	o3logon: fixed bug in last commit
	mdc2 is not always available. It now has a 1 time check
	hdaa: patched to fix ASAN read error in new short format
	SRP formats had resource leaks for non GMP builds
	HDAA: better fix for memory overread ASAN for the new short hashes
	recent changes with work around for invalid UTF-8 during valid,
	  changed to not error(), but to print a warning and ignore the
	  hashes. error() call in valid is a bad-thing (tm) to do, especially
	  exiting when no format specified, when jtr is searching for proper
	  format to match the hash
	Corrected if condition boolean logic when fuzzing
	HDAA: added split to canonize the shorter hashes (trailing or no
	  trailing $ char
	wbb3: created a dynamic format compatible with wbb3. Can be much
	  faster. No OMP (usually), but good with fork
	dynamic: removed speed hit to several formats caused by changes needed
	  for dynamic_1592. Added a new flag and only dyna_1592 uses it at
	  this time, so it is the only format that takes the hit
	legacy generic build was not working
	prince: changes needed to match john.c, so that legacy builds work
	pass_gen: removed requirement of Digest::MD5. Handle interface change
	  introduced in v2.00 for Crypt::ECB. Fix #2266
	gpg2john: allow multi-part message blobs (i.e. large file support).
	  #2109 #2218
	gpg2john: each file processed gets its own large enough hash buffer
	  allocated. Prior code could crash on a multiple files run
	gpg: full large file support. #2109 #2218
	gpg: bugs found in -test-full=0 using ASAN
	pass_gen: added as400-ssha1 and dynamic_1590
	logger. Recent changes were not VC compatible
	dynamic.conf. A tweak to 1598 and comments.
	dynamic: work to improve utf8 handling
	logger: Still issues with VC
	gpg2john: buffer overflows fixed. gp fixed if bad file name given.
	  changed code so both -d and -S can be used on same run
	Handle almost all of GPG. Still missing twofish hash, but added:
	  SHA224/384 hashes, crypts: Camellia-128,192,256
	bench.c: message buffer not large enough. Bug when more gpg crypt
	  types added
	gpg: added twofish. Now gpg format (cpu) handles ALL types
	gpg: after testing all type and all max bit sizes, these sizes are
	  adequate for the big num variables to avoid overflow
	bench: better fix for cost message buffer overflows
	twofish: fixed new cfb mode to not output more bytes than requested
	gpg2john: better error handling. #2255
	gpg2john: fix hang problem in bz2 code. #2255
	gpg2john: added warn_exit calls when truncated compressed files are
	  seen
	misc.c: fixed a speelling error in comment (pure no code change)
	rules: now multiple rulesets can be specified on command line
	pbkdf2-hmac-sha1: fix ASAN buffer read overflow
	TravisCI: try to hook in libASAN into one of the build steps
	TravisCI: try to hook in libASAN into one of the build steps, take 2
	Travis. Trying to find the right package to install
	rpp.c: rule dupe removal code was broken for new multi rule list
	  handling
	as400-ssha, commenting the hash format properly
	o3logon: a couple functions needed static, and max buffer length was
	  too small
	New format: oracle 10g sniffed protocol
	oracle: added OMP support
	oracle: ASAN problem fixed. Needed buffer large enough for UTF-16
	  data
	o10glogon: adjustments to OMP_SCALE
	wpapcap2john: fixed ASAN (and crash) problem, and found memory leak
	zip: when there were multiple hits in the same SIMD block, later hits
	  would not get properly found. #2281
	dynamic_big_crypt: Was not using openSSL version of Whirlpool if it
	  was present
	leet: added compile time usage of openssl whirlpool if available. It
	  usually is faster than the SPH
	pass_gen: added leet hash
	leet: added additional test hashes
	leet: added SIMD code for the SHA512 part. About 1.3x faster
	leet: the non-SIMD had a syntax error in it.
	pass_gen: removed errant comma added to list of formats handled
	leet: trying to pacify the CI failure. I can not replicate the
	  problem, so sort of shooting in the dark
	leet: that was problem found in travis-ci. Fixed in a documented way
	  now
	ssha512: fixed ASAN bug in 32 bit linux builds
	#2363 sed s/ARCH_WORD_32/uint32_t/g In all source, other than core
	  john files
	Porting issues for VC
	salt resume bug fixed. New v2 salt record in .rec file stores KPC and
	  if this changes upon resume, it is handled properly Fixes #2817
	argon2: alignment problems, caused crashes on machines requiring
	  alignment
	enpass: Alighnment problems
	fvde. Alignment problems and failure on BE systems
	itunes-backup Alignment problems and failure on BE systems
	Fix leet format on BE systems
	BE buffer out of bounds warning when building BE systems
	sha2 generic. Fixed stict pointer warning when building on PPC64
	mscash1: memory access (crossing 16 bit and 32 bit pointer access) on
	  some BE systems was causing failures of 0 and 1 byte passwords.
	  Using proper union fixed problem
	formats.c: make the testing candidates stir the long candidates a bit
	  better. When getkey and setkey do not match, print out what was
	  returned
	raw-MD5: enhanced format so that SIMD works on a BE machine. #2888
	raw-MD4: enhanced format so that SIMD works on a BE machine. #2888
	raw-SHA1: enhanced format so that SIMD works on a BE machine. #2888
	  (small change for raw-md5)
	raw-SHA24/256: enhanced format so that SIMD works on a BE machine.
	  #2888
	raw-SHA384/512: enhanced format so that SIMD works on a BE machine.
	  #2888
	raw-MD4/5: enhanced format self tests to make sure all byte
	  boundaries are handled in key loading. #2888
	pbkdf2_hmac_sha1.h: ixed this core file to run properly on BE
	  machines. #2888 MANY formats will be fixed by this.
	raw-MD%u: fixed this format to run properly on BE SIMD machines.
